#include<stdio.h>
#include<string.h>
#include<fcntl.h>
#include<stdlib.h>
#include<sys/stat.h>
#include<sys/types.h>
#include<dirent.h>
#include<unistd.h>
#include"addisorec.h"
#include"addrec.h"
#include"wrctl.h"
#include"utils.h"
#include"ecma_167.h"
#include"osta_udf.h"

static char *lastNextBlock = NULL;
static uint32_t isoBlankBlock = 0;
static uint32_t isoDiscType = 0;
static char* tmpFileDirName = NULL;
static char* tmpIsoName = NULL;
int InitIsoFs(char *devname)
{//初始化光盘 已经确认是iso格式之后再来读取信息
    int ret = 0;
    ret = initUdfDev (devname);  //这个函数是打开光盘，并不是打开UDF光盘
    if (ret != 0)
        return ret;
	
	int i,initflag;
	if (lastNextBlock == NULL)
		lastNextBlock = calloc(30,1); // 4g = 7位数 够用了
	else
		memset(lastNextBlock,0,30);

    multiStart = (uint32_t*) malloc(getdiscinfo()->trk1_lastsession*sizeof(uint32_t));

	struct cdrom_trackinfo *tmpTrackInfo;
	tmpTrackInfo = (struct cdrom_trackinfo *) malloc(sizeof(struct cdrom_trackinfo));
	ret = getdiscinfo()->trk1_lastsession;
	logUdfInfo ("[InitIsoFs] getdiscinfo()->trk1_lastsession = %d \n",getdiscinfo()->trk1_lastsession);
	for (i = 0; i < getdiscinfo()->trk1_lastsession; i++)
	{
		if( read_trackinfo(getudfdevice(), tmpTrackInfo, i+1))
		{
			logUdfError ("[InitIsoFs] read_trackinfo failed");
		}
		multiStart[i] = tmpTrackInfo->trk_start;
		logUdfInfo ("[InitIsoFs] multiStart[ %d ] = %d,tmpTrackInfo->trk_size= %d \n",i,multiStart[i],tmpTrackInfo->trk_size);
	}
    isoBlankBlock = tmpTrackInfo->trk_size;
	isoDiscType = getdiscinfo()->disc_type;
	sprintf(lastNextBlock,"%u,%u",multiStart[getdiscinfo()->trk1_lastsession-2],multiStart[getdiscinfo()->trk1_lastsession-1]);

    if(tmpTrackInfo)
        free(tmpTrackInfo);
    tmpTrackInfo=NULL;	
    if(multiStart) 
        free(multiStart);
	multiStart = NULL;
    closeUdfDev();	//iso9660格式不需要保持光盘打开状态 用完就直接关闭即可
    
	logUdfInfo ("[InitIsoFs] isoDiscType=%d,lastNextBlock=%s,isoBlankBlock=%d.\n",isoDiscType,lastNextBlock,isoBlankBlock);


    return ret;
}
int InitIsoInfo(char *devinfo)
{
	char *isoLabel;
	char *findLabelSPos = NULL;
	char *findLabelEPos = NULL;
	isoLabel = GetIsoTrackLabel();
	findLabelSPos = strstr(devinfo,"Volume id: ");
	findLabelSPos = findLabelSPos + 11;
	findLabelEPos = strstr(devinfo,"Volume set id: ");
	findLabelEPos = findLabelEPos - 1;
	strncpy(isoLabel,findLabelSPos,
	((findLabelEPos-findLabelSPos)<LABELNAMEMAX)?(findLabelEPos-findLabelSPos):(LABELNAMEMAX-1));
	

	return 0;
}
int FinIsoFs()
{//结束初始化

	if (tmpFileDirName)
		free(tmpFileDirName);
	tmpFileDirName = NULL;
	if (tmpIsoName)
		memset(tmpIsoName,0,MAXIMAGENAME);
	
	DelFileDirList(&stPreFileList);
    return 0;
}

uint32_t GetIsoBlankBlock()
{ //剩余空间block
    return isoBlankBlock;
}

char * GetIsoDiscType()
{//光盘类型
	static char diTye[9][9]={"DVD-R","CD-R","BD","UNKNOWN"};
	if (isoDiscType >= 0 && isoDiscType <= 3)
		return diTye[isoDiscType];
	logUdfInfo ("[GetIsoDiscType] isoDiscType=%d",isoDiscType);
	return diTye[3];
}

char * GetIsoTrackLabel()
{
	static char * labelName = NULL;
	if (labelName == NULL)
		labelName = calloc(LABELNAMEMAX,1); // 长度257
	return labelName;
}
int MkFileDirCp(char *tmppath)
{	
	if (tmpFileDirName == NULL)
		tmpFileDirName = calloc(MAXIMAGENAME,1);
	else
		memset(tmpFileDirName,0,MAXIMAGENAME);
	strcpy(tmpFileDirName,tmppath);
	return 0;
}
int MkFileDirLn(char *tmppath)
{	//处理临时文件 把临时文件的软链接创建到临时文件夹里 然后用生成镜像工具全部生成
	//static char* tmpFileDirName = NULL;
	uint32_t cmdsize = 1000;
	char *mkdircmd;
	char *rmdircmd;
	if (tmpFileDirName == NULL)
		tmpFileDirName = calloc(MAXIMAGENAME,1);
	else
		memset(tmpFileDirName,0,MAXIMAGENAME);
	
	mkdircmd = calloc(cmdsize,1);
	rmdircmd = calloc(cmdsize,1);
	//组合创建临时文件夹的命令

	sprintf(tmpFileDirName,"%s/isodir%u",tmppath,getTimeuint()); //给临时文件夹起个名

	sprintf(rmdircmd,"rm -rf %s",tmpFileDirName); //删除一下可能存在的之前的临时文件夹
	system(rmdircmd);  //删除一下可能存在的之前的临时文件夹
	free(rmdircmd);

	sprintf(mkdircmd,"mkdir %s",tmpFileDirName);
	logUdfInfo("[MkFileDirLn] mkdircmd=%s\n",mkdircmd);
	system(mkdircmd);
	free(mkdircmd);
	//开始在临时文件夹中创建软链接 stPreFileList
	struct stprefiledir *currfd;
	char *mklncmd;
	char *filename;
	
	mklncmd = calloc(cmdsize,1);
	currfd = stPreFileList.fdStart;
	logUdfInfo("[MkFileDirLn] start ln !\n");
	while (currfd != NULL)
	{
		if (!currfd->isDir && currfd->isRecorded)
		{ //跳过已有文件
			currfd = currfd->next;
			continue;
		}
		memset(mklncmd,0,cmdsize);
		//把文件名找出来
		filename = strrchr(currfd->filePath, '/');
		if (filename != NULL)
			filename += 1;
		else
			filename = currfd->filePath;
		//假设topath都是./开头的  +2为了去掉./
		if (currfd->isDir)														//toPath+2变空导致前后俩斜杠
			sprintf(mklncmd,"mkdir %s/%s/%s",tmpFileDirName,currfd->toPath+2,filename); 
		else if (! currfd->isRecorded)													// 两个/也不会出问题
			sprintf(mklncmd,"ln %s %s/%s/%s -s",currfd->filePath,tmpFileDirName,currfd->toPath+2,filename);
		//如果路径中出现空格需要处理

		logUdfInfo("[MkFileDirLn] mklncmd=%s\n",mklncmd);
		system(mklncmd);
		currfd = currfd->next;
	}
	
	free(mklncmd);
	return 0;
}
int MkIsoImg(char *devname,char *tmppath,int appendflag,int rrflag,int jflag)
{	//static char* tmpIsoName = NULL;
	char *mkisocmd;
	char *rmisocmd;
	uint32_t cmdsize = 1000;
	//MkFileDirLn(tmppath);   //原本是用ln的方式处理待刻录文件 
	MkFileDirCp(tmppath);   //现在直接把输入文件夹当临时文件夹用

	rmisocmd = calloc(cmdsize,1);
	mkisocmd = calloc(cmdsize,1);
	//组合创建镜像的命令
	
	strcat(mkisocmd,"genisoimage -input-charset utf-8 -f ");
	//先处理label
	strcat(mkisocmd,"-V \"");
	if (strlen(GetIsoTrackLabel()) != 0)
	{
		strcat(mkisocmd,GetIsoTrackLabel());
	}
	else
	{
		char isoLabel[100]={'\0'};
		sprintf(isoLabel,"数据光盘%u",getTimeuint()); //给临时文件起个名
		strcat(mkisocmd,mkisocmd);
		strcpy(GetIsoTrackLabel(),isoLabel);
	}
	strcat(mkisocmd,"\" ");
	//处理RJ
	if (rrflag == 1)
		strcat(mkisocmd,"-R ");
	if (jflag == 1)
		strcat(mkisocmd,"-J ");
	if (appendflag == 1)
	{
		strcat(mkisocmd,"-M ");
		strcat(mkisocmd,devname);
		strcat(mkisocmd," -C ");
		strcat(mkisocmd,lastNextBlock);
		strcat(mkisocmd," ");
	}
	//给临时文件起个名

	memset(GetTmpIsoName(),0,MAXIMAGENAME);
	if (appendflag == 1)
		sprintf(tmpIsoName,"%s/isoadd%u.iso",tmppath,getTimeuint());
	else
		sprintf(tmpIsoName,"%s/isonew%u.iso",tmppath,getTimeuint());
	strcat(mkisocmd,"-o ");
	strcat(mkisocmd,tmpIsoName);
	//加入临时文件夹
	strcat(mkisocmd," ");
	strcat(mkisocmd,tmpFileDirName);
	logUdfInfo("[MkIsoImg] mkisocmd=%s\n",mkisocmd);	

	sprintf(rmisocmd,"rm -f %s ",tmpIsoName);  //删除一下可能存在的之前的文件
	system(rmisocmd); //删除一下可能存在的之前的文件
	
	system(mkisocmd); //创建iso文件
	//判断文件是否生成成功
	if (access(tmpIsoName,F_OK) != 0)
	{//文件不存在
		char *rpcstr ;
		rpcstr = strstr(mkisocmd," -R ");
		memset(rpcstr,' ',4);
		system(mkisocmd); //创建iso文件
		//判断文件是否生成成功
		if (access(tmpIsoName,F_OK) != 0)
		{//文件不存在
			char *rpcstr ;
			rpcstr = strstr(mkisocmd," -J ");
			memset(rpcstr,' ',4);
			system(mkisocmd); //创建iso文件
		}

	}

	//如果是新创建的临时文件夹要删除 相同的文件夹留给上层函数删除
	if (strcmp(tmpFileDirName,tmppath) != 0)
	{
		memset(rmisocmd,0,cmdsize);
		sprintf(rmisocmd,"rm -rf %s",tmpFileDirName); //删除一下临时文件夹
		logUdfInfo("[MkIsoImg] rmisocmd=%s\n",rmisocmd);
		system(rmisocmd);
	}

	free (rmisocmd);
	free (mkisocmd);

	return 0;
}

char *GetTmpIsoName()
{
	if (tmpIsoName == NULL)
		tmpIsoName = calloc(MAXIMAGENAME,1);
	
	return tmpIsoName;
}