#include<stdio.h>
#include<string.h>
#include<fcntl.h>
#include<stdlib.h>
#include<sys/stat.h>
#include<sys/types.h>
#include<dirent.h>
#include"addrec.h"
#include"wrctl.h"
#include"utils.h"
#include"ecma_167.h"
#include"osta_udf.h"

//在此文件实现暴露给外部的接口，参数和返回值尽量使用原生类型，减少依赖。
//正式编译接口时注释掉main函数
//旧：使用例子 ./addrec -R ../udfx/a1.udf 253700 ../udfx/a1x.udf 253700 40820736


#define FOUND_BEA01	1
#define FOUND_NSR02	1<<1
#define FOUND_TEA01	1<<2
#define FOUND_PVD	1<<8
#define FOUND_LVD	1<<9
#define FOUND_PD	1<<10
#define FOUND_USD	1<<11 
static uint32_t	found = 0;


static extent_ad	extentNextVolDescSeq;
static extent_ad	extentLogVolIntegritySeq;
static uint32_t	integrityDescBlocknumber;		/* where to write LVID when finished */
static extent_ad	extentLogVolIntegrityDesc;		/* (continuation) extent for current LVIDs */

static	extent_ad	extentMainVolDescSeq;
static	extent_ad	extentRsrvVolDescSeq;

static struct partitionDesc		*pd;			/* for the writable partition */

static struct logicalVolDesc		*lvd;
static struct unallocSpaceDesc		*usd;
static struct spaceBitmapDesc		*spaceMap;
static struct logicalVolIntegrityDesc	*lvid;
static struct fileSetDesc		*fsd;
static unsigned int			usedSparingEntries;
static struct sparingTable		*st;

static int	spaceMapDirty, usdDirty, sparingTableDirty;
static int	alreadyInit;
static char *addUdfFile = NULL;
static char *devicepath = NULL;
static unsigned int emptyBlockNum = 0;
static unsigned int emptyDiscBlockNum = 0;
static uint32_t udfDiscType;
static uint32_t devUdfVer;


int initUdfMod(char *devname)
{
	printf ("[initUdfMod] start\n");
	int ret = 0;
	int inMainSeq;
	uint32_t	i, len, blkno, lastblk, size, offset, currtrk_size;
	struct volStructDesc	*vsd;
	struct generic_desc 	*p;
	char	zeroes[5];
	struct sparablePartitionMap *spm;	
    long_ad			*fsdAd;
	short_ad			*adSpaceMap;

    struct partitionHeaderDesc	*phd;
    struct logicalVolHeaderDesc	*lvhd;
	if ((strcmp(devname,getDevicePath()) != 0) && (alreadyInit == 1) )
	{//换光驱了 但是要先清理上次的文件树
			alreadyInit = 0;
			logUdfInfo("[initUdfMod] change devname, run delStRootDirDescTree() finUdfMod() \n");
			delStRootDirDescTree(); //有文件树但是没有刻录
			finUdfMod();
	
	}
	else if ((strcmp(devname,getDevicePath()) == 0) && (alreadyInit == 1))
	{ //没换光驱 也有上次文件树 不需要重新读取了
		return 0;
	}
	else
	{}
	
	
	memset(zeroes, 0, 5);
	
	ret = initUdfDev(devname);
	if (ret == -1)
	{
		logUdfError ("[initUdfMod] initUdfDev(%s) error \n",devname);
		return ret;
	}
	logUdfInfo ("[initUdfMod] start2");

//处理multi session刻录导致的多区段

	multiStart = (uint32_t*) malloc(getdiscinfo()->trk1_lastsession*sizeof(uint32_t));

	struct cdrom_trackinfo *tmpTrackInfo;
	tmpTrackInfo = (struct cdrom_trackinfo *) malloc(sizeof(struct cdrom_trackinfo));
	
	logUdfInfo ("[initUdfMod] getdiscinfo()->trk1_lastsession = %d \n",getdiscinfo()->trk1_lastsession);
	for (i = 0; i < getdiscinfo()->trk1_lastsession; i++)
	{
		if( read_trackinfo(getudfdevice(), tmpTrackInfo, i+1))
		{
			logUdfError ("[initUdfMod] read_trackinfo failed");
		}
		if (currTrack == 0xFFFF)
		{
			if (i == getdiscinfo()->trk1_lastsession - 2)
			currtrk_size = tmpTrackInfo->trk_size;
		}
		else
		{
			if (i == currTrack)
			currtrk_size = tmpTrackInfo->trk_size;
		}

		multiStart[i] = tmpTrackInfo->trk_start;
		logUdfInfo ("[initUdfMod] multiStart[ %d ] = %d,trk_size=%u,nwa_v=%u \n",i,multiStart[i],tmpTrackInfo->trk_size,tmpTrackInfo->nwa_v);
	}
	if (getdiscinfo()->trk1_lastsession <= 1)
	{	
		logUdfInfo ("[initUdfMod] get new disc ");
		finUdfMod();
		return -1;
	}
	offset = multiStart[i-2];  //选择要读取的session  设置此位置0则可以持续读取session 0
	if (currTrack != 0xFFFF)
		offset = multiStart[currTrack];

	emptyDiscBlockNum = tmpTrackInfo->trk_size;
	emptyBlockNum = tmpTrackInfo->trk_size;
	free (tmpTrackInfo);
	udfDiscType = getdiscinfo()->disc_type;
//检查UDF格式的标志位	
	for( blkno = 16 + offset; blkno < 256 + offset; blkno++ ) 
	{
		vsd = readSingleBlock(blkno);
		
		if( vsd == NULL || memcmp(vsd->stdIdent, zeroes, 5) == 0 )
			break;

		if( strncmp((char *)vsd->stdIdent, "BEA01", VSD_STD_ID_LEN) == 0 ) {
			found |= FOUND_BEA01;
			logUdfInfo (" FOUND_BEA01");
			continue;
		}
		if( strncmp((char *)vsd->stdIdent, "NSR02", VSD_STD_ID_LEN) == 0 ) {
			found |= FOUND_NSR02;
			logUdfInfo (" FOUND_NSR02");
			continue;
		}
		if( strncmp((char *)vsd->stdIdent, "TEA01", 5) == 0 ) {
			found |= FOUND_TEA01;
			logUdfInfo (" FOUND_TEA01");
			continue;
		}
		
	}
	if (found == 0)
	{
		logUdfError("[initUdfMod] cant get FOUND_BEA01 FOUND_NSR02 FOUND_TEA01 on disc\n");
		return -1;
	}
	else
		logUdfInfo("\n");
//检查AVDP的内容		
	p = readSingleBlock(256 + offset);
	if( p == NULL || p->descTag.tagIdent != TAG_IDENT_AVDP )
		logUdfError("[initUdfMod] cant get AVDP at block 256 on CDR disc,p->descTag.tagIdent= %d \n",p->descTag.tagIdent);
	else
	    logUdfInfo("[initUdfMod] find AVDP at block 256 on CDR disc,p->descTag.tagIdent= %d \n",p->descTag.tagIdent);

// TODO 在N-1和N-256获取AVDP应该是多区段读取需要的功能
/*	p = readTaggedBlock(getlasttrackinfo()->trk_size - 1, ABSOLUTE);
	if( p == NULL || p->descTag.tagIdent != TAG_IDENT_AVDP )
		printf("[initUdfMod] cant get AVDP at N-1 on CDR disc\n");
	else
	    printf("[initUdfMod] find AVDP at N-1 on CDR disc\n");
	
	p = readTaggedBlock(getlasttrackinfo()->trk_size - 256, ABSOLUTE);
	if( p == NULL || p->descTag.tagIdent != TAG_IDENT_AVDP )
		printf("[initUdfMod] cant get AVDP at N-256 on CDR disc\n");
	else
	    printf("[initUdfMod] find AVDP at N-256 on CDR disc\n");
*/
//处理multi session刻录导致的多区段


// read Volume Descriptor Sequence 读取卷描述符序列
    extentMainVolDescSeq = ((struct anchorVolDescPtr*)p)->mainVolDescSeqExt;
    extentRsrvVolDescSeq = ((struct anchorVolDescPtr*)p)->reserveVolDescSeqExt;


    blkno = extentMainVolDescSeq.extLocation;
    len = extentMainVolDescSeq.extLength;
    inMainSeq = 1;
	if (blkno < offset)
	{
		logUdfInfo("[initUdfMod] extentMainVolDescSeq.extLocation point first session , add offset = %d \n",offset);
		blkno = blkno + offset;
	}
logUdfInfo("[initUdfMod] readTaggedBlock blkno= %d , len = %d ,\n",blkno,len);
    for( i = 0; i < len; blkno++, i += 2048 ) 
    {
		if( (p = readTaggedBlock(blkno, ABSOLUTE)) == NULL ) 
		{
			if( !inMainSeq ) 
			printf("[initUdfMod] Volume Descriptor Sequences read failure\n");
			blkno = extentRsrvVolDescSeq.extLocation - 1;
			len = extentRsrvVolDescSeq.extLength;
			inMainSeq = 0;
			i = (uint32_t) -2048;
			continue;
		}
	
		switch( p->descTag.tagIdent ) 
		{
		case TAG_IDENT_PVD:
			found |= FOUND_PVD;
			logUdfInfo("[initUdfMod] find TAG_IDENT_PVD\n");
			break;
		case TAG_IDENT_VDP:
			blkno = ((struct volDescPtr*)p)->nextVolDescSeqExt.extLocation - 1;
			len   = ((struct volDescPtr*)p)->nextVolDescSeqExt.extLength;
			i = (uint32_t) -2048;
			logUdfInfo("[initUdfMod] find TAG_IDENT_VDP\n");
			break;
		case TAG_IDENT_IUVD:
			break;
		case TAG_IDENT_PD:
			// must have one (re)writable partition 
			// may have at most one RDONLY partition 
			logUdfInfo("[initUdfMod] find TAG_IDENT_PD p->accessType = %d \n",((struct partitionDesc *)p)->accessType);
			switch( ((struct partitionDesc *)p)->accessType ) {
			case PD_ACCESS_TYPE_READ_ONLY:
//			break;
			case PD_ACCESS_TYPE_REWRITABLE:
			case PD_ACCESS_TYPE_WRITE_ONCE:
			case PD_ACCESS_TYPE_OVERWRITABLE:
			found |= FOUND_PD;
			if( !pd )
				pd  = (struct partitionDesc*) calloc(sizeof(struct partitionDesc), 1);
			logUdfInfo("[initUdfMod] TAG_IDENT_PD tmpDesc->volDescSeqNum = %d ,blkno = %d \n",p->volDescSeqNum,blkno);
			if( p->volDescSeqNum > pd->volDescSeqNum )
				memcpy(pd, p, 512);
			logUdfInfo("[initUdfMod] pd->partitionStartingLocation = %d \n",pd->partitionStartingLocation);	
			logUdfInfo("[initUdfMod] pd->partitionLength = %d \n",pd->partitionLength);
			setPartitionDesc(pd); //主要是给wrctl文件存一下分区起点

			break;
			default:
			printf("[initUdfMod] What to do with an accesstype %d partition?\n", 
				((struct partitionDesc*)p)->accessType);
			break;
			}
			break;
		case TAG_IDENT_LVD:
			found |= FOUND_LVD;
			logUdfInfo("[initUdfMod] find TAG_IDENT_LVD\n");
			if( !lvd )
			lvd  = (struct logicalVolDesc*) calloc(512, 1);
			logUdfInfo("[initUdfMod] TAG_IDENT_LVD tmpDesc->volDescSeqNum = %d ,blkno = %d \n",p->volDescSeqNum,blkno);
			if( p->volDescSeqNum > lvd->volDescSeqNum )
			memcpy(lvd, p, 512);
			break;
		case TAG_IDENT_USD:
			found |= FOUND_USD;
			logUdfInfo("[initUdfMod] find FOUND_USD\n");
			if( !usd )
			usd = (struct unallocSpaceDesc*) calloc(512, 1);
			logUdfInfo("[initUdfMod] TAG_IDENT_USD tmpDesc->volDescSeqNum = %d ,blkno = %d \n",p->volDescSeqNum,blkno);
			if( p->volDescSeqNum > usd->volDescSeqNum )
			memcpy(usd, p, 512);
			break;
		case TAG_IDENT_TD:
			i = len;
			break;
		default:
			logUdfInfo("[initUdfMod] Unexpected tag ID %04X  in Volume Descriptor Sequence block %d \n", p->descTag.tagIdent, blkno);
		}
    }
    if( (found & FOUND_USD) == 0 )
	{
		logUdfError("[initUdfMod] Did not find Unallocated Space Descriptor\n");
	}
		
//判断必要的descriptor
    if( (found & FOUND_LVD) == 0 )
	{
		logUdfError("[initUdfMod] No LVD found \n");
		if (pd != NULL)
			free(pd);
		pd = NULL;
		if (usd != NULL)
			free(usd);
		usd = NULL;
		return -1;
	}

    if( (found & FOUND_PD) == 0 )
	{
		if (lvd != NULL)
			free(lvd);
		lvd = NULL;
		if (usd != NULL)
			free(usd);
		usd = NULL;
		logUdfError("[initUdfMod] No PD found\n");
		return -1;
	}
	
    if( lvd->logicalBlockSize != 2048 )
	{
		logUdfError("[initUdfMod] Blocksize not 2048\n");
		return -1;
	}
	
//处理可能有的vat
	devUdfVer = pd->descTag.descVersion;
	if (pd->descTag.descVersion == 3)
	{//2是udf1.02版本 3是udf2.01版本
		if (readVATtable(offset + currtrk_size - 1) == 0)
		{
			struct virtualPartitionMap *vpm;
			sizeof(struct logicalVolDesc);
			vpm = lvd->partitionMaps + 6;
			virtualPartitionNum = vpm->volSeqNum;
			logUdfInfo("[initUdfMod] readVATtable virtualPartitionNum =%u \n",virtualPartitionNum);
		}
	}
	

//分区表鉴定
/*
    spm  = (struct sparablePartitionMap*)lvd->partitionMaps;
    for( i = 0; i < lvd->numPartitionMaps; i++ ) {
		logUdfInfo("[initUdfMod] spm->partitionMapType =%d \n",spm->partitionMapType);
		// 这个版本的udf此处永远是1 
	if( spm->partitionMapType == 2 ) {
		
	    if( strncmp((char *)spm->partIdent.ident, UDF_ID_SPARABLE, strlen(UDF_ID_SPARABLE)) == 0 ) {
		unsigned int	j;

		if( spm->sizeSparingTable > 2048 )
		    logUdfError("[initUdfMod] Cannot handle SparingTable > 2048 bytes");
		st = (struct sparingTable*)malloc(2048);
		p = readTaggedBlock(spm->locSparingTable[0], ABSOLUTE);
		memcpy(st, p, spm->sizeSparingTable);

		// if #1 fails, try #2; should pick copy with highest sequenceNum

		for( j = usedSparingEntries = 0; j < (spm->sizeSparingTable >> 3); j++ ) {
		     if( st->mapEntry[j].origLocation < 0xFFFFFFF0 )
			 usedSparingEntries++;
		}
	    } else if( strncmp((char *)spm->partIdent.ident, UDF_ID_VIRTUAL, strlen(UDF_ID_VIRTUAL)) == 0 )
		virtualPartitionNum = i;
	}
	spm = (struct sparablePartitionMap*)((char*)spm + spm->partitionMapLength);
    }
*/


  /* Read Fileset Descriptor Sequence */
    fsdAd = (long_ad*) lvd->logicalVolContentsUse;
	
	logUdfInfo("[initUdfMod] fsdAd->extLocation.logicalBlockNum = %d \n",fsdAd->extLocation.logicalBlockNum);
	logUdfInfo("[initUdfMod] fsdAd->extLength = %d \n",fsdAd->extLength);
	logUdfInfo("[initUdfMod] pd->partitionStartingLocation = %d \n",pd->partitionStartingLocation);
    for( i = 0; i < (fsdAd->extLength >> 11); i++ ) {

	blkno = fsdAd->extLocation.logicalBlockNum + i;
	logUdfInfo("[initUdfMod] File Set Descriptor blkno = %u \n",blkno);
	if( !(p = readTaggedBlock(blkno, fsdAd->extLocation.partitionReferenceNum)) ) 
	{
		return -1;
	}
	switch( p->descTag.tagIdent ) {
	case TAG_IDENT_TD:
	    i = fsdAd->extLength;
	    break;
	case TAG_IDENT_FSD:
	    if( fsd && (lvd->volDescSeqNum > p->volDescSeqNum) )
		break;
	    fsd = (struct fileSetDesc*)malloc(512);
	    memcpy(fsd, p, 512);
	    logUdfInfo("[initUdfMod] File Set Descriptor find at blkno = %d \n",blkno);
	    break;
	default:
	    logUdfInfo("[initUdfMod] Unxpected tag id %d, where File Set Desc(256) expected\n", p->descTag.tagIdent);
	}
    }

    if( !fsd )
	{
		free(lvd);
		lvd = NULL;
		logUdfError("[initUdfMod] No File Set Descriptor\n");
		return -1;
	}
		
	logUdfInfo("[initUdfMod] File Set Descriptor fsd->fileSetNum = %d ,fsd->fileSetDescNum = %d \n",fsd->fileSetNum,fsd->fileSetDescNum);

   /* load Spacemap extent */
    phd = (struct partitionHeaderDesc*)pd->partitionContentsUse;
    adSpaceMap = &phd->unallocSpaceBitmap;

    if( adSpaceMap->extLength != 0 ) {
	blkno = adSpaceMap->extPosition;
	len = adSpaceMap->extLength;
	spaceMap = (struct spaceBitmapDesc*) malloc((len + 2047) & ~2047);

	for( i = 0; i < len; i += 2048 ) {
	    p = readBlock(blkno, 0);
	    memcpy( (uint8_t*)spaceMap + i, (uint8_t*) p, 2048);
	    freeBlock(blkno++, 0);
	}

	if( spaceMap->descTag.tagIdent != TAG_IDENT_SBD )
	    logUdfError("[initUdfMod] SpaceBitmap not found\n");
    }
//处理光盘名称
	char *labelName;
	labelName = getTrackLabel();
	if (labelName != NULL)
	{
		if (decode_string(NULL, fsd->logicalVolIdent, labelName, sizeof(fsd->logicalVolIdent), LABELNAMEMAX) == (size_t)-1)
			labelName[0] = 0;

		logUdfInfo("[initUdfMod] You are going to update fileset '%s'\n ", labelName);
	}
    /* Read Logical Volume Integrity sequence */
    blkno = lvd->integritySeqExt.extLocation;
    lastblk = blkno + (lvd->integritySeqExt.extLength >> 11);
    extentLogVolIntegrityDesc = lvd->integritySeqExt;

    for(   ; blkno < lastblk; blkno++ ) {
	if( !(p = readTaggedBlock(blkno, ABSOLUTE))  ) 
	    logUdfError("[initUdfMod] Read failure in Integrity Sequence, blk %d\n", blkno);

	switch( p->descTag.tagIdent ) {
	case TAG_IDENT_TD:
	    blkno = lastblk;
	    break;
	case TAG_IDENT_LVID:
	    size = sizeof(struct logicalVolIntegrityDesc) + sizeof(struct logicalVolIntegrityDescImpUse)
		+ 2 * sizeof(uint32_t) * ((struct logicalVolIntegrityDesc*)p)->numOfPartitions;
	    if( !lvid )
		lvid = (struct logicalVolIntegrityDesc*) malloc(size);
	    integrityDescBlocknumber = blkno;
	    memcpy(lvid, p, size);

	    if( lvid->nextIntegrityExt.extLocation ) {
		extentLogVolIntegrityDesc = lvid->nextIntegrityExt;
		blkno = lvid->nextIntegrityExt.extLocation;
		lastblk = blkno + (lvid->nextIntegrityExt.extLength >> 11);
		blkno--;					/* incremented again in for statement */
	    }
	    break;
	default:
	    logUdfInfo("[initUdfMod] Unxpected tag %X in Integrity Sequence; blk %d\n", p->descTag.tagIdent, blkno);
	    blkno = lastblk;
	    break;
	}
    }

    if( !lvid || lvid->descTag.tagIdent != TAG_IDENT_LVID  )
	{
		logUdfError("[initUdfMod] No Logical Volume Integrity Descriptor\n");
		finUdfMod();
		if (lvd)
			free(lvd);
		lvd = NULL;
		if (usd)
			free(usd);
		usd = NULL;
		if (pd)
			free(pd);
		pd = NULL;
		return -1;
	}
		
	else
		logUdfInfo("[initUdfMod] Logical Volume Integrity Descriptor find blkno= %d \n",blkno);
	

    if( lvid->integrityType == LVID_INTEGRITY_TYPE_CLOSE )
	logUdfInfo("[initUdfMod] CDR volume has been closed\n");




	// rootdir readDirectory 处理
    curDir = rootDir = (Directory*)malloc(sizeof(Directory));
    memset(rootDir, 0, sizeof(Directory));
    rootDir->dataSize = 4096;
    rootDir->data = malloc(4096);
    rootDir->name = "";
    readDirectory( NULL, &fsd->rootDirectoryICB, "");
	

	
	addIsoBlocks = 20000 ;  //10000 = 20M TODO
	alreadyInit = 1;
	memset(getDevicePath(),0,MAXIMAGENAME);
	strcpy(getDevicePath(),devname);
	

	free(lvd);
	lvd = NULL;
	return 0;
}

uint32_t getUdfModInitVer()
{
	return devUdfVer;
}

int readVATtable(uint32_t blkno) {
    
    struct fileEntry *fe;
	uint64_t sizeVAT20 = 0;
    //blkno = getNWA();  //multiStart[getdiscinfo()->trk1_lastsession-1]
 	//prevVATlbn = blkno;
	struct virtualAllocationTable20 *vatb20;
    fe = (struct fileEntry*)readTaggedBlock(blkno, ABSOLUTE);

    if( fe->descTag.tagIdent != TAG_IDENT_FE ||  fe->icbTag.fileType != 248 )
	{ // TAG_IDENT_FE 和 248 是udf2.01文档Virtual Allocation Table structure规定的
		logUdfError("[readVATtable] blkno=%u,descTag.tagIdent=%u,icbTag.fileType=%u, VAT ICB not found\n",blkno,fe->descTag.tagIdent,fe->icbTag.fileType);
		return -1;
	}
	
	//把vat结构读取到vatb20中
	//CDRuniqueID  = fe->uniqueID;
    sizeVAT20 = ((fe->informationLength + 4095) & ~2047);
	vatb20 = calloc(sizeVAT20,1);
	// newVATindex = (fe->informationLength - 36) >> 2;
	// fe->informationLength - 36 可能是vat表格的长度 尚不清楚-36的意思
	if( sizeof(*fe) + fe->lengthExtendedAttr + fe->informationLength <= 2048 ) {
	memcpy(vatb20, fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr, fe->informationLength);
    } else {
	readExtents((char*)vatb20, 1, fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr);
    }
	//把vat表读取到变量vat中
	//长度需要计算
	uint64_t sizevat = 0;
	sizevat = fe->informationLength - sizeof(struct virtualAllocationTable20) - vatb20->lengthImpUse;
    vat = calloc(sizevat,1);
    memcpy(vat, vatb20->impUse + vatb20->lengthImpUse, sizevat);
	logUdfInfo("[readVATtable] sizevat=%u,memcpy vat end\n",sizevat);	
//	logUdfInfo("[readVATtable] vat[0]=%u,vat[1]=%u,vat[2]=%u\n",vat[0],vat[1],vat[2]);
 
	if (vatb20)
		free (vatb20);
	return 0;
}

int getAlreadyInit()
{
	return alreadyInit;
}

char * getDevicePath()
{
	if (devicepath == NULL)
		devicepath = calloc(MAXIMAGENAME,1);
	return devicepath;
}

char * getTrackLabel()
{
	static char * labelName = NULL;
	if (labelName == NULL)
		labelName = calloc(LABELNAMEMAX,1); // 长度257
	return labelName;
}

char * getLastTrackInfo(char * inputdev)
{
	static char *lastNextBlock = NULL;
	int i,initflag;
	if (lastNextBlock == NULL)
		lastNextBlock = calloc(20,1); // 4g = 7位数 够用了
	else
		memset(lastNextBlock,0,20);
	if (getAlreadyInit() != 1)
	{
		if (initUdfDev(inputdev) == -1)
		return NULL;
	}
	if (multiStart == NULL)	
		multiStart = (uint32_t*) malloc(getdiscinfo()->trk1_lastsession*sizeof(uint32_t));
	else
		return NULL;
		

	struct cdrom_trackinfo *tmpTrackInfo;
	tmpTrackInfo = (struct cdrom_trackinfo *) malloc(sizeof(struct cdrom_trackinfo));
	
	logUdfInfo ("[initUdfMod] getdiscinfo()->trk1_lastsession = %d \n",getdiscinfo()->trk1_lastsession);
	for (i = 0; i < getdiscinfo()->trk1_lastsession; i++)
	{
		if( read_trackinfo(getudfdevice(), tmpTrackInfo, i+1))
		{
			logUdfError ("[initUdfMod] read_trackinfo failed");
		}
		multiStart[i] = tmpTrackInfo->trk_start;
		logUdfInfo ("[initUdfMod] multiStart[ %d ] = %d,tmpTrackInfo->trk_size= %d \n",i,multiStart[i],tmpTrackInfo->trk_size);
	}
	sprintf(lastNextBlock,"%d,%d",multiStart[getdiscinfo()->trk1_lastsession-2],multiStart[getdiscinfo()->trk1_lastsession-1]);
	if (getAlreadyInit() != 1)
	{
		if(multiStart) 
			free(multiStart);
		if(tmpTrackInfo)
			free(tmpTrackInfo);
		tmpTrackInfo=NULL;			
		multiStart = NULL;
		closeUdfDev();
	}	
	logUdfInfo ("[initUdfMod] lastNextBlock = %s \n",lastNextBlock);
	return lastNextBlock;
}

int lsCDR()
{
	//应该会考虑用文件树stDIR取代 读取本设备的追刻有问题
//	lscCommand();
	return 0;
}

int finUdfMod()
{
	logUdfInfo("[finUdfMod] before close\n");
	alreadyInit = 0;
	//finish
	closeUdfDev();
	//init申请的空间在这里释放	
	if (usd != NULL)
		free(usd);
	usd = NULL;
	if (rootDir != NULL && rootDir->data != NULL)
	{
		free(rootDir->data);
		rootDir->data = NULL;
	}
	if (rootDir != NULL)
		free(rootDir);
	rootDir = NULL;
	curDir = NULL;
	if(vat != NULL) free(vat);
	vat = NULL;
	if(multiStart) free(multiStart);
	multiStart = NULL;
	
	logUdfInfo("[finUdfMod] after close\n");
	return 0;
}

int mkAddUdfFs(int startBlock, int endBlock, char *isoFileName, double vernum)
{
	int ret = 0;
	//sudo mkudffs -b 2048 --packetlen=16 --startblock=$nextsession -r 0x0102 -l "$label" /tmp/$imgudffile `expr $nextsession + $mkblocknum`
	char mkUdfFsCmd[512] = {'\0'};
	char delUdfFsCmd[256] = {'\0'};
	char startBlockStr[33] = {'\0'};
	char endBlockStr[33] = {'\0'};
	char *label;
//	label = "mydr";
	label = getTrackLabel();
	sprintf(startBlockStr, "%d", startBlock);
	sprintf(endBlockStr, "%d", endBlock);

	strcat(mkUdfFsCmd, "mkudffs -b 2048 --packetlen=16 --space=unalloctable --startblock="); // --space=unalloctable 换成spacemap 但是最终还是要删除 修改PD表删掉这些分区
	strcat(mkUdfFsCmd, startBlockStr);
	if (vernum == 102)
		strcat(mkUdfFsCmd, " -r 0x0102 -l \"");
	else
		strcat(mkUdfFsCmd, " -r 0x0201 -l \"");
	if (strcmp(label,"") == 0 || label[0] == ' ')
		strcat(mkUdfFsCmd, "mydr");
	else
		strcat(mkUdfFsCmd, label);
	strcat(mkUdfFsCmd, "\" ");
	strcat(mkUdfFsCmd, isoFileName);
	strcat(mkUdfFsCmd, " ");
	strcat(mkUdfFsCmd, endBlockStr);
	strcat(delUdfFsCmd, "rm -f ");
	strcat(delUdfFsCmd, isoFileName);
	logUdfInfo("[mkAddUdfFs] run %s \n",delUdfFsCmd);
	logUdfInfo("[mkAddUdfFs] run %s \n",mkUdfFsCmd);
	system(delUdfFsCmd);
	ret = system(mkUdfFsCmd);
	return ret;
}


char *getUDFImageName()
{
	if (addUdfFile == NULL)
		addUdfFile = calloc(MAXIMAGENAME,1);
	return addUdfFile;
}

int updateFileTree()
{
	updateStTree();	 //计算了镜像的大小
	return 0;
}

int makeTmpFile(char *imagepath,double vernum)
{
	memset(getUDFImageName(),0,MAXIMAGENAME);
	sprintf(getUDFImageName(),"%s/isoadd%u.udf",imagepath,getTimeuint());
	mkAddUdfFs(multiStart[getdiscinfo()->trk1_lastsession-1],multiStart[getdiscinfo()->trk1_lastsession-1] + addIsoBlocks,getUDFImageName(), vernum);
	return 0;
}

int updateISO()
{
	patchAddUdfFs(getUDFImageName()); // open 镜像
	writeFDTree2ISO();	// 使用了open镜像的fd
	delStRootDirDescTree();  // 使用了open镜像的fd fclose 镜像 
	return 0;
}

int ejectUdfDisc()
{
	if (alreadyInit == 0)
		return 0;
	else
	{
		logUdfInfo("[ejectUdfDisc] run delStRootDirDescTree() finUdfMod() \n");
		delStRootDirDescTree(); //有文件树但是没有刻录
		finUdfMod(); 
	}
	return 0;
}

int getAddBlocks()
{
	return addIsoBlocks;
}

int makeDir2ISO(char *dirname, char* topath)
{
	int ret = 0;
	if (strlen(dirname)==0 || strlen(topath)==0)
		return FILEPATHERROR;
	if (topath[0] != '.' || topath[1] != '/')
	{
		logUdfError("[makeDir2ISO] get todir %s error\n",topath);  //拷贝的目录必须从./开始
		return FILEPATHERROR;
	}
//	if (topath[strlen(topath)-1] == '/')
//		topath[strlen(topath)-1] = '\0';
	if (emptyBlockNum < 25000)
		return FILESIZEERROR;
	ret = makeDir2Tree( dirname, topath);
	if (ret == 0)
		emptyBlockNum++;
	return ret;
}

int delFile4Tree(char *filepath)
{
	struct stfiledir *currDir;
	if (strlen(filepath)==0)
		return -1;

	if (strlen(filepath) <= 2 || filepath[0] != '.' || filepath[1] != '/' || filepath[strlen(filepath)-1] == '/')
	{
		logUdfError("[delFile4Tree] get filepath %s error\n",filepath);  //删除的目录必须从./开始,不允许最后一位是/的情况
		return -1;
	}
	//先在树里找到这个节点拿掉 
	currDir = NULL;
	currDir = delNode4Tree(filepath);
	//用删除函数把这个节点删除掉
	currDir->rfd = NULL; // 避免删多了

	if (currDir != NULL)
	{
		reDirTree(currDir,&delStNode);
		emptyBlockNum = emptyDiscBlockNum - countUsedBlock();
		logUdfInfo("[delFile4Tree] left empty blocks = %d \n",emptyBlockNum);
	}
	else
		return -1;
	return 0;
}

int delFlowTree(struct stfiledir * currTree)
{
	// 未测试的函数
	if (currTree != NULL)
	{
		reDirTree(currTree,&delStNode);
	}
	return 0;
}

int copyFile2ISO(char *filepath, char* topath)
{
	struct stat st;
	uint64_t fileSize;

	int ret;
	ret = 0;
	if (strlen(filepath)==0 || strlen(topath)==0)
		return FILEPATHERROR;
	if (stat(filepath,&st) == -1)
	{
		logUdfError("[copyFile2ISO] get path %s error\n",filepath);
		return FILESTATUSERROR;
	}
	if (strlen(topath) < 2 || topath[0] != '.' || topath[1] != '/')
	{
		logUdfError("[copyFile2ISO] get todir %s error\n",topath);  //拷贝的目录必须从./开始
		return FILEPATHERROR;
	}
//	if (topath[strlen(topath)-1] == '/')
//		topath[strlen(topath)-1] = '\0';


	if (S_ISREG(st.st_mode))
	{
		fileSize =(uint64_t) (st.st_size);
		emptyBlockNum = emptyDiscBlockNum - countUsedBlock();
		if ((fileSize/DVDBLOCKS) >= (emptyBlockNum - 25000))
		{
			logUdfError("[copyFile2ISO] disc has no empty space \n");
			return FILESIZEERROR;
		}
		else
		logUdfError("[copyFile2ISO] file size %d \n",fileSize);	
		ret = copyFile2Tree( filepath, topath, &st);
		if (ret == 0)
			emptyBlockNum = emptyBlockNum - fileSize/DVDBLOCKS;
		logUdfInfo("[copyFile2ISO] left empty blocks = %u \n",emptyBlockNum);
	}
	else if (S_ISDIR(st.st_mode))
	{
		return copyDir2ISO(filepath, topath);
		//logUdfError("[copyFile2ISO] dir %s dont support \n",filepath);
		// TODO 
		return ADDFOLDERERROR;
		
	}
	else
	{
		logUdfError("[copyFile2ISO] file %s ,st.st_mode = %d ,st.st_size = %d dont support \n",filepath,st.st_mode,st.st_size);
		ret = FILESTATUSERROR;
	}
	


	return ret;
}

int copyDir2ISO(char *filepath, char* topath)
{
	int ret = 0;
	DIR *currDir = NULL;
	struct dirent *currDirst = NULL;
	struct dirent *nextDirst = NULL;
	char currDirName[257] = {'\0'};
	char *currDirToPath = NULL;
	currDir = opendir(filepath);
	if (currDir == NULL)
	{
		logUdfError("[copyDir2ISO] filepath %s open failed. \n",filepath);
		return ADDFOLDERERROR;
	}
	currDirst = readdir(currDir); //readdir的返回值是静态分配，无法free
	if (currDirst != NULL)
	{ //添加一下本文件夹
		cutPathName(filepath,currDirName);
		ret = makeDir2ISO(currDirName,topath);
		if (ret != 0) //添加失败 直接处理
		{
			closedir(currDir);
			return ret;
		}
		currDirToPath = calloc (strlen(topath) + strlen(currDirName) + 3, 1);
		currDirToPath = strcat(currDirToPath,topath);
		if (topath[strlen(topath)-1] != '/')
			currDirToPath = strcat(currDirToPath,"/");
		currDirToPath = strcat(currDirToPath,currDirName);
		currDirToPath = strcat(currDirToPath,"/");
	}
	else
	{
		closedir(currDir);
		return ADDFOLDERERROR;
	}
	while (currDirst != NULL)
	{
		logUdfInfo("[copyDir2ISO] currDirst->d_name %s  \n",currDirst->d_name);
		if (strcmp(currDirst->d_name,".") == 0) //本文件夹 跳过这个
		{}
		else if (strcmp(currDirst->d_name,"..") == 0) //上级文件夹 跳过这个
		{}
		else if(strcmp(currDirst->d_name,".") != 0 && currDirst->d_type == DT_DIR )
		{//读取到一个文件夹，需要递归处理
			char *tmpDirPath;
			tmpDirPath = calloc (strlen(filepath) + strlen(currDirst->d_name) + 3, 1);
			tmpDirPath = strcat(tmpDirPath,filepath);
			tmpDirPath = strcat(tmpDirPath,"/");
			tmpDirPath = strcat(tmpDirPath,currDirst->d_name);
			copyDir2ISO(tmpDirPath,currDirToPath);
			free (tmpDirPath);	
		}
		else if(currDirst->d_type == DT_REG)
		{//读取到一个文件
			char *tmpFilePath;
			tmpFilePath = calloc (strlen(filepath) + strlen(currDirst->d_name) + 3, 1);
			tmpFilePath = strcat(tmpFilePath,filepath);
			tmpFilePath = strcat(tmpFilePath,"/");
			tmpFilePath = strcat(tmpFilePath,currDirst->d_name);
			copyFile2ISO(tmpFilePath,currDirToPath);
			free (tmpFilePath);
		}
		else //不支持的文件类型
		{}
		currDirst = readdir(currDir);
	}
	
	if (currDir != NULL)
	{
		closedir(currDir);
		currDir = NULL;
	}
	if (currDirToPath != NULL)
		free(currDirToPath);
	currDirToPath = NULL;
	return ret;
}

struct stfiledir * getFileTreeSt()
{
	if (stRootDir == NULL)
	{
		logUdfInfo("[getFileTreeSt] initStRootDirTree()\n");
		initStRootDirTree();
	}
	else
	{
		logUdfInfo("[getFileTreeSt] no need initStRootDirTree()\n");
	}
		
	return stRootDir;
}

char * convGTKTreePath(char* path)
{
	char* ret;
	char* tmpStr;
	char* tmpNodeStr;
	int tmpNo;
	struct stfiledir *currNode;
	if(path == NULL)
		return NULL;
	logUdfInfo("[convGTKTreePath] path = %s \n",path);
	currNode = stRootDir;
	ret = calloc(MAXDIRSTRALONG,1); //给定最大目录长度 
	tmpNodeStr = calloc (DNAMELENMAX, 1); //暂时只给了每个文件夹名称限制 
	strcat(ret, currNode->name);//先把.写入
	currNode = currNode->stfd;
	while((tmpStr = strchr(path, ':')) != NULL) //从头开始数还有':'分割文件夹
	{
		memset(tmpNodeStr,0,DNAMELENMAX);
		strncpy(tmpNodeStr,path,tmpStr - path);
		tmpNo = atoi(tmpNodeStr);
		tmpNo++; //用来跳过文件夹目录的第一个..文件
		for(int i = 0; i < tmpNo; i++)
		{
			currNode = currNode->rfd;
		}
		strcat(ret, "/");
		strcat(ret, currNode->name);
		path = tmpStr + 1;
		currNode = currNode->stfd;
	};

	tmpNo = atoi(path);
	tmpNo++; //用来跳过文件夹目录的第一个..文件
	for(int i = 0; i < tmpNo; i++)
	{
		currNode = currNode->rfd;
	}
	strcat(ret, "/");
	strcat(ret, currNode->name);
	free(tmpNodeStr);
	return ret;
}

char * convGTKTreePathDir(char* path)
{
	char* ret;
	char* tmpStr;
	char* tmpNodeStr;
	int tmpNo;
	struct stfiledir *currNode;
	if(path == NULL)
		return NULL;
	logUdfInfo("[convGTKTreePathDir] path = %s \n",path);
	currNode = stRootDir;
	ret = calloc(MAXDIRSTRALONG,1); //给定最大目录长度 
	tmpNodeStr = calloc (DNAMELENMAX, 1); //给了每个文件夹名称限制 
	strcat(ret, currNode->name);//先把.写入
	currNode = currNode->stfd;
	while((tmpStr = strchr(path, ':')) != NULL) //从头开始数还有':'分割文件夹
	{
		memset(tmpNodeStr,0,DNAMELENMAX);
		strncpy(tmpNodeStr,path,tmpStr - path);
		tmpNo = atoi(tmpNodeStr);
		tmpNo++; //用来跳过文件夹目录的第一个..文件
		for(int i = 0; i < tmpNo; i++)
		{
			currNode = currNode->rfd;
		}
		strcat(ret, "/");
		strcat(ret, currNode->name);
		path = tmpStr + 1;
		currNode = currNode->stfd;
	};

	tmpNo = atoi(path);
	tmpNo++; //用来跳过文件夹目录的第一个..文件
	for(int i = 0; i < tmpNo; i++)
	{
		currNode = currNode->rfd;
	}
	strcat(ret, "/");
	if (currNode->isDir)
	{
		strcat(ret, currNode->name);
		strcat(ret, "/");
	}
	free(tmpNodeStr);
	return ret;
}

char * GetUdfDiscType()
{//光盘类型
	static char diTye[9][9]={"DVD-R","CD-R","BD","UNKNOWN"};
	if (udfDiscType >= 0 && udfDiscType <= 2)
		return diTye[udfDiscType];
	logUdfInfo ("[GetUdfDiscType] udfDiscType=%d",udfDiscType);
	return diTye[3];
}

uint32_t GetUdfBlankBlock()
{
	return emptyDiscBlockNum;
}

int PatchBlankUDFImage(char *imagepath, double vernum)
{
	FILE *imgfp;
	uint32_t blkno,len;
	uint32_t numPD,numUSE,numUSD,numLVD,numFSD;
	struct generic_desc *tmpDesc;
	struct generic_desc *tmpAVDP;
	struct logicalVolDesc *tmpLVD;
	struct fileSetDesc		*tmpFSD;
	struct partitionDesc *tmpPD;
	struct unallocSpaceEntry *tmpUSE;
	struct unallocSpaceDesc *tmpUSD;
	long_ad			*fsdAd;
	tmpDesc = calloc (DVDBLOCKS,1);
	tmpAVDP = calloc (DVDBLOCKS,1);
	tmpLVD = calloc (DVDBLOCKS,1);
	tmpFSD = calloc (DVDBLOCKS,1);
	tmpPD = calloc (DVDBLOCKS,1); //因为读取函数一次读取2048字节
	tmpUSE = calloc (DVDBLOCKS,1);
	tmpUSD = calloc (DVDBLOCKS,1);
	imgfp = fopen(imagepath, "rb+");
	
	readFileBlock(imgfp, 256, tmpAVDP);
	blkno = ((struct anchorVolDescPtr*)tmpAVDP)->mainVolDescSeqExt.extLocation;
    len = ((struct anchorVolDescPtr*)tmpAVDP)->reserveVolDescSeqExt.extLength;
	logUdfInfo("[PatchBlankUDFImage] blkno=[%u] len=[%u]\n",blkno,len);
    for(int i = 0; i < len; blkno++, i += 2048 ) 
    {
		readFileBlock(imgfp, blkno, tmpDesc);
		
		switch( tmpDesc->descTag.tagIdent ) 
		{
			
		case TAG_IDENT_PD:
			// must have one (re)writable partition 
			// may have at most one RDONLY partition 
			logUdfInfo("[PatchBlankUDFImage] find TAG_IDENT_PD tmpDesc->accessType = %d \n",((struct partitionDesc *)tmpDesc)->accessType);
			switch( ((struct partitionDesc *)tmpDesc)->accessType ) {
			case PD_ACCESS_TYPE_READ_ONLY:
			case PD_ACCESS_TYPE_REWRITABLE:
			case PD_ACCESS_TYPE_WRITE_ONCE:
			case PD_ACCESS_TYPE_OVERWRITABLE:
			if( tmpDesc->volDescSeqNum > tmpPD->volDescSeqNum )
				memcpy(tmpPD, tmpDesc, 512);
			numPD = blkno;
			logUdfInfo("[PatchBlankUDFImage] TAG_IDENT_PD tmpDesc->volDescSeqNum = %d ,blkno = %d \n",tmpDesc->volDescSeqNum,blkno);
			break;
			default:
			logUdfInfo("[PatchBlankUDFImage] What to do with an accesstype %d partition?\n", 
				((struct partitionDesc*)tmpDesc)->accessType);
			break;
			}
			break;
		case TAG_IDENT_LVD:
			logUdfInfo("[PatchBlankUDFImage] TAG_IDENT_LVD tmpDesc->volDescSeqNum = %d ,blkno = %d \n",tmpDesc->volDescSeqNum,blkno);
			if( tmpDesc->volDescSeqNum > tmpLVD->volDescSeqNum )
			memcpy(tmpLVD, tmpDesc, 512);
			numLVD = blkno;
			break;			
		case TAG_IDENT_USD:
			logUdfInfo("[PatchBlankUDFImage] TAG_IDENT_USD tmpDesc->volDescSeqNum = %d ,blkno = %d \n",tmpDesc->volDescSeqNum,blkno);
			if( tmpDesc->volDescSeqNum > tmpUSD->volDescSeqNum )
				memcpy(tmpUSD, tmpDesc, 512);
			break;
		case TAG_IDENT_USE:
			logUdfInfo("[PatchBlankUDFImage] TAG_IDENT_USE tmpDesc->volDescSeqNum = %d ,blkno = %d \n",tmpDesc->volDescSeqNum,blkno);
			if( tmpDesc->volDescSeqNum > tmpUSD->volDescSeqNum )
				memcpy(tmpUSE, tmpDesc, DVDBLOCKS);
			numUSE = blkno;
			break;
			
		default:
			//logUdfInfo("[PatchBlankUDFImage] Unexpected tag ID %04X  in Volume Descriptor Sequence block %d \n", tmpDesc->descTag.tagIdent, blkno);
			break;
		}
		
    }
	
	//处理分区表
	logUdfInfo("[PatchBlankUDFImage] tmpPD->partitionStartingLocation = %d \n",tmpPD->partitionStartingLocation);	
	logUdfInfo("[PatchBlankUDFImage] tmpPD->partitionLength = %d \n",tmpPD->partitionLength);
	tmpPD->accessType = PD_ACCESS_TYPE_READ_ONLY;
		
	//不论何种spacemap 这边都删除标识位 ECMA167-2rd搜+NSR02 提到partitionContentsUse需要写入Partition Header Descriptor
	// Partition Header Descriptor全都空则删除spacemap
	memset(tmpPD->partitionContentsUse,0,128); 
	setChecksum(tmpPD);
	writeFileBlock(imgfp, numPD, tmpPD, 512);

//寻找文件组描述符FSD位置
	fsdAd = (long_ad*) tmpLVD->logicalVolContentsUse;
	logUdfInfo("[PatchBlankUDFImage] tmpLVD->logicalVolContentsUse.extLocation.logicalBlockNum = %d \n",  fsdAd->extLocation.logicalBlockNum);
    for(int i = 0; i < (fsdAd->extLength >> 11); i++ ) {
	blkno =  tmpPD->partitionStartingLocation + fsdAd->extLocation.logicalBlockNum + i;
	readFileBlock(imgfp, blkno, tmpDesc);
	
	switch( tmpDesc->descTag.tagIdent ) {
	case TAG_IDENT_TD:
	    i = fsdAd->extLength;
	    break;
	case TAG_IDENT_FSD:
	    memcpy(tmpFSD, tmpDesc, 512);
		numFSD = blkno;
	    logUdfInfo("[PatchBlankUDFImage] File Set Descriptor find at blkno = %d \n",blkno);
	    break;
	default:
	    logUdfInfo("[PatchBlankUDFImage] Unxpected tag id %d, where File Set Desc(256) expected\n", tmpDesc->descTag.tagIdent);
	}
    }

    if( vernum == 201 && tmpFSD != NULL )
	{
		logUdfError("[PatchBlankUDFImage]find File Set Descriptor\n");

		//streamDirectoryICB应该清除
		tmpFSD->streamDirectoryICB.extLength = 0;
		tmpFSD->streamDirectoryICB.extLocation.logicalBlockNum = 0;
		tmpFSD->streamDirectoryICB.extLocation.partitionReferenceNum = 0;
		
		setChecksum(tmpFSD);
		writeFileBlock(imgfp, numFSD, tmpFSD, 512);
	}
//消除 Unallocated Space Entry 在fsd前一个的block
//	memset(tmpUSE,0,DVDBLOCKS);
//	writeFileBlock(imgfp, numUSE, tmpUSE, DVDBLOCKS);

endx:	
	fclose(imgfp);
	free (tmpPD);
	free (tmpAVDP);
	free (tmpFSD);
	free (tmpLVD);
	free (tmpUSE);
	free (tmpUSD);
	free (tmpDesc);
	return 0;
}
int WriteFL2stTree()
{
	struct stprefiledir *currfd;
	int ret = 0;
	char *filename;

	currfd = stPreFileList.fdStart;
	while (currfd != NULL)
	{
		if (currfd->isRecorded)
		{ //跳过已有文件
			currfd = currfd->next;
			continue;
		}

		if (currfd->isDir)
		{
			filename = strrchr(currfd->filePath, '/');
			if (filename != NULL)
				filename += 1;
			else
				filename = currfd->filePath;
			ret = makeDir2ISO(filename, currfd->toPath);
			if (ret != 0)
				logUdfError("[WriteFL2stTree] makeDir2ISO filename=%s error.\n",filename);
		}
		else
		{

			ret = copyFile2ISO(currfd->filePath, currfd->toPath);
			if (ret != 0)
				logUdfError("[WriteFL2stTree] copyFile2ISO currfd->filePath=%s currfd->toPath =%s error.\n",currfd->filePath,currfd->toPath);
		}
		currfd = currfd->next;
	}
	return 0;
}
int UpdateBlankUDFImage(char *imagepath, double vernum)
{
	//把文件树写入文件
	FILE *imgfp;
	imgfp = fopen(imagepath, "rb+");
	writeFDTree2Image(imgfp,stRootDir);
	fclose(imgfp);
	//清理树
	delFlowTree(stRootDir);
	stRootDir == NULL;
	clearCountFileNum();
	return 0;
}

int MkBlankUDFImage(char *devname, char *tmppath, double vernum)
{ 
	//新建空文件树 stRootDir
	InitBlankRootsTree(".");
	//把待处理的文件加到文件树里
	WriteFL2stTree();
	//把文件树的fe和fid填完整
	updateCurrStTree(stRootDir); //这一步可以得到 addIsoBlocks 的大小
	//制作镜像
	//mkudffs -b 2048 --packetlen=16 --space=unalloctable --ad=short --startblock=$nextsession -r 0x0102 -l "$label" /tmp/$imgudffile `expr $nextsession + $mkblocknum`
	char *mkudfcmd;
	char *rmudfcmd;
	char numblockstr[33] = {'\0'};
	uint32_t cmdsize = 1000;
	mkudfcmd = calloc(cmdsize,1);
	rmudfcmd = calloc(cmdsize,1);
	strcat(mkudfcmd,"mkudffs -b 2048 --packetlen=16 --space=unalloctable  -r ");
	if (vernum == 201)
		strcat(mkudfcmd,"0x0201");
	else if (vernum == 102)
		strcat(mkudfcmd,"0x0102");
	strcat(mkudfcmd," -l \"");
	strcat(mkudfcmd,getTrackLabel());
	strcat(mkudfcmd,"\" ");
	//加入临时文件名称
	memset(getUDFImageName(),0,100);
	sprintf(getUDFImageName(),"%s/isonew%u.udf",tmppath,getTimeuint());
	strcat(mkudfcmd,getUDFImageName());
	strcat(mkudfcmd," ");
	//加入镜像大小 stPreFileList
	sprintf(numblockstr,"%u",addIsoBlocks);
	strcat(mkudfcmd,numblockstr);
	sprintf(rmudfcmd,"rm -rf %s",getUDFImageName()); //删除可能存在的之前的临时文件
	system(rmudfcmd); //删除可能存在的之前的临时文件
	free (rmudfcmd);
	logUdfInfo("[MkBlankUDFImage] mkudfcmd=%s\n",mkudfcmd);
	system(mkudfcmd);
	free (mkudfcmd);

	//更新空白镜像 把文件和文件夹拷贝
	if (vernum == 201)
	{	
		PatchBlankUDFImage(getUDFImageName(), 201);
		UpdateBlankUDFImage(getUDFImageName(), 201);
	}
	else if (vernum == 102)
	{
		PatchBlankUDFImage(getUDFImageName(), 102);
		UpdateBlankUDFImage(getUDFImageName(), 102);
	}

	return 0; 
}

int FinUdfNewBurn()
{

	if (addUdfFile)
		memset(addUdfFile,0,MAXIMAGENAME);
	
	DelFileDirList(&stPreFileList);
	return 0;
}

//这个函数必须要有su权限才能运行
int CpFileDir2UDFImage(char *imagepath)
{
	
	char *cpfilecmd;
	char *tmpmountname;
	
	uint32_t cmdsize = 1000;
	
	cpfilecmd = calloc(cmdsize,1);
	tmpmountname = calloc(cmdsize,1);
	strcat(tmpmountname,imagepath);
	strcat(tmpmountname,"dir");
	//先创建mount文件夹
	strcat(cpfilecmd,"rm -rf ");
	strcat(cpfilecmd,tmpmountname);
	
	system(cpfilecmd);  //删除一下可能存在的旧文件夹
	memset(cpfilecmd,0,cmdsize);
	strcat(cpfilecmd,"mkdir ");
	strcat(cpfilecmd,tmpmountname);
	
	system(cpfilecmd);
	//mount操作
	memset(cpfilecmd,0,cmdsize);
	strcat(cpfilecmd,"mount ");
	strcat(cpfilecmd,imagepath);
	strcat(cpfilecmd," ");
	strcat(cpfilecmd,tmpmountname);
	
	logUdfInfo("[CpFileDir2UDFImage] mkdircmd=%s\n",cpfilecmd);
	system(cpfilecmd);

//文件拷贝
	struct stprefiledir *currfd;
	char *filename;
	
	currfd = stPreFileList.fdStart;
	while (currfd != NULL)
	{
		memset(cpfilecmd,0,cmdsize);
		//把文件名找出来
		filename = strrchr(currfd->filePath, '/');
		if (filename != NULL)
			filename += 1;
		else
			filename = currfd->filePath;
		//假设topath都是./开头的  +2为了去掉./
		if (currfd->isDir)														//toPath+2变空导致前后俩斜杠
			sprintf(cpfilecmd,"mkdir %s/%s/%s",tmpmountname,currfd->toPath+2,filename); 
		else												// 两个/也不会出问题
			sprintf(cpfilecmd,"cp %s %s/%s",currfd->filePath,tmpmountname,currfd->toPath+2);
		logUdfInfo("[CpFileDir2UDFImage] cpfilecmd=%s\n",cpfilecmd);
		system(cpfilecmd);
		currfd = currfd->next;
	}

	//umount操作
	memset(cpfilecmd,0,cmdsize);
	strcat(cpfilecmd,"umount ");
	strcat(cpfilecmd,imagepath);
	system(cpfilecmd);

	//删除mount的路径
	memset(cpfilecmd,0,cmdsize);
	strcat(cpfilecmd,"rm -rf ");
	strcat(cpfilecmd,tmpmountname);
	system(cpfilecmd);  //删除一下可能存在的旧文件夹
	
	free(cpfilecmd);
	free (tmpmountname);
	return 0;
}

//#define PATCH_HAVE_MAIN 1 已经转移到makefile里了
#ifdef PATCH_HAVE_MAIN

int main (int argc, char *argv[])
{
	printf ("argc=[%d]\n",argc);

	char *inputfile,*outputfile;
	struct generic_desc 	*p;
	const char *dirnamexx = "xss";
	const char *dirpathxx = "./mcmods";
	if (argv[1][0] == '-')
	{
	
		if (argv[1][1] == 'R')
		{	
			int ifstartpos,ofstartpos,numbytes;
			if (argc < 3)
			{
				printf ("err: argc < 3\n");
				printf ("-R for replace example:  -R /dev/sr0 \n");
				return 0;
			}
			else
			{
				inputfile = argv[2];
				initUdfMod(inputfile);
				
				//lsCDR();

				initStRootDirTree();
				
				updateStTree();
				
				mkAddUdfFs(multiStart[getdiscinfo()->trk1_lastsession-1],multiStart[getdiscinfo()->trk1_lastsession-1] + addIsoBlocks,addUdfFile); // 5w正好100M
				patchAddUdfFs(addUdfFile);  //在这里open ISO了				
				
				writeFDTree2ISO();
				
				delStRootDirDescTree();   //在这里close ISO了
				
				finUdfMod();
/*				ifstartpos  =atoi( argv[3]);
				outputfile  = argv[4];
				ofstartpos =atoi( argv[5]); 
				numbytes = atoi( argv[6]);
				int buffonce = DVDBLOCKS*PKGLEN/8;
				if (numbytes%buffonce != 0)
					numbytes = (numbytes/buffonce)*buffonce + buffonce;
//				replacefilebyte(inputfile,ifstartpos,outputfile,ofstartpos,numbytes);
*/
			}
			
		}
		else if (argv[1][1] == 'C')
		{
			int ifstartpos,ofstartpos,numbytes;
			if (argc < 3)
			{
				printf("err: argc < 3\n");
				printf("-C for replace example:  -C /dev/sr0\n");
				return 0;
			}
			else
			{
				inputfile = argv[2];
				initUdfMod(inputfile);
				
				printf("[main] TAG_IDENT_FSD = %d \n",TAG_IDENT_FSD);
				printf("[main] TAG_IDENT_FE = %d \n",TAG_IDENT_FE);

				p = readSingleBlock(288 + 81248);
				printf("[main] FileSetDesc p->descTag.tagIdent = %d \n",p->descTag.tagIdent);
				
				p = readSingleBlock(288 + 581664);
//				printf("[main] FileEntry p->descTag.tagIdent = %d \n",p->descTag.tagIdent);
				
				p = readSingleBlock(288 + 581648);
//				printf("[main] FileSetDesc p->descTag.tagIdent = %d \n",p->descTag.tagIdent);
				
				
				int patch = 1;
				if (patch)
				{

				initStRootDirTree();
				updateStTree();
				mkAddUdfFs(multiStart[getdiscinfo()->trk1_lastsession-1],multiStart[getdiscinfo()->trk1_lastsession-1] + addIsoBlocks,addUdfFile); // 5w正好100M
				patchAddUdfFs(addUdfFile);  //在这里open ISO了
				writeFDTree2ISO();
				delStRootDirDescTree();   //在这里close ISO了
				}
				struct generic_desc *tmpDesc;
				struct fileEntry      *tmpFE;
				struct fileSetDesc		*tmpFSD;
				struct fileIdentDesc *tmpFid;
				struct fileIdentDesc *tmpFid2;
				char *data;
				FILE *xfile;
				regid *tmpRegid;
				icbtag *tmpIcb;
				
				xfile = fopen(addUdfFile, "rb+");
				tmpDesc = malloc (DVDBLOCKS);
				tmpFE = malloc (DVDBLOCKS);
				tmpFSD = malloc (DVDBLOCKS);
				tmpFid = malloc (DVDBLOCKS);
				
				//readFileBlock(xfile, 288, tmpDesc);
				//memcpy(tmpFSD, tmpDesc, 2048);
				
				readFileBlock(xfile, 305, tmpDesc);
				memcpy(tmpFid, tmpDesc, 2048);
				
				readFileBlock(xfile, 306, tmpDesc);
				memcpy(tmpFE, tmpDesc, 2048);
				
				printf("[main] xfile tmpFE->descTag.tagIdent = %d \n",tmpFE->descTag.tagIdent);
				//printf("[main] xfile tmpFSD->descTag.tagIdent = %d \n",tmpFSD->descTag.tagIdent);
				
				
				//change
				printf("[main] xfile tmpFE->descTag.tagSerialNum = %d \n",tmpFE->descTag.tagSerialNum);
				printf("[main] xfile tmpFE->descTag.tagLocation = %d \n",tmpFE->descTag.tagLocation);
				
				printf("[main] xfile tmpFE->extendedAttrICB.extLocation.logicalBlockNum = %d \n",tmpFE->extendedAttrICB.extLocation.logicalBlockNum);
				printf("[main] xfile tmpFE->extendedAttrICB.extLocation.partitionReferenceNum = %d \n",tmpFE->extendedAttrICB.extLocation.partitionReferenceNum);
				printf("[main] xfile tmpFE->uniqueID = %d \n",tmpFE->uniqueID);
			//	tmpFE->descTag.tagLocation = 0;  //影响挂载
			//	tmpFE->descTag.descVersion = 1;
			//	tmpFE->descTag.tagSerialNum = 0;
			//	tmpFE->uniqueID = 0;
				tmpIcb = &(tmpFE->icbTag);
				
				tmpRegid = &(tmpFE->impIdent);
			//	tmpRegid->ident[2] = 1;
				logUdfInfo("[main] tmpFSD tmpRegid->ident = %s \n",tmpRegid->ident);
				if (memcmp(tmpRegid->ident, UDF_ID_COMPLIANT, strlen(UDF_ID_COMPLIANT)))
				{
					logUdfInfo("[main] tmpFSD tmpRegid->ident = %s \n",tmpRegid->ident);
				}
				//tmpFE->uniqueID = 10;
				

	
				printf("[main] xfile tmpIcb->priorRecordedNumDirectEntries = %d \n",tmpIcb->priorRecordedNumDirectEntries);
				printf("[main] xfile tmpIcb->strategyType = %d \n",tmpIcb->strategyType);
				printf("[main] xfile tmpIcb->strategyParameter = %d \n",tmpIcb->strategyParameter);
				printf("[main] xfile tmpIcb->numEntries = %d \n",tmpIcb->numEntries);
				printf("[main] xfile tmpIcb->reserved = %d \n",tmpIcb->reserved);
				printf("[main] xfile tmpIcb->fileType = %d \n",tmpIcb->fileType);
				printf("[main] xfile tmpIcb->flags = %d \n",tmpIcb->flags);
				
				printf("[main] xfile tmpFE->fileLinkCount = %d \n",tmpFE->fileLinkCount);
				
				tmpIcb->parentICBLocation.logicalBlockNum = 0;
				
				if (patch)
					tmpFE->descTag.tagSerialNum = 1;
				
				updateFePermissions(tmpFE,"README");
				regid entityWRUDF = { 0, "-wrudf (1.02)", "\x04\x05"};
				tmpFE->impIdent = entityWRUDF;
				
			
				if (!patch)
					tmpFid = tmpFE->extendedAttrAndAllocDescs + tmpFE->lengthExtendedAttr;
				data = tmpFid;
				data = data + ((sizeof(struct fileIdentDesc) + tmpFid->lengthOfImpUse + tmpFid->lengthFileIdent + 3) & ~3);
				tmpFid2 = data;
				printf("[main] xfile tmpFid->descTag.tagIdent = %d \n",tmpFid->descTag.tagIdent);
				printf("[main] xfile tmpFid->descTag.tagSerialNum = %d \n",tmpFid->descTag.tagSerialNum);
				printf("[main] xfile tmpFid->descTag.tagLocation = %d \n",tmpFid->descTag.tagLocation);
				printf("[main] xfile tmpFid->icb.extLocation.logicalBlockNum = %d \n",tmpFid->icb.extLocation.logicalBlockNum);
				
				if (patch)
					tmpFid->descTag.tagSerialNum = 1;  //影响追加刻录
				
				//tmpFid->descTag.tagLocation = 366225; //不影响挂载
				//tmpFid->icb.extLocation.logicalBlockNum = 366224;
				tmpFid2->impUseAndFileIdent;
				//tmpFid2->impUseAndFileIdent[0] = 0;
				printf("[main] xfile tmpFid2->impUseAndFileIdent[0] = %d \n",tmpFid2->impUseAndFileIdent[0]);
				setChecksum(tmpFid2);
				setChecksum(tmpFid);
				
				if (patch)
					writeFileBlock(xfile, 305, tmpFid, 2048);
					
				setChecksum(tmpFE);
				writeFileBlock(xfile, 306, tmpFE, 2048);	
				/*
				printf("[main] xfile tmpFSD->descTag.tagSerialNum = %d \n",tmpFSD->descTag.tagSerialNum);
				printf("[main] xfile tmpFSD->descTag.tagLocation = %d \n",tmpFSD->descTag.tagLocation);
				//tmpFSD->descTag.tagLocation = 0;
				//tmpFSD->descTag.descVersion = 1;
				setChecksum(tmpFSD);
				writeFileBlock(xfile, 288, tmpFSD, 2048);
				*/
				
				
				
				fflush(xfile);
				fclose(xfile);
				free(tmpDesc);
				free(tmpFSD);
				free(tmpFE);
				
				finUdfMod();
			}
		}
		else if (argv[1][1] == 'T')
		{
			int ifstartpos,ofstartpos,numbytes;
			if (argc < 3)
			{
				printf("err: argc < 3\n");
				printf("-C for replace example:  -C /dev/sr0\n");
				return 0;
			}
			else
			{
				printf("-T for replace example:  -T /dev/sr0 ssd.udf ./ \n");

				inputfile = argv[2];

				
				initUdfMod(inputfile);
				
				lsCDR();

				initStRootDirTree();
				//makeDir2ISO(dirnamexx,dirpathxx);
				makeDir2ISO("102ttt", "./");
				copyFile2ISO(argv[3], argv[4]);
				
				updateStTree();
				
				mkAddUdfFs(multiStart[getdiscinfo()->trk1_lastsession-1],multiStart[getdiscinfo()->trk1_lastsession-1] + addIsoBlocks,addUdfFile); // 5w正好100M
				patchAddUdfFs(addUdfFile);  //在这里open ISO了				
				
				writeFDTree2ISO();
				
				delStRootDirDescTree();   //在这里close ISO了
				
				
				finUdfMod();
			}
		}
		else if (argv[1][1] == 'U')
		{
			int ifstartpos,ofstartpos,numbytes;
			if (argc < 3)
			{
				printf("err: argc < 3\n");
				printf("-C for replace example:  -C /dev/sr0\n");
				return 0;
			}
			else
			{
				printf("-T for replace example:  -U /dev/sr0 ssd.udf ./ \n");
				inputfile = argv[2];

				/*
				initUdfMod(inputfile);
				
				lsCDR();

				initStRootDirTree();
				copyFile2ISO(argv[3], argv[4]);
				
				
				updateStTree();
				
				mkAddUdfFs(multiStart[getdiscinfo()->trk1_lastsession-1],multiStart[getdiscinfo()->trk1_lastsession-1] + addIsoBlocks,addUdfFile); // 5w正好100M
				patchAddUdfFs(addUdfFile);  //在这里open ISO了				
				
				writeFDTree2ISO();
				
				delStRootDirDescTree();   //在这里close ISO了
				
				
				finUdfMod();
				*/
				dchars uName[256];
				char* name2[256];
    			size_t uLen;
    			char* name;
    			char* name3;
    			name3="";
    			struct fileIdentDesc *tmpFid;
    			uint32_t         fidlen;
    			name = "README";
    			logPrintX(name, 6) ;
    			printf("[main] name = %s \n",name);
    			printf("[main] name.size = %d \n",strlen(name));
    			//uLen = encode_locale(uName, name, 256);
    			uLen = utf8_TO_utf16(uName, name, 128);
    			printf("[main] uLen = %d \n",uLen);
    			printf("[main] uName = %s \n",uName);
    			logPrintX(uName, 16) ;
    			decode_locale(uName, name2, 15,256);
    			printf("[main] name2 = %s \n",name2);
    			logPrintX(name2, 6) ;
    			
    			printf("[main] sizeof(struct fileIdentDesc) = %d \n",sizeof(struct fileIdentDesc));
    			tmpFid = makeFileIdentDesc(name);
    			fidlen = (sizeof(struct fileIdentDesc) + tmpFid->lengthOfImpUse + tmpFid->lengthFileIdent + 3) & ~3 ;
    			printf("[main] fidlen = %d \n",fidlen);
    			if (name3[0] != 0 )
    			
    				printf("[main] name3[0] != 0 \n");
    			
    			else
    				printf("[main] name3[0] == 0 \n");

    			
			}
		}
		else if (argv[1][1] == 'I')
		{	
			int ifstartpos,ofstartpos,numbytes,i;
			if (argc < 3)
			{
				printf ("err: argc < 3\n");
				printf ("-I example:  -I /dev/sr0 \n");
				return 0;
			}
			inputfile = argv[2];
			getLastTrackInfo(inputfile);
		}
	}
	else
		printf("-R for replace example:  -R inputfile startposition outputfile startposition numberofbytes\n");
	return 0;
}
#endif




