#ifndef _DEFAULTVAR_H
#define _DEFAULTVAR_H

#include<stdio.h>
#include <sys/types.h>		/* for u_char etc. */
#include"ecma_167.h"

enum MEDIUM { CDR = 1, CDRW };
//extern enum MEDIUM medium; //defaultvar.c中定义了

enum MEDIUM setudfmedium(enum MEDIUM inmedium);
enum MEDIUM getudfmedium();

int setudfdevicetype(int intype);
int getudfdevicetype();

int setudfdevice(int indevice);
int getudfdevice();

uint16_t setvirtualPartitionNum(uint16_t inVPNum);
uint16_t getvirtualPartitionNum();

struct cdrom_discinfo* getdiscinfo();
struct cdrom_trackinfo* getlasttrackinfo();

void setdevicecharname(char *inname);

char* getdevicecharname();

typedef struct _dir_ {
    struct _dir_	*parent, *child;
    uint32_t		dataSize;
    char		*data;
    long_ad		icb;				/* icb of this directory itself */
    char		*name;
    uint32_t		dirDirty;
    uint8_t		fe[2048];
}   Directory;


struct cdrom_trackinfo {
    u_short	data_length;
    u_char	trk;
    u_char	session;
    u_char	_r4;
    u_char	trk_mode	:4;
    u_char	copy		:1;
    u_char	damage		:1;
    u_char	_r5		:2;
    u_char	data_mode	:4;
    u_char	fixpkt		:1;
    u_char	packet		:1;
    u_char	blank		:1;
    u_char	rsrvd_trk	:1;
    u_char	nwa_v	:1;
    u_char	_r7	:7;
    u_int	trk_start;
    u_int	nwa;
    u_int	free_blks;
    u_int	fixpkt_size;
    u_int	trk_size;
};

struct cdrom_discinfo {
    u_short	data_length;
    u_char	disc_status	:2;
#define	DS_EMPTY	0	/* Empty disk				*/
#define	DS_APPENDABLE	1	/* Incomplete disk (appendable)		*/
#define	DS_COMPLETE	2	/* Complete disk (closed/no B0 pointer)	*/
    u_char	session_status	:2;
#define	SS_EMPTY	0	/* Empty session			*/
#define	SS_APPENDABLE	1	/* Incomplete session			*/
#define	SS_COMPLETE	3	/* Complete session (needs DS_COMPLETE)	*/
    u_char	erasable:1;
    u_char	_r1	:3;

    u_char	trk0;
    u_char	nsessions;
    u_char	trk0_lastsession;
    u_char	trk1_lastsession;
    u_char	_r4	:5;
    u_char	uru	:1;
    u_char	dbc_v	:1;
    u_char	did_v	:1;
    u_char	disc_type;
    u_char	_r9;
    u_char	_r10;
    u_char	_r11;
    u_int	disc_id;
    u_char	latest_leadin_msf[4];
    u_char	last_leadout_msf[4];
    u_char	barcode[8];
    u_char	_r32;
    u_char	n_opc;
};




#endif


