#include<stdio.h>
#include<string.h>
#include<fcntl.h>


#include <stddef.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <inttypes.h>
#include"wrctl.h"
#include"ecma_167.h"
#include"utils.h"
#include"defaultvar.h"


Directory * readDirectory(Directory *parentDir, long_ad* icb, char *name) 
{
    char	*p;
    uint32_t	len;
    Directory	*dir;
    struct fileEntry	*fe;
	struct extendedFileEntry	*efe;


	dir = rootDir;
 
 //如果是rw设备，则更新文件夹
 	logUdfInfo("[readDirectory] passed 45 icb->extLength = %d \n",icb->extLength);  //TODO
 	logUdfInfo("[readDirectory]  icb->extLocation.logicalBlockNum = %d \n",icb->extLocation.logicalBlockNum);  //TODO
 	logUdfInfo("[readDirectory]  icb->extLocation.partitionReferenceNum = %d \n",icb->extLocation.partitionReferenceNum);  //TODO
    dir->icb = *icb;

    //TODO 需要做一个分区对应表 主要是每个分区的起点问题
    p = readTaggedBlock(icb->extLocation.logicalBlockNum, icb->extLocation.partitionReferenceNum);
    memcpy(dir->fe, p, 2048);
     
//	logPrintX(p,2048); //TODO
	if (dir->fe[0] == 5 && dir->fe[1] == 1 && dir->fe[2] == 2)
	{
		fe = (struct fileEntry *)dir->fe;
		logUdfInfo("[readDirectory] fe is udf1.02 fe \n");  //TODO
		dir->dataSize = fe->informationLength;
		if( (fe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_IN_ICB ) 
		{
			memcpy(dir->data, fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr, fe->lengthAllocDescs);
			memset(fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr, 0, fe->lengthAllocDescs);

		} 
		else 
		{
			if( fe->informationLength > dir->dataSize ) 
			{
				len = (fe->informationLength + 2047) & ~2047;
				dir->data = realloc(dir->data, len);
				if( !dir->data ) 
				{
					printf("Realloc directory data failed\n");
					return NULL;
				}
				dir->dataSize = len;
				
			} 
			readExtents(dir->data, (fe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_SHORT,
			fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr);
	/*
		if( medium == CDRW ) {
			if( (fe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_SHORT )
			freeShortExtents((short_ad*)(fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr));
			else if( (fe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_LONG )
			freeLongExtents((long_ad*)(fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr));
		}
	*/	
			logUdfInfo("[readDirectory] passed 77 \n");  //TODO
		}
	}
	else if (dir->fe[0] == 10 && dir->fe[1] == 1 && dir->fe[2] == 3)
	{
		logUdfInfo("[readDirectory] fe is udf2.01 efe \n");  //TODO
		efe = (struct fileEntry *)dir->fe;
		dir->dataSize = efe->informationLength;
		if( (efe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_IN_ICB ) 
		{
			memcpy(dir->data, efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr, efe->lengthAllocDescs);
			memset(efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr, 0, efe->lengthAllocDescs);
			logUdfInfo("[readDirectory] efe use ICBTAG_FLAG_AD_IN_ICB \n");
		} 
		else 
		{
			if( efe->informationLength > dir->dataSize ) 
			{
				len = (efe->informationLength + 2047) & ~2047;
				dir->data = realloc(dir->data, len);
				if( !dir->data ) 
				{
					printf("Realloc directory data failed\n");
					return NULL;
				}
				dir->dataSize = len;
				
			} 
			readExtents(dir->data, (efe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_SHORT,
			efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr);
			logUdfInfo("[readDirectory] efe use ICBTAG_FLAG_AD_SHORT \n");
		}

	}


    return dir;
}

int lscCommand(void) 
{
    struct fileIdentDesc *fid;
    struct fileEntry *fe;
    struct fileEntry *curfe;
    char	*name, filename[512];
    uint64_t	i;
    int		state;
    short_ad *sad;


	state = analyzeDest(".", &fid, &name);
	logUdfError("[lscCommand] analyzeDest  state = %d \n",state);
	if( state != EXISTING_DIR )
	{
		logUdfError("[lscCommand] analyzeDest state != EXISTING_DIR state = %d \n",state);
	    return state;
	}
    
    curfe = (struct fileEntry *)curDir->fe;

	
    for( i = 0; i < curfe->informationLength;
	 i += ((sizeof(struct fileIdentDesc) + fid->lengthOfImpUse + fid->lengthFileIdent + 3) & ~3) ) 
    {
	fid = (struct fileIdentDesc*)(curDir->data + i);
	if( fid->fileCharacteristics & FID_FILE_CHAR_DELETED  ) 
	    continue;

	if( fid->fileCharacteristics & FID_FILE_CHAR_PARENT )
	    strcpy(filename, "..");
	else
	    decode_locale((dchars *)(fid->impUseAndFileIdent + fid->lengthOfImpUse), filename, fid->lengthFileIdent, sizeof(filename)); //转换文件名

	fe = readTaggedBlock( fid->icb.extLocation.logicalBlockNum, fid->icb.extLocation.partitionReferenceNum);
	logUdfInfo("[lscCommand] fid->icb.extLocation.logicalBlockNum %d , fe->lengthAllocDescs = %d\n",fid->icb.extLocation.logicalBlockNum,fe->lengthAllocDescs);  //TODO
	sad = (short_ad*)(fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr);
	logUdfInfo("[lscCommand] sad->extLength = %d , sad->extPosition = %d ,uniqueID = %d ,logicalBlocksRecorded= %d ,fid-tagLocation = %d ,end \n", 
	sad->extLength,sad->extPosition,fe->uniqueID,fe->logicalBlocksRecorded,fid->descTag.tagLocation); //TODO
	printf("%s %6d:%c%c%c%c%c %6d:%c%c%c%c%c other:%c%c%c%c%c links:%2d info:%12"PRIu64" %s\n",
	    fe->icbTag.fileType == ICBTAG_FILE_TYPE_DIRECTORY ? "DIR" : "   ", 
	    fe->uid, 
	    fe->permissions & FE_PERM_U_READ ? 'r' : '-',
	    fe->permissions & FE_PERM_U_WRITE ? 'w' : '-',
	    fe->permissions & FE_PERM_U_EXEC ? 'x' : '-',
	    fe->permissions & FE_PERM_U_CHATTR ? 'a' : '-',
	    fe->permissions & FE_PERM_U_DELETE ? 'd' : '-',
	    fe->gid,
	    fe->permissions & FE_PERM_G_READ ? 'r' : '-',
	    fe->permissions & FE_PERM_G_WRITE ? 'w' : '-',
	    fe->permissions & FE_PERM_G_EXEC ? 'x' : '-',
	    fe->permissions & FE_PERM_G_CHATTR ? 'a' : '-',
	    fe->permissions & FE_PERM_G_DELETE ? 'd' : '-',
	    fe->permissions & FE_PERM_O_READ ? 'r' : '-',
	    fe->permissions & FE_PERM_O_WRITE ? 'w' : '-',
	    fe->permissions & FE_PERM_O_EXEC ? 'x' : '-',
	    fe->permissions & FE_PERM_O_CHATTR ? 'a' : '-',
	    fe->permissions & FE_PERM_O_DELETE ? 'd' : '-',
	    fe->fileLinkCount, fe->informationLength, filename);
    }
    return CMND_OK;

}

enum RV analyzeDest(char* arg, struct fileIdentDesc** fid, char** name) 
{
    int		len;
    char 	*comp, *endComp;

	
    if( arg[0] == '/' ) {
	curDir = rootDir;
	comp = arg + 1;
    } else {
	comp = arg;
	
    }

    len = strlen(comp);
    if( len > 1 && comp[len-1] == '/' )
	comp[len-1] = 0;				/* remove any trailing slash */

    for(  ; ( endComp = strchr(comp, '/') ) != NULL; comp = ++endComp ) {
		*endComp = 0;
		
		if( strcmp(comp, ".") == 0 )
			continue;

		if( strcmp(comp, "..") == 0 ) {
			if( !curDir->parent )
			return DIR_INVALID;
			curDir = curDir->parent;
			continue;
		}
	
		*fid = findFileIdentDesc(curDir, comp);

		if( *fid == NULL )
			return DIR_INVALID;

		if( ! ((*fid)->fileCharacteristics & FID_FILE_CHAR_DIRECTORY ))
			return DIR_INVALID;

		if( (*fid)->fileCharacteristics & FID_FILE_CHAR_DELETED )
			return DIR_INVALID;

	//	curDir = readDirectory(curDir->child, &(*fid)->icb, comp); 
		curDir = readDirectory(curDir, &(*fid)->icb, comp); 
    }
	
    // final component
    *name = comp;

    if( comp[0] == 0 || strcmp(comp, ".") == 0 )
    {
    	
    	*fid = findFileIdentDesc(curDir, comp);
		return EXISTING_DIR;
	}
	
    if( strcmp(comp, "..") == 0 ) {
	if( !curDir->parent )
	    return DIR_INVALID;
	curDir = curDir->parent;
	return EXISTING_DIR;
    }

    *fid = findFileIdentDesc(curDir, comp);

    if( *fid == NULL )
	return DOES_NOT_EXIST;

    if( (*fid)->fileCharacteristics & FID_FILE_CHAR_DIRECTORY ) {
	if( (*fid)->fileCharacteristics & FID_FILE_CHAR_DELETED )
	    return DELETED_DIR;
	else {
	    curDir = readDirectory(curDir, &(*fid)->icb, comp); 
	    return EXISTING_DIR;
	}
    } else {
	if( (*fid)->fileCharacteristics & FID_FILE_CHAR_DELETED )
	    return DELETED_FILE;
    }
    return EXISTING_FILE;    
}

struct fileIdentDesc* findFileIdentDesc(Directory *dir, char* name) 
{
    uint64_t		i;
    char		*data;
    struct fileEntry	*fe;
    struct fileIdentDesc *fid;
    dchars              uName[256];
    size_t              uLen;

    uLen = encode_locale(uName, name, 256);
    if (uLen == (size_t)-1)
        return NULL;
	logUdfInfo("[findFileIdentDesc] passed 248  \n");  //TODO
    data = dir->data;
//    logPrintX(data,4096); //TODO
    fe = (struct fileEntry *)dir->fe;
	logUdfInfo("[findFileIdentDesc] passed 253 fe->informationLength = %d  \n",fe->informationLength);  //TODO
    for( i = 0; i < fe->informationLength; 
	 i += (sizeof(struct fileIdentDesc) + fid->lengthOfImpUse + fid->lengthFileIdent + 3) & ~3 ) {

	fid = (struct fileIdentDesc*)(data + i);

	if( fid->descTag.tagIdent == TAG_IDENT_TE ){
		logUdfInfo("[findFileIdentDesc] passed 263  \n");  //TODO
	    return NULL;
	}
	if( fid->descTag.tagIdent == TAG_IDENT_IE ) {
	    printf("[findFileIdentDesc] Indirect Entry not yet implemented\n");
	    continue;
	}
	if( fid->descTag.tagIdent != TAG_IDENT_FID )
	    logUdfError("[findFileIdentDesc] Unknown tag id %08X in directory\n", fid->descTag.tagIdent);

	// check CRC

	if( fid->fileCharacteristics == FID_FILE_CHAR_PARENT)
	    continue;

	if( fid->lengthFileIdent == uLen
	    && memcmp( fid->impUseAndFileIdent, uName, fid->lengthFileIdent) == 0 )
	    return fid;
    }
    logUdfInfo("[findFileIdentDesc] passed 282  \n");  //TODO
    return NULL;
}

/*
 *	Return pointer to new FileEntry in a 2k allocated block to be free'd when no longer required.
 *	Only basic data is filled in. 
 */
struct fileEntry* makeFileEntry() 
{
	regid msWRUDF = { 0, "Microsoft IMAPI2 1.0", "\x06"};
	regid entityWRUDF = { 0, "-wrudf (1.02)", "\x04\x05"};
    struct fileEntry *fe = (struct fileEntry*) calloc(2048, 1);
    memset(fe,0,2048);
//    struct logicalVolHeaderDesc* lvhd = (struct logicalVolHeaderDesc*)lvid->logicalVolContentsUse;

    updateTimestamp(0,0);
    fe->descTag.tagIdent = TAG_IDENT_FE;
    fe->descTag.descVersion = 2;
    fe->descTag.tagSerialNum = 1; // 暂时是1
    fe->icbTag.strategyType = 4;
    fe->icbTag.numEntries = 1;
    fe->icbTag.fileType = ICBTAG_FILE_TYPE_REGULAR;
	fe->icbTag.flags = (fe->icbTag.flags & ~ICBTAG_FLAG_AD_MASK) | ICBTAG_FLAG_AD_SHORT;
    /* User has all permission; Group/Others Read/Exec */
    fe->permissions = FE_PERM_U_READ | FE_PERM_U_WRITE | FE_PERM_U_DELETE | FE_PERM_U_CHATTR | FE_PERM_U_EXEC |
	FE_PERM_G_READ | FE_PERM_G_EXEC | FE_PERM_O_READ | FE_PERM_O_EXEC;
    fe->fileLinkCount = 1;
    fe->accessTime = timeStamp;
    fe->modificationTime = timeStamp;
    fe->attrTime = timeStamp;
    fe->impIdent = msWRUDF;
//    fe->impIdent.identSuffix[0] = 6;
//    fe->uniqueID = lvhd->uniqueID++;
    return fe;
}

struct extendedFileEntry* makeFileEntryEx()
{
	struct extendedFileEntry *efe;
	regid msWRUDF = { 0, "Microsoft IMAPI2 1.0", "\x06"};
	regid entityWRUDF = { 0, "-wrudf (1.02)", "\x04\x05"};
    efe = (struct extendedFileEntry*) calloc(2048, 1);

    updateTimestamp(0,0);
    efe->descTag.tagIdent = TAG_IDENT_EFE;
    efe->descTag.descVersion = 3;
    efe->descTag.tagSerialNum = 1; // 暂时是1
    efe->icbTag.strategyType = 4;
    efe->icbTag.numEntries = 1;
    efe->icbTag.fileType = ICBTAG_FILE_TYPE_REGULAR;
	efe->icbTag.flags = (efe->icbTag.flags & ~ICBTAG_FLAG_AD_MASK) | ICBTAG_FLAG_AD_SHORT;
    /* User has all permission; Group/Others Read/Exec */
    efe->permissions = FE_PERM_U_READ | FE_PERM_U_WRITE | FE_PERM_U_DELETE | FE_PERM_U_CHATTR | FE_PERM_U_EXEC |
	FE_PERM_G_READ | FE_PERM_G_EXEC | FE_PERM_O_READ | FE_PERM_O_EXEC;
    efe->fileLinkCount = 1;
    efe->accessTime = timeStamp;
    efe->modificationTime = timeStamp;
    efe->attrTime = timeStamp;
	efe->createTime = timeStamp;
    efe->impIdent = msWRUDF;
	return efe;
}

int updateFePermissionsEx(struct extendedFileEntry* efe, char* filepath)
{
	struct stat fileStat;
	stat(filepath,&fileStat);

   	efe->uid = 0xFFFFFFFF;
    efe->gid = 0xFFFFFFFF;
    efe->permissions = 0x318C;
    
	efe->logicalBlocksRecorded = ((fileStat.st_size + 2047) & ~2047) >> 11;
	if ( efe->logicalBlocksRecorded == 0)
		efe->logicalBlocksRecorded = 1;
	
	return 0;
}

int updateFePermissions(struct fileEntry* fe, char* filepath)
{
	struct stat fileStat;
	stat(filepath,&fileStat);
	/*
	fe->uid = fileStat.st_uid;
    fe->gid = fileStat.st_gid;
    if( fileStat.st_mode & S_IRUSR ) fe->permissions |= FE_PERM_U_READ;
    if( fileStat.st_mode & S_IWUSR ) fe->permissions |= FE_PERM_U_WRITE | FE_PERM_U_DELETE | FE_PERM_U_CHATTR;;
    if( fileStat.st_mode & S_IXUSR ) fe->permissions |= FE_PERM_U_EXEC;
    if( fileStat.st_mode & S_IRGRP ) fe->permissions |= FE_PERM_G_READ;
    if( fileStat.st_mode & S_IWGRP ) fe->permissions |= FE_PERM_G_WRITE | FE_PERM_G_DELETE | FE_PERM_G_CHATTR;
    if( fileStat.st_mode & S_IXGRP ) fe->permissions |= FE_PERM_G_EXEC;
    if( fileStat.st_mode & S_IROTH ) fe->permissions |= FE_PERM_O_READ;
    if( fileStat.st_mode & S_IWOTH ) fe->permissions |= FE_PERM_O_WRITE | FE_PERM_O_DELETE | FE_PERM_O_CHATTR;;
    if( fileStat.st_mode & S_IXOTH ) fe->permissions |= FE_PERM_O_EXEC;
    if( fileStat.st_mode & S_ISUID ) fe->icbTag.flags |= ICBTAG_FLAG_SETUID;
    if( fileStat.st_mode & S_ISGID ) fe->icbTag.flags |= ICBTAG_FLAG_SETGID;
   */
   	fe->uid = 0xFFFFFFFF;
    fe->gid = 0xFFFFFFFF;
    fe->permissions = 0x318C;
    
	fe->logicalBlocksRecorded = ((fileStat.st_size + 2047) & ~2047) >> 11;
	if ( fe->logicalBlocksRecorded == 0)
		fe->logicalBlocksRecorded = 1;
	
	return 0;
}

/*
 *	Return pointer to new FileIdentDesc in an allocated block to be free'd when no longer required.
 *	Does NOT fill: descTag.checksum, descTag.tagLocation, icbTag.characteristics, icb
 */
struct fileIdentDesc* makeFileIdentDesc(char* name) 
{
    dchars uName[256];
    size_t uLen;
    struct fileIdentDesc *fid;
	
	memset(uName,0,256);
    fid = (struct fileIdentDesc*) calloc(512,1);
    memset(fid,0,512);
    fid->descTag.tagIdent = TAG_IDENT_FID;
	if (discBurnFSVer == 201)
		fid->descTag.descVersion = 3;
	else
    	fid->descTag.descVersion = 2;
    fid->descTag.tagSerialNum = 1;
    fid->fileVersionNum = 1;
    fid->icb.extLength = 2048;
//logUdfInfo("[makeFileIdentDesc] name=%s \n",name); 
    if( name[0] != 0 ) {				/* FID to parent directory has no name */
	uLen = utf8_TO_utf16(uName + 1, name, 127);
	uName[0] = 16;
	uLen++;
	//uLen = encode_locale(uName, name, 256);
	if (uLen == (size_t)-1) {
		uLen = 1;
		uName[0] = 0x8;
	}
//	logUdfInfo("[makeFileIdentDesc] uName[2]=%s \n",uName[0]); 
	fid->lengthFileIdent = uLen;
	memcpy(fid->impUseAndFileIdent + fid->lengthOfImpUse, uName, fid->lengthFileIdent);
    }
    return fid;
}

int makeDir2Tree(char* dirname, char* topath)
{
	char name[FNAMELENMAX];
	char* tmpStr;
	struct stfiledir *tmpST;
	struct stfiledir *tmpST2;
	int ret = 0;
	
	tmpST = calloc (sizeof(struct stfiledir), 1); //需要calloc刷新空间全为0
	tmpST2 = calloc (sizeof(struct stfiledir), 1);
	
	strcpy(tmpST->name, dirname);

	tmpST->isDataRecorded = 0;
	tmpST->isDir = 1;
	tmpST->stfd = tmpST2;
	tmpST->datalen = 40; // ".."文件夹的fid大小就正好是40
	tmpST->fidlen = (count_utf8(tmpST->name) + 1 + sizeof(struct fileIdentDesc) + 3) & ~3; //TODO strlen中文不行

	strcpy(tmpST2->name, "..");
	tmpST2->isDataRecorded = 0;
	tmpST2->isDir = 0;
	tmpST2->pdirfd = tmpST;
	tmpST2->fidlen = 40;
	
	ret = linkNode2Tree(tmpST,topath);
	if (ret == 0)
		contrlfilenum(0,1);
	else
	{
		free(tmpST);
		free(tmpST2);
	}	
	
	
	return ret;
}

char *cutPathName(char* filepath,char* retName)
{
	char* tmpStr;
	tmpStr = strrchr(filepath, '/');
	if (tmpStr != NULL)
	{
		tmpStr += 1;
	}
	else
		tmpStr = filepath;
	dchars *uName;
	uName = calloc (FNAMELENMAX, 1);
	size_t uLen;
	uLen = utf8_TO_utf16(uName + 1, tmpStr, 127);
	uName[0] = 16;
	uLen++;
	decode_locale((dchars *)(uName), retName, uLen, FNAMELENMAX - 1);
	free(uName);
	logUdfInfo("[cutPathName] retName=[%s] \n",retName);
	return retName;
}

int copyFile2Tree(char* filepath, char* topath, struct stat *st)
{ //stRootDir
	char* tmpStr;
	struct stfiledir *tmpST;
	int ret = 0;
	
	tmpST = calloc (sizeof(struct stfiledir), 1); //需要calloc刷新空间全为0
	tmpStr = strrchr(filepath, '/');
	if (tmpStr != NULL)
	{
		tmpStr += 1;
	}
	else
		tmpStr = filepath;
	logUdfInfo("[copyFile2Tree] copy %s ,only name(%s) to %s \n",filepath,tmpStr,topath);
	//考虑到超长文件名在截断之后可能会与已有的重名，所以name这里就用转换成utf16后再转换回utf8的内容
   
    if( tmpStr[0] != 0 ) 
	{
		dchars *uName;
		uName = calloc (FNAMELENMAX, 1);
		size_t uLen;
		//logUdfInfo("[copyFile2Tree] utf8_TO_utf16 strlen tmpStr=[%u] \n",strlen(tmpStr));
		//logUdfInfo("[copyFile2Tree] utf8_TO_utf16 sizeof tmpStr=[%u] \n",sizeof(tmpStr));
		uLen = utf8_TO_utf16(uName + 1, tmpStr, 127);
		logUdfInfo("[copyFile2Tree] utf8_TO_utf16 tmpStr uLen=[%u] \n",uLen);
		uName[0] = 16;
		uLen++;
		uLen = decode_locale((dchars *)(uName), tmpST->name, uLen, FNAMELENMAX - 1);
		//logUdfInfo("[copyFile2Tree] decode_locale tmpST->name, uLen=[%u] \n",uLen);
		free(uName);
		logUdfInfo("[copyFile2Tree] tmpST->name=[%s] \n",tmpST->name);
		
	}
	else
		strncpy(tmpST->name, tmpStr,64);
	logUdfInfo("[copyFile2Tree] after tran tmpST->name= [%s] \n",tmpST->name);
	tmpST->path = calloc (strlen(filepath)+1, 1);
	strcpy (tmpST->path, filepath);
	tmpST->datalen = st->st_size;
	tmpST->isDataRecorded = 0;
	tmpST->isDir = 0;
	//sizeof(struct fileIdentDesc)=38
	tmpST->fidlen = (count_utf8(tmpST->name) + 1 + sizeof(struct fileIdentDesc) + 3) & ~3;	//TODO strlen中文不行
	logUdfInfo("[copyFile2Tree] count_utf8(tmpST->name)=[%d],sizeof(struct fileIdentDesc)=[%d]\n",count_utf8(tmpST->name),sizeof(struct fileIdentDesc));
	ret = linkNode2Tree(tmpST,topath);
	if (ret == 0)
		contrlfilenum(1,0);
	else
	{
		free(tmpST);
	}
	return ret;
}

struct stfiledir *delNode4Tree(char* filepath)
{
	
	char* tmpStr;
	char* strDir;
	struct stfiledir *currDir; //这里是currNode
	struct stfiledir *lastDir; //这里是lastNode
	struct stfiledir *nextDir;

	strDir = calloc (DNAMELENMAX, 1); //暂时只给了每个文件夹名称DNAMELENMAX的限制
	currDir = stRootDir;

	do  //从头开始数还有'/'分割文件夹
	{
		logUdfInfo("[delNode4Tree] delpath = %s \n",filepath);
		if ((tmpStr = strchr(filepath, '/')) != NULL)
		{
			memset(strDir,0,DNAMELENMAX);
			strncpy(strDir,filepath,tmpStr - filepath);
			
			logUdfInfo("[delNode4Tree] curr st = %s \n",strDir);
			do
			{
				if (strcmp(currDir->name,strDir) == 0)
				{
					if (currDir->isDir == 1)
					{
						lastDir = currDir;
						currDir = currDir->stfd;
						filepath = tmpStr + 1;
						break;
					}
					else
					{//因为最后还有/的情况下找到了非文件夹 所以不能执行删除了
						if (strDir) 
						free(strDir);
						return NULL;
					}

				}
				else
				{
					lastDir = currDir;
					currDir = currDir->rfd;
				}
			}while(currDir != NULL);
			
		}
		else
		{
			memset(strDir,0,DNAMELENMAX);
			strcpy(strDir,filepath);
			logUdfInfo("[delNode4Tree] curr st = %s \n",strDir);
			do
			{
				if (strcmp(currDir->name,strDir) == 0)
				{
					break;
				}
				else
				{
					lastDir = currDir;
					currDir = currDir->rfd;
				}
			}while(currDir != NULL);
			break;
		}
	}while(currDir != NULL);
	if (strDir) 
		free(strDir);
	strDir = NULL;
	
	if (currDir != NULL)
	{
		//找到了这个节点 移除这个节点的链接 清理内存的操作留到上一层函数
		lastDir->rfd = currDir->rfd;
		currDir->pdirfd->datalen = currDir->pdirfd->datalen - currDir->fidlen;   //上级文件夹的data长度提前计算
	}
	else
	{
		return NULL;
	}

	return currDir;
}

int linkNode2Tree(struct stfiledir *newst, char* topath)
{
	char* tmpStr;
	char* strDir;
	struct stfiledir *currDir;
	struct stfiledir *lastDir;
	struct stfiledir *nextDir;
	int cmpNum;
	strDir = calloc (DNAMELENMAX, 1); //暂时只给了每个文件夹名称128的限制
	currDir = stRootDir;
	// 先寻找文件夹 文件夹最后的 '/' 已经被上个函数拿掉了
	do  //从头开始数还有'/'分割文件夹
	{
		logUdfInfo("[linkNode2Tree] topath = %s \n",topath);
		if ((tmpStr = strchr(topath, '/')) != NULL)
		{
			memset(strDir,0,DNAMELENMAX);
			strncpy(strDir,topath,tmpStr - topath);
			
			logUdfInfo("[linkNode2Tree] curr st = %s \n",strDir);
			do
			{
				if ((currDir->isDir == 1) && (strcmp(currDir->name,strDir) == 0))
				{
					topath = tmpStr + 1;
					currDir = currDir->stfd;
					break;
				}
				else
				{
					currDir = currDir->rfd;
				}
			}while(currDir != NULL);
			if (strlen(topath) == 0) //用来处理topath最后的时候有个/的情况
			{
				currDir = currDir->pdirfd;
				break;
			}
		}
		else
		{
			memset(strDir,0,DNAMELENMAX);
			strcpy(strDir,topath);
			logUdfInfo("[linkNode2Tree] curr st = %s \n",strDir);
			do
			{
				if ((currDir->isDir == 1) && (strcmp(currDir->name,strDir) == 0))
				{
					break;
				}
				else
				{
					currDir = currDir->rfd;
				}
			}while(currDir != NULL);
			break;
		}
		
	}while(currDir != NULL);
	
	if (strDir) 
		free(strDir);
	if(currDir == NULL)
	{
		logUdfError("[linkNode2Tree] curr dir cant find \n");
		return FILETOPATHERROR;
	}
	logUdfInfo("[linkNode2Tree] curr insert dir = %s \n",currDir->name);

	//把newst放到指定文件夹内 currDir
	//假设所有文件都是排序过的 但是".."始终在第一位
	currDir = currDir->stfd;
	lastDir = currDir;
	if (strcmp(currDir->name,"..") == 0)
		currDir = currDir->rfd;

	if (currDir == NULL) //说明".."之后没有文件了 那就放在".."后面即可
	{
		newst->rfd = lastDir->rfd;
		lastDir->rfd = newst;
		newst->pdirfd = lastDir->pdirfd;

		newst->pdirfd->datalen += newst->fidlen;   //上级文件夹的data长度提前计算
		return 0;
	}	

	//先检查本层有没有同名文件 TODO
	/*
	while((currDir != NULL) && (currDir->isDir == 1))  //实际上不需要假设文件夹都在前面的情况，这边文件夹和文件按照文件名直接排序了
	{
		lastDir = currDir;
		currDir = currDir->rfd;
	}
	*/
	while(currDir != NULL)
	{
		cmpNum = strcmp(newst->name,currDir->name);
		if (cmpNum < 0)
		{
			break;
		}
		else if (cmpNum > 0)
		{
			lastDir = currDir;
			currDir = currDir->rfd;
		}
		else if (cmpNum == 0)
		{
			logUdfError("[linkNode2Tree] same file/dir name find \n");
			//做个删除和替换 TODO
			return FILENAMEERROR;
		}
	}
	
	logUdfInfo("[linkNode2Tree] insert stfd pos lastDir->name = %s \n",lastDir->name);
	newst->rfd = lastDir->rfd;
	lastDir->rfd = newst;
	newst->pdirfd = lastDir->pdirfd;
	newst->pdirfd->datalen += newst->fidlen;  //上级文件夹的data长度提前计算
	logUdfInfo("[linkNode2Tree] newst->fidlen = %d \n",newst->fidlen);
	if (newst->rfd != NULL)
		logUdfInfo("[linkNode2Tree] insert already newst->rfd->name = %s \n",newst->rfd->name);
	
	return 0;
}

int AddFileDir2List(char *filepath,char* topath,int isrecorded,int isdir,struct stprefiledirlist *stpfdl)
{ //stPreFileList
	struct stprefiledir *currfd;
	struct stprefiledir *nextfd;
	struct stat st;
	uint64_t fileSize;
	
	if (isdir == 0 && isrecorded == 0)
	{//新加入的文件要统计大小 
		if (stat(filepath,&st) == -1)
		{
			logUdfError("[AddFileDir2List] get path %s error\n",filepath);
			return FILESTATUSERROR;
		}
		stpfdl->allAddFileSizeBlock += ((st.st_size + 2047) & ~2047) >> 11;
	}
	currfd = calloc(sizeof(struct stprefiledir),1);
	currfd->filePath = calloc(strlen(filepath) + 1,1);
	strcpy(currfd->filePath,filepath);
	currfd->toPath = calloc(strlen(topath) + 1,1);
	strcpy(currfd->toPath,topath);
	if ((strlen(currfd->toPath) > 2) && (currfd->toPath[strlen(currfd->toPath) - 1] == '/'))
		currfd->toPath[strlen(currfd->toPath) - 1] = '\0';  //把最后的/消除
	currfd->isRecorded = isrecorded;
	currfd->isDir = isdir;
	currfd->prev = stpfdl->fdEnd;
	if (isdir == 0)
		stpfdl->dirNum ++;
	else
		stpfdl->fileNum ++;

	if (stpfdl->fdStart == NULL)
		stpfdl->fdStart = stpfdl->fdEnd = currfd;
	else
		stpfdl->fdEnd = stpfdl->fdEnd->next = currfd;

	return 0;
}

int DelFileDirList(struct stprefiledirlist *stpfdl)
{
	struct stprefiledir *currfd;
	struct stprefiledir *lastfd;
	currfd = stpfdl->fdStart;
	while (currfd != NULL)
	{
		if (currfd->filePath)
			free (currfd->filePath);
		if (currfd->toPath)
			free (currfd->toPath);
		lastfd = currfd;
		currfd = currfd->next;
		free(lastfd);
		lastfd = NULL;
	}
	stpfdl->fdStart = NULL;
	stpfdl->fdEnd = NULL;
	stpfdl->dirNum = 0;
	stpfdl->fileNum = 0;
	stpfdl->allAddFileSizeBlock = 0;
	return 0;
}

char *DealWithBlankCmd(char *instr)
{
	char *ret;
	ret  = calloc(2000,1);
	strcpy(ret,instr);

	free(ret);
	return instr;
}











