#include "disk-burn-window.h"


static void
quit (GtkWidget *widget, gpointer data)
{
    g_print ("%s\n", __func__);
    gtk_main_quit ();
}

char*
get_window_geometry_string (GtkWindow *window)
{
    char *str;
    int w, h, x, y;

    g_return_val_if_fail (GTK_IS_WINDOW (window), NULL);
    g_return_val_if_fail (gtk_window_get_gravity (window) ==
                GDK_GRAVITY_NORTH_WEST, NULL);

    gtk_window_get_position (window, &x, &y);
    gtk_window_get_size (window, &w, &h);

    str = g_strdup_printf ("%dx%d+%d+%d", w, h, x, y);

    return str;
}

static gboolean
geometry_string_changed (GtkWindow *window,
                        GdkEvent  *event,
                        gpointer user_data)
{
    g_return_val_if_fail (GTK_WINDOW (window) != NULL, GDK_EVENT_PROPAGATE);
    // g_print ("geometry string:%s\n", get_window_geometry_string (GTK_WINDOW (window)));
    return GDK_EVENT_PROPAGATE;
}


int 
main (int argc, char* argv[])
{
    gtk_init (&argc, &argv);
    g_print ("start %s\n", __func__);
    printf ("argc=[%d]\n",argc);
    bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
    bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
    textdomain (GETTEXT_PACKAGE);

    GtkWidget *window;
    char *geometry_string;

    if (argc < 3)
        window = disk_burn_window_new ("/dev/sr0", "/home/nfs/m1");
    else
        window = disk_burn_window_new (argv[1], argv[2]);
    // 显示当前窗口
    geometry_string = get_window_geometry_string (GTK_WINDOW (window));
    g_print ("geometry_string:%s\n", geometry_string);

    g_signal_connect (window, "configure-event",
                    G_CALLBACK(geometry_string_changed), window);

    g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (quit), NULL);

    gtk_main ();

    return 0;
}