#include<stdio.h>

#include<stdarg.h>
#include<string.h>
#include<fcntl.h>
#include<time.h>
#include<sys/time.h>
#include"utils.h"
#include"wrctl.h"

void logUdfInfo(char *fmt, ...) {
#ifdef LOGUDFINFO
    va_list	args;

    va_start(args, fmt); 
    vfprintf(stdout, fmt, args);
#endif
}

void logUdfDebug(char *fmt, ...) {
#ifdef LOGUDFDEBUG
    va_list	args;

    va_start(args, fmt); 
    vfprintf(stdout, fmt, args);
#endif
}

void logUdfError(char *fmt, ...) {
#ifdef LOGUDFERROR
    va_list	args;

    va_start(args, fmt); 
    vfprintf(stdout, fmt, args);
#endif
}

void logPrintX(char *inStr, int len) 
{
	int i ;
	uint8_t a,b;
	printf("logPrintX start print HEX\n");
	for ( i = 0; i < len; i+=2)
	{
		/*		
		a = inStr[i] & 0x0F;
		a = a << 4;
		b = inStr[i+1] & 0x0F;
		b = b << 4;
		*/
		a = inStr[i];
		b = inStr[i+1];
		printf("%X %X ",a,b);
		if ( ((i+2) % 32) == 0 && (i != 0) )
			printf("\n");
	}
	printf("\n");
}



int setutils()
{
	return 0;
}

void updateTimestamp(uint32_t t, uint32_t ut) 
{
    struct timeval	timev;
    struct tm		time;
    int			offset;


	gettimeofday(&timev, NULL);
 

    localtime_r( &timev.tv_sec, &time);
    offset = time.tm_gmtoff / 60;
    timeStamp.typeAndTimezone = 0x1000 + (offset & 0x0FFF);		/* 1/3.7.1 */
    timeStamp.year = time.tm_year + 1900;
    timeStamp.month = time.tm_mon + 1;
    timeStamp.day = time.tm_mday;
    timeStamp.hour = time.tm_hour;
    timeStamp.minute = time.tm_min;
    timeStamp.second = time.tm_sec;
    timeStamp.centiseconds = timev.tv_usec / 10000;
    timeStamp.hundredsOfMicroseconds = (timev.tv_usec / 100) % 100;
    timeStamp.microseconds = timev.tv_usec % 100 ;
}

uint32_t getTimeuint()
{
	struct timeval	timev;
    struct tm		time;
    int			offset;
	gettimeofday(&timev, NULL);
	localtime_r( &timev.tv_sec, &time);
	uint32_t ret = 0;
	ret = time.tm_hour*10000 + time.tm_min*100 + time.tm_sec;
	return ret;
}

size_t RunCurrCmd(char *runCmd, char *cmdOut, size_t cmdOutLen)
{
	size_t ret = 0;
	FILE *cmdFp = NULL;
	if (cmdOut == NULL)
		return ret;
	cmdFp = popen(runCmd,"r"); //popen可以读取的最大长度 131071 bytes.
	
	ret = fread(cmdOut,1,cmdOutLen,cmdFp);
	
	fclose(cmdFp);
	
	return ret;
}
