#include<stdio.h>
#include"wrctl.h"
#include"ecma_167.h"
#include"osta_udf.h"
#include"utils.h"

#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <linux/cdrom.h>		/* for CDROM_DRIVE_STATUS  */

//在这里作为addrec之后的中间层接口文件


#define MAXPKTBUFS	4
struct packetbuf {
    uint32_t		inuse;
    uint32_t		dirty;
    uint32_t		bufNum;
    uint32_t		start;
    unsigned char	*pkt;
};


static unsigned char *verifyBuffer;					/* for verify only */
static unsigned char *blockBuffer = NULL;
static int sectortype;
Directory	*rootDir, *curDir; //因为用法太多太特殊必须设置的全局变量

timestamp	timeStamp;
uint32_t *vat;
uint32_t *multiStart;
double discFSVer = 0;
double discBurnFSVer = 0;
uint32_t currTrack = 0xFFFF;
uint32_t addIsoBlocks;
uint16_t virtualPartitionNum = 0xFFFF;
static unsigned int usedBlockNum;
volatile struct stfiledir *stRootDir;
struct stprefiledirlist  stPreFileList;
static struct countfile countfilenum;
static struct partitionDesc wpd;
static uint32_t phyblkno;
static uint64_t uniqueID;
static FILE* pfile = NULL;
int initUdfDev(char *devname)
{
	struct packetbuf *pb;
    int		rv;
    off_t	off;
    ssize_t	len;
    struct stat filestat;
    struct cdrom_discinfo  *di;
    struct cdrom_trackinfo *ti;
    u_char *buffer;
    struct cdrom_writeparams *wp;
    uint16_t	ident;
	
	di = getdiscinfo();
	ti = getlasttrackinfo();
//判断设备类型
	if( (rv = stat(devname, &filestat)) < 0 )
	{
		printf("[initudfdev] stat failed\n");
		return -1;
	}
	int modetype=filestat.st_mode;
	printf("[initudfdev] devtype filestat.st_mode=[%d]\n",modetype);
/*如果是普通文件 disk image of a UDF volume */
	if( S_ISREG(filestat.st_mode) ) 		
	{
		printf("[initudfdev]  S_ISREG  true \n");
		return -1;
		setudfdevicetype(DISK_IMAGE);
		int fd = open(devname, O_RDWR);
		if( fd < 0 ) 
		{
			printf("[initudfdev]  initIO: open file %s failed\n", devname);
		}
		else
		{
			printf("[initudfdev]  initIO: open file %s succeed\n", devname);
			setudfdevice(fd);
		}
	}
/* block文件，实际上判断光驱是这个文件 */
	if( S_ISBLK(filestat.st_mode) )
	{
		printf("[initudfdev]  S_ISBLK  true \n");
		int fd = open(devname, O_RDONLY | O_NONBLOCK);
		if ( fd < 0 )
		{
			printf("[initudfdev]   open device %s failed\n", devname);
			return -1;
		}
		else
		{
			printf("[initudfdev]   open device %s succeed\n", devname);
			setudfdevice(fd);
		}
	}
#ifdef PATCH_USE_SG_IO
    openMediaSGIO(getudfdevice());
#else
	
#endif
	/* heuristically determine medium imitated on disk image based on VAT FileEntry in block 512 */
/*	
	off = lseek(getudfdevice(), 2048 * 512, SEEK_SET);
	if( off == (off_t)-1 )
	{
	    printf("[initudfdev] lseek %s failed: \n", devname);
	    return -1;
	}
	len = read(getudfdevice(), &ident, 2);
	if( len < 0 )
	{
	    printf("[initudfdev] read %s failed: \n", devname);
	    return -1;
	}
	if( len != 2 )
	{
	    printf("[initudfdev] read %s failed: \n", devname);
	    return -1;
	}
	setudfmedium(ident == TAG_IDENT_VDP ? CDR : CDRW);

	printf("[initudfdev] CDR=1,CDRW=2  getudfmedium=%d\n",getudfmedium());
*/

//不释放这个申请空间 但是也不会重新申请
	
    if( blockBuffer == NULL )
	{
		blockBuffer = malloc(2048);
		if( blockBuffer == NULL )
			printf("[initudfdev] malloc blockBuffer failed\n");
	}

//读取光盘状态
	rv = ioctl(getudfdevice(), CDROM_DRIVE_STATUS);	
    if( (rv != CDS_DISC_OK) && (rv != CDS_NO_INFO) )
	{
		printf("[initudfdev] No disc or not ready\n");	
	}
	else
	{
		printf("[initudfdev] disc ready rv=%d\n",rv);	
	}
//读取光盘信息
    if( read_discinfo(getudfdevice(), di) )
	printf("[initudfdev] Read discinfo failed\n");
//判断是否是不可擦写光盘
    if( di->erasable == 0 ) {
	
	printf("[initudfdev] CDR disc\n");
    } else {
	
	printf("[initudfdev] CDRW disc\n");
    }
	printf("[initudfdev] di->disc_id = [%u]\n",di->disc_id);
	
	
	printf("[initudfdev] di->trk1_lastsession=%d\n",di->trk1_lastsession);

	
//读取最后一个轨道的信息
    if( read_trackinfo(getudfdevice(), ti, di->trk1_lastsession) )	/* last track 1 in last session writable for UDF */
    {
    	printf("[initudfdev] read_trackinfo failed\n");
	}

	printf("[initudfdev] ti->fixpkt=%d\n",ti->fixpkt);

	printf("[initudfdev] ti->fixpkt_size=%d\n",ti->fixpkt_size);
    
	printf("[initudfdev] ti->trk_start=%d\n",ti->trk_start);  //与growisofs读取出来的下次刻录位置相同， 有用的数值
	printf("[initudfdev] ti->trk_size=%d\n",ti->trk_size);
    printf("[initudfdev] ti->data_length=%d\n",ti->data_length);
    printf("[initudfdev] ti->data_mode=%d\n",ti->data_mode);
    if( ti->data_mode == 1 )
	sectortype = 2;					/* for readCD() */
    else if( ti->data_mode == 2 )
	sectortype = 4;



	return 0;
}

int closeUdfDev()
{
	printf("[closeUdfDev] before close\n");

//init申请的空间在这里释放	
//	if (blockBuffer != NULL)
//		free(blockBuffer);
//	blockBuffer = NULL;
	close(getudfdevice());
	printf("[closeUdfDev] after close\n");
	return 0;
}

void setChecksum(void *descriptor) 
{
    uint32_t	sum;
    int		i;
    tag		*descTag = (tag*) descriptor;

    descTag->descCRC = udf_crc((uint8_t*)descTag + sizeof(tag), descTag->descCRCLength, 0);
    descTag->tagChecksum = sum = 0;
    for( i = 0; i < 16; i++ )
	sum += *((uint8_t*)descTag + i);
    descTag->tagChecksum = (uint8_t) sum;
}

void* readSingleBlock(uint32_t pbn)
{
	int ret;
    off_t off;
    ssize_t len;
//直接读取设备
#ifdef PATCH_USE_SG_IO
	ret = readCDex(getudfdevice(), sectortype, pbn, 1, blockBuffer);
#else
	ret = readCD(getudfdevice(), sectortype, pbn, 1, blockBuffer);
#endif
	if( ret ) 
	{
		printf("[readSingleBlock] errno = %d , strerror = %s \n",errno,strerror(errno));
		return NULL;
	} else 
	    return blockBuffer;
}

//读取单独的tag ，并且校验crc
void* readTaggedBlock(uint32_t lbn, uint16_t partition) 
{
    int		i;
    uint8_t	sum, *p;
    struct generic_desc *block=NULL;
    block = (struct generic_desc*) readCDR(lbn, partition);
	if (block == NULL)
	{
		return block;
	}
    if( block->descTag.tagIdent == 0x0000 ) {
	/* ignore not ISO 13346 defined descriptors with 0 tags */
	if( strncmp((char *)((struct sparingTable*)block)->sparingIdent.ident, UDF_ID_SPARING, strlen(UDF_ID_SPARING)) != 0 ) {
	    for( i = 0; i < 2048; i++ ) {
		if( ((uint8_t*)block)[i] != 0 ) {
		    printf("readTaggedBlock: Empty block %d not all zeroes\n", lbn);
		    break;
		}
	    }
	    return block;
	}
    }
//校验crc
    for( i = 0, sum = 0, p = (uint8_t*)block; i< 16; i++ )
	if( i != 4 )
	    sum += *(p + i);

    if( block->descTag.tagChecksum != sum )
		printf("readTagged: Checksum error in block %d\n", lbn);

    if( block->descTag.descCRC != udf_crc((uint8_t*)block + sizeof(tag), ((tag*)block)->descCRCLength, 0) )
		printf("readTagged: CRC error in block %d\n", lbn);
//	printf("readTagged: CRC check passed in block %d\n", lbn);	
	return block;
}



uint32_t setPartitionDesc(struct partitionDesc *tmpd)
{
	memcpy(&wpd,tmpd,sizeof(struct partitionDesc));
	
	return 0;
}

uint32_t getPhysical(uint32_t lbn, uint16_t part) 
{
    if( part == 0xFFFF ) 
		return lbn;
	else if( part == virtualPartitionNum && vat != NULL )
		lbn = vat[lbn] + wpd.partitionStartingLocation;
	else
	{
		lbn =  lbn + wpd.partitionStartingLocation;
	}
	return lbn;
}

unsigned char*	readCDR(uint32_t lbn, uint16_t partition) 
{
    int		stat;
    uint32_t	pbn = getPhysical(lbn, partition);
#ifdef PATCH_USE_SG_IO
    stat = readCDex(getudfdevice(), sectortype, pbn, 1, blockBuffer);
#else
	stat = readCD(getudfdevice(), sectortype, pbn, 1, blockBuffer);
#endif
    if( stat ) {

	    printf("[readCDR] errno = %d , strerror = %s \n",errno,strerror(errno));
		return NULL;
    }
    return blockBuffer;
}    

void freeBlock(uint32_t lbn, uint16_t part) 
{
	return;
}

void* readBlock(uint32_t lbn, uint16_t part) 
{
    struct packetbuf *b;
    uint32_t	physical = getPhysical(lbn, part);

	return readCDR(physical, ABSOLUTE);
}

int readExtents(char* dest, int usesShort, void* extents) 
{
    uint	len, blkno, partitionNumber;
    char	*p;
    long_ad	*lo;
    short_ad	*sh;
	logUdfInfo("[readExtents] usesShort = %d \n",usesShort);
    if( usesShort ) {
	sh = (short_ad*) extents;
	len = sh->extLength;
	blkno = sh->extPosition;
	partitionNumber  = 0;

    } else {
	lo = (long_ad*) extents;
	len = lo->extLength;
	blkno = lo->extLocation.logicalBlockNum;
	partitionNumber = lo->extLocation.partitionReferenceNum;
    }
    if (len == 0)
    	return -1;
	logUdfInfo("[readExtents] len = %d ,blkno = %d\n",len,blkno);

    for(;;) {
	p = readBlock(blkno, partitionNumber);
	memcpy(dest, p, 2048);
	freeBlock(blkno, partitionNumber);
	dest += 2048;
	if( len < 2048 )
	    break;
	if( len == 0 ) {
	    if( usesShort ) {
		sh++;
		len = sh->extLength;
		blkno = sh->extPosition;
	    } else {
		lo++;
		len = lo->extLength;
		blkno = lo->extLocation.logicalBlockNum;
		partitionNumber = lo->extLocation.partitionReferenceNum;
	    }
	    if( len == 0 )
		break;
	    continue;
	}
	len -= 2048;
	blkno++;
    } 
    return 0;
}

int patchAddUdfFs(char *isoFileName)
{
	
	pfile = fopen(isoFileName, "rb+");
	uint32_t startPosByte;
	uint32_t blkno,len;
	uint32_t numPD,numLVD,numFSD,numUSD,numUSE,oriStartBlock;
	long_ad			*fsdAd;
	long_ad			*icb;
	short_ad		*tmpSd;
	struct generic_desc *tmpDesc;
	struct generic_desc *tmpAVDP;
	struct partitionDesc *tmpPD;
	struct logicalVolDesc *tmpLVD;
	struct unallocSpaceDesc *tmpUSD;
	struct fileSetDesc		*tmpFSD;
	struct fileEntry      *tmpFE;
	struct unallocSpaceEntry *tmpUSE;
	int inMainSeq;
	regid *tmpRegid;
	sizeof(struct fileEntry);
	tmpDesc = malloc (DVDBLOCKS);
	if ( tmpDesc == NULL )
	{
		logUdfError("[patchAddUdfFs] tmpDesc = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	tmpAVDP = malloc (DVDBLOCKS);
	if ( tmpAVDP == NULL )
	{
		logUdfError("[patchAddUdfFs] tmpAVDP = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	tmpPD = malloc (DVDBLOCKS); //因为读取函数一次读取2048字节
	if ( tmpPD == NULL )
	{
		logUdfError("[patchAddUdfFs] tmpPD = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	tmpLVD = malloc (DVDBLOCKS);
	if ( tmpLVD == NULL )
	{
		logUdfError("[patchAddUdfFs] tmpLVD = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	tmpUSD = malloc (DVDBLOCKS);
	if ( tmpUSD == NULL )
	{
		logUdfError("[patchAddUdfFs] tmpUSD = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	tmpFSD = malloc (DVDBLOCKS);
	if ( tmpFSD == NULL )
	{
		logUdfError("[patchAddUdfFs] tmpFSD = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	tmpFE = malloc (DVDBLOCKS);
	if ( tmpFE == NULL )
	{
		logUdfError("[patchAddUdfFs] tmpFE = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	tmpUSE = malloc (DVDBLOCKS);
	if ( tmpUSE == NULL )
	{
		logUdfError("[patchAddUdfFs] tmpUSE = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	
//	startPosByte = multiStart[getdiscinfo()->trk1_lastsession-2] * DVDBLOCKS;
//先读取AVDP 处理AVDP关于主卷描述符的位置修改
	memset(tmpAVDP,0,DVDBLOCKS);

	readFileBlock(pfile, 256, tmpAVDP);

	blkno = ((struct anchorVolDescPtr*)tmpAVDP)->mainVolDescSeqExt.extLocation;
    len = ((struct anchorVolDescPtr*)tmpAVDP)->reserveVolDescSeqExt.extLength;
//	logPrintX(tmpAVDP,2048);
	logUdfInfo("[patchAddUdfFs]find LVD&USD blkno = %d , len = %d \n",blkno,len);
	
//寻找PD和LVD和USD位置
	memset(tmpPD,0,DVDBLOCKS);
	memset(tmpLVD,0,DVDBLOCKS);
//AVDP获取的位置正确，但是我们处理的文件是追加镜像，所以需要减去前面没有的部分
	blkno -= multiStart[getdiscinfo()->trk1_lastsession-1];
    for(int i = 0; i < len; blkno++, i += 2048 ) 
    {
		readFileBlock(pfile, blkno, tmpDesc);
		
		switch( tmpDesc->descTag.tagIdent ) 
		{
		case TAG_IDENT_PVD:
	
			logUdfInfo("[patchAddUdfFs] find TAG_IDENT_PVD\n");
			break;
		case TAG_IDENT_VDP:
			blkno = ((struct volDescPtr*)tmpDesc)->nextVolDescSeqExt.extLocation - 1;
			blkno -= multiStart[getdiscinfo()->trk1_lastsession-1];
			len   = ((struct volDescPtr*)tmpDesc)->nextVolDescSeqExt.extLength;
			i = (uint32_t) -2048;
			logUdfInfo("[patchAddUdfFs] find TAG_IDENT_VDP\n");
			break;
		case TAG_IDENT_IUVD:
			break;
		case TAG_IDENT_PD:
			// must have one (re)writable partition 
			// may have at most one RDONLY partition 
			logUdfInfo("[patchAddUdfFs] find TAG_IDENT_PD tmpDesc->accessType = %d \n",((struct partitionDesc *)tmpDesc)->accessType);
			switch( ((struct partitionDesc *)tmpDesc)->accessType ) {
			case PD_ACCESS_TYPE_READ_ONLY:
			case PD_ACCESS_TYPE_REWRITABLE:
			case PD_ACCESS_TYPE_WRITE_ONCE:
			case PD_ACCESS_TYPE_OVERWRITABLE:
			if( tmpDesc->volDescSeqNum > tmpPD->volDescSeqNum )
				memcpy(tmpPD, tmpDesc, 512);
			numPD = blkno;
			logUdfInfo("[patchAddUdfFs] TAG_IDENT_PD tmpDesc->volDescSeqNum = %d ,blkno = %d \n",tmpDesc->volDescSeqNum,blkno);
			break;
			default:
			printf("[patchAddUdfFs] What to do with an accesstype %d partition?\n", 
				((struct partitionDesc*)tmpDesc)->accessType);
			break;
			}
			break;
		case TAG_IDENT_LVD:
			logUdfInfo("[patchAddUdfFs] TAG_IDENT_LVD tmpDesc->volDescSeqNum = %d ,blkno = %d \n",tmpDesc->volDescSeqNum,blkno);
			if( tmpDesc->volDescSeqNum > tmpLVD->volDescSeqNum )
			memcpy(tmpLVD, tmpDesc, 512);
			numLVD = blkno;
			break;
		case TAG_IDENT_USD:
			logUdfInfo("[patchAddUdfFs] TAG_IDENT_USD tmpDesc->volDescSeqNum = %d ,blkno = %d \n",tmpDesc->volDescSeqNum,blkno);
			if( tmpDesc->volDescSeqNum > tmpUSD->volDescSeqNum )
				memcpy(tmpUSD, tmpDesc, 512);
			numUSD = blkno;
			break;
		case TAG_IDENT_USE:
			logUdfInfo("[patchAddUdfFs] TAG_IDENT_USE tmpDesc->volDescSeqNum = %d ,blkno = %d \n",tmpDesc->volDescSeqNum,blkno);
			if( tmpDesc->volDescSeqNum > tmpUSD->volDescSeqNum )
				memcpy(tmpUSE, tmpDesc, DVDBLOCKS);
			numUSE = blkno;
			break;
		case TAG_IDENT_TD:
			i = len;
			break;
		default:
			logUdfInfo("[patchAddUdfFs] Unexpected tag ID %04X  in Volume Descriptor Sequence block %d \n", tmpDesc->descTag.tagIdent, blkno);
		}
    }
//改分区PD表描述符
	logUdfInfo("[patchAddUdfFs] tmpPD->partitionStartingLocation = %d \n",tmpPD->partitionStartingLocation);	
	logUdfInfo("[patchAddUdfFs] tmpPD->partitionLength = %d \n",tmpPD->partitionLength);
	tmpPD->accessType = PD_ACCESS_TYPE_READ_ONLY;
	//tmpPD->partitionNumber = wpd.partitionNumber;
	oriStartBlock = tmpPD->partitionStartingLocation;
	tmpPD->partitionStartingLocation = wpd.partitionStartingLocation;
	tmpPD->partitionLength = tmpPD->partitionLength + oriStartBlock - wpd.partitionStartingLocation;
	regid msWRUDF = { 0, "Microsoft IMAPI2 1.0", "\x06"};
//	memcpy(&(tmpPD->impIdent),&msWRUDF,32);
	//不论何种spacemap 这边都删除标识位 ECMA167-2rd搜+NSR02 提到partitionContentsUse需要写入Partition Header Descriptor
	// Partition Header Descriptor全都空则删除spacemap
	memset(tmpPD->partitionContentsUse,0,128);
	setChecksum(tmpPD);
	writeFileBlock(pfile, numPD, tmpPD, 512);
	logUdfInfo("[patchAddUdfFs] after patch tmpPD->partitionStartingLocation = %d \n",tmpPD->partitionStartingLocation);	
//处理第二PD
	
//寻找文件组描述符FSD位置
	fsdAd = (long_ad*) tmpLVD->logicalVolContentsUse;
	logUdfInfo("[patchAddUdfFs] tmpLVD->logicalVolContentsUse.extLocation.logicalBlockNum = %d \n",  fsdAd->extLocation.logicalBlockNum);
	
    for(int i = 0; i < (fsdAd->extLength >> 11); i++ ) {
	blkno =  (oriStartBlock - multiStart[getdiscinfo()->trk1_lastsession-1]) + fsdAd->extLocation.logicalBlockNum + i; //blkno = 288 + i
	readFileBlock(pfile, blkno, tmpDesc);
	
	switch( tmpDesc->descTag.tagIdent ) {
	case TAG_IDENT_TD:
	    i = fsdAd->extLength;
	    break;
	case TAG_IDENT_FSD:

	    memcpy(tmpFSD, tmpDesc, 512);
		numFSD = blkno;
	    logUdfInfo("[patchAddUdfFs] File Set Descriptor find at blkno = %d \n",blkno);
	    break;
	default:
	    logUdfInfo("[patchAddUdfFs] Unxpected tag id %d, where File Set Desc(256) expected\n", tmpDesc->descTag.tagIdent);
	}
    }

    if( !tmpFSD )
		logUdfError("[patchAddUdfFs] No File Set Descriptor\n");
//改FSD文件组描述符 改 rootDirectoryICB (指向file entry的指针)
	logUdfInfo("[patchAddUdfFs] tmpFSD tmpFSD->descTag.tagLocation = %d \n",tmpFSD->descTag.tagLocation); 
	tmpFSD->descTag.tagLocation = fsdAd->extLocation.logicalBlockNum + oriStartBlock - wpd.partitionStartingLocation;
	logUdfInfo("[patchAddUdfFs] after patch tmpFSD tmpFSD->descTag.tagLocation = %d \n",tmpFSD->descTag.tagLocation); 
//	tmpFSD->descTag.descVersion = 1;
	tmpRegid = &(tmpFSD->domainIdent);
//	tmpRegid->ident[2] = 1;
	if (memcmp(tmpRegid->ident, UDF_ID_COMPLIANT, strlen(UDF_ID_COMPLIANT)))
	{
		logUdfInfo("[patchAddUdfFs] tmpFSD tmpRegid->ident = %s \n",tmpRegid->ident);
	}

	icb = &(tmpFSD->rootDirectoryICB);
	logUdfInfo("[patchAddUdfFs] tmpFSD icb->extLength = %d \n",icb->extLength);  //TODO
	logUdfInfo("[patchAddUdfFs] tmpFSD icb->extLocation.logicalBlockNum = %d \n",icb->extLocation.logicalBlockNum);  //TODO
 	logUdfInfo("[patchAddUdfFs] tmpFSD icb->extLocation.partitionReferenceNum = %d \n",icb->extLocation.partitionReferenceNum);  //TODO
	
	icb->extLocation.logicalBlockNum = oriStartBlock + icb->extLocation.logicalBlockNum - wpd.partitionStartingLocation;
	logUdfInfo("[patchAddUdfFs] after patch tmpFSD icb->extLocation.logicalBlockNum = %d \n",icb->extLocation.logicalBlockNum);  //TODO
// 	streamDirectoryICB应该清除
	tmpFSD->streamDirectoryICB.extLength = 0;
	tmpFSD->streamDirectoryICB.extLocation.logicalBlockNum = 0;
	tmpFSD->streamDirectoryICB.extLocation.partitionReferenceNum = 0;
//	memset(tmpFSD->fileSetIdent,0,32);
//	memset(tmpFSD->copyrightFileIdent,0,32);
//	memset(tmpFSD->abstractFileIdent,0,32);
	
	setChecksum(tmpFSD);
	writeFileBlock(pfile, numFSD, tmpFSD, 512);


//改逻辑卷LVD表描述符
	fsdAd->extLocation.logicalBlockNum = fsdAd->extLocation.logicalBlockNum + oriStartBlock - wpd.partitionStartingLocation;

	logUdfInfo("[patchAddUdfFs] after patch fsdAd->extLocation.logicalBlockNum = %d \n",  fsdAd->extLocation.logicalBlockNum);
	setChecksum(tmpLVD);
	writeFileBlock(pfile, numLVD, tmpLVD, 512);
//改第二个逻辑卷LVD表描述符
	// numLVD = 1186;
	// readFileBlock(pfile, numLVD, tmpDesc);
	// memcpy(tmpLVD, tmpDesc, 512);
	// fsdAd = (long_ad*) tmpLVD->logicalVolContentsUse;
	// fsdAd->extLocation.logicalBlockNum = fsdAd->extLocation.logicalBlockNum + oriStartBlock - wpd.partitionStartingLocation;
	// setChecksum(tmpLVD);
//	writeFileBlock(pfile, numLVD, tmpLVD, 512);
//USD的修改
//	memset(tmpUSD,0,DVDBLOCKS);
//	if (numUSD != 0)
//		writeFileBlock(pfile, numUSD, tmpUSD, DVDBLOCKS);
//消除 Unallocated Space Entry 在fsd前一个的block
//	memset(tmpUSE,0,DVDBLOCKS);
//	if (numUSE != 0)
//		writeFileBlock(pfile, numUSE, tmpUSE, DVDBLOCKS);
//	迁移file entry和fileIdentDesc 
	patchAddUdfFsFe(icb->extLocation.logicalBlockNum);



endx:

	free(tmpDesc);
	free(tmpAVDP);
	free(tmpPD);
	free(tmpLVD);
	free(tmpUSD);
	free(tmpFSD);
	free(tmpFE);
	free(tmpUSE);

	return 0;
}

int patchAddUdfFsFe(uint32_t feBlock)
{
	//pfile
	uint32_t startPosByte;
	uint32_t blkno,len;
	uint32_t numPD,numLVD,numFSD,oriStartBlock;
	long_ad			*tmpLd;
	long_ad			*icb;
	short_ad		*tmpSd;
	struct generic_desc *tmpDesc;
	struct fileEntry      *tmpFE;
	struct extendedFileEntry      *tmpEFE;
	struct fileIdentDesc *tmpFid;
	
	tmpDesc = malloc (DVDBLOCKS);
	if ( tmpDesc == NULL )
	{
		logUdfError("[patchAddUdfFsFe] tmpDesc = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	tmpFE = malloc (DVDBLOCKS);
	if ( tmpFE == NULL )
	{
		logUdfError("[patchAddUdfFsFe] tmpFE = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}
	tmpEFE = malloc (DVDBLOCKS);
	if ( tmpEFE == NULL )
	{
		logUdfError("[patchAddUdfFsFe] tmpEFE = malloc (DVDBLOCKS) failed \n");
		exit(-1);
	}

	if (discBurnFSVer == 201)
	{
		blkno = 320;
		readFileBlock(pfile, blkno, tmpDesc);
		memcpy(tmpEFE, tmpDesc, 2048);
		logUdfInfo("[patchAddUdfFsFe] (tmpEFE->icbTag.flags & ICBTAG_FLAG_AD_MASK) = %u \n",(tmpEFE->icbTag.flags & ICBTAG_FLAG_AD_MASK));
		if( (tmpEFE->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_IN_ICB ) 
		{
			//memcpy(tmpFid, fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr, fe->lengthAllocDescs);
			//memset(fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr, 0, fe->lengthAllocDescs);
			tmpFid = tmpEFE->extendedAttrAndAllocDescs + tmpEFE->lengthExtendedAttr;
			icb =&(tmpFid->icb);
			logUdfInfo("[patchAddUdfFsFe] tmpEFE->icb->extLocation.logicalBlockNum = %d \n",icb->extLocation.logicalBlockNum);  //TODO
			icb->extLocation.logicalBlockNum = feBlock;
			logUdfInfo("[patchAddUdfFsFe]  tmpFid->descTag.tagLocation = %d \n",tmpFid->descTag.tagLocation);
			tmpFid->descTag.tagLocation = feBlock;
			setChecksum(tmpFid);
			logUdfInfo("[patchAddUdfFsFe] after patch tmpEFE->icb->extLocation.logicalBlockNum = %d \n",icb->extLocation.logicalBlockNum);
		} 


		tmpEFE->descTag.tagLocation = feBlock;
		logUdfInfo("[patchAddUdfFsFe] tmpEFE tmpEFE->descTag.tagLocation = %d \n",tmpEFE->descTag.tagLocation);
		logUdfInfo("[patchAddUdfFsFe] tmpEFE->descTag.tagLocation = %d \n",tmpEFE->descTag.tagLocation);
		setChecksum(tmpEFE);

		writeFileBlock(pfile, blkno, tmpEFE, 2048);
	}
	else
	{
		blkno = 304;
		readFileBlock(pfile, blkno, tmpDesc);
		memcpy(tmpFE, tmpDesc, 2048);

		if( (tmpFE->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_IN_ICB ) 
		{
			//memcpy(tmpFid, fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr, fe->lengthAllocDescs);
			//memset(fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr, 0, fe->lengthAllocDescs);
			tmpFid = tmpFE->extendedAttrAndAllocDescs + tmpFE->lengthExtendedAttr;
			icb =&(tmpFid->icb);
			logUdfInfo("[patchAddUdfFsFe] tmpFE->icbTag.flags ICBTAG_FLAG_AD_IN_ICB \n");
			logUdfInfo("[patchAddUdfFsFe] tmpFE->icb->extLocation.logicalBlockNum = %d \n",icb->extLocation.logicalBlockNum);  //TODO
			icb->extLocation.logicalBlockNum = feBlock;
			logUdfInfo("[patchAddUdfFsFe]  tmpFid->descTag.tagLocation = %d \n",tmpFid->descTag.tagLocation);
			tmpFid->descTag.tagLocation = feBlock;
			setChecksum(tmpFid);
			logUdfInfo("[patchAddUdfFsFe] after patch tmpFE->icb->extLocation.logicalBlockNum = %d \n",icb->extLocation.logicalBlockNum);
		} 	
			
		logUdfInfo("[patchAddUdfFsFe] tmpFE tmpFE->descTag.tagLocation = %d \n",tmpFE->descTag.tagLocation);
		tmpFE->descTag.tagLocation = feBlock;
		logUdfInfo("[patchAddUdfFsFe] tmpFE->descTag.tagLocation = %d \n",tmpFE->descTag.tagLocation);
		setChecksum(tmpFE);

		writeFileBlock(pfile, blkno, tmpFE, 2048);	
	}
	free(tmpDesc);
	free(tmpFE);
	free(tmpEFE);
	return 0;
}

int contrlfilenum(uint32_t filenum,uint32_t dirnum)
{
	countfilenum.filenum += filenum;
	countfilenum.dirnum += dirnum;
	return 0;
}

int InitBlankRootsTree(char* dirname)
{
	char name[FNAMELENMAX];
	char* tmpStr;
	struct stfiledir *tmpST2;
	int ret = 0;
	
	stRootDir = calloc (sizeof(struct stfiledir), 1); //需要calloc刷新空间全为0
	tmpST2 = calloc (sizeof(struct stfiledir), 1);
	
	strcpy(stRootDir->name, dirname);

	stRootDir->isDataRecorded = 0;
	stRootDir->isDir = 1;
	stRootDir->stfd = tmpST2;
	stRootDir->datalen = 40; // ".."文件夹的fid大小就正好是40
	stRootDir->fidlen = (count_utf8(stRootDir->name) + 1 + sizeof(struct fileIdentDesc) + 3) & ~3; //strlen中文不行

	strcpy(tmpST2->name, "..");
	tmpST2->isDataRecorded = 0;
	tmpST2->isDir = 0;
	tmpST2->pdirfd = stRootDir;
	tmpST2->fidlen = 40;

	contrlfilenum(0,1);
	uniqueID = 0;

	return 0 ;
}

int initStRootDirTree()
{
	//把旧session的已有文件做成文件树 (但是只有名称和层级) , 不做文件管理器，不需要读出文件属性和长度，因为剩余空间可以由discinfo导出
	// struct stfiledir *stRootDir;

//	struct extendedFileEntry      *efe;
    struct fileIdentDesc *fid;
    uint64_t		i;
    char		*data;
    dchars              uName[256];
    size_t              uLen;
    char* name;
    
	stRootDir = calloc(sizeof(struct stfiledir),1); //不然初始化不全是0会有问题
	stRootDir->isDir = 1;
	stRootDir->isDataRecorded = 1;
	memset(stRootDir->name,0,FNAMELENMAX);
	stRootDir->name[0] = '.';
	
	if (discBurnFSVer == 201)
	{//udf 2.01
		stRootDir->efe = calloc(DVDBLOCKS,1);
		memcpy(stRootDir->efe, curDir->fe, 2048);
		stRootDir->datalen = stRootDir->efe->informationLength;
	}
	else
	{
		stRootDir->fe = calloc(DVDBLOCKS,1);
		memcpy(stRootDir->fe, curDir->fe, 2048);
		stRootDir->datalen = stRootDir->fe->informationLength;
	}
	
	stRootDir->data = malloc (stRootDir->datalen);
	memcpy(stRootDir->data, curDir->data, stRootDir->datalen);
	
	countfilenum.filenum = 0;
	countfilenum.dirnum = 1;
	uniqueID = 0;
	addDir2RootDirTree(stRootDir->data, stRootDir->datalen, stRootDir); 

	return 0;
}
//只处理刻录好的文件 dirFid是在stDir的FE中找到的第一个dirFid,dataLength是dirFid组合的长度,stDir是当前工作目录的结构体 
int addDir2RootDirTree(char *dirFid, uint32_t dataLength, struct stfiledir *stDir)
{
	//只处理刻录好的文件  遇到已经刻录的文件里有文件夹的情况，用这个函数把文件夹里的文件都加到文件树里

	struct stfiledir *newst;
	struct stfiledir *lastst;

	struct fileEntry	*tmpblock;
    struct fileIdentDesc *fid;

    uint64_t		i;
    uint32_t		fidlen;
    char		*data;
    char	*name;
	
	if (dataLength == 0)  //是空文件夹
		return 0;
		
    fidlen = 0;
	data = dirFid;


    for( i = 0; i < dataLength; i += fidlen ) 
	{
		//fidlen是本fid的长度  后面的4位补齐是ECMA167的要求
		fid = (struct fileIdentDesc*)(data + i);

		fidlen = (sizeof(struct fileIdentDesc) + fid->lengthOfImpUse + fid->lengthFileIdent + 3) & ~3 ;

		if( fid->fileCharacteristics & FID_FILE_CHAR_DELETED  ) 
			continue;
		
		lastst = newst;
		newst = calloc(sizeof(struct stfiledir),1);
		
		//先把上个结构体指向这个结构体的指针做好
		if( i == 0 )
			stDir->stfd = newst;
		else
			lastst->rfd = newst;

		newst->isDataRecorded = 1;  //既然是已经刻录的内容 这个位置设置1
		newst->pdirfd = stDir;
		memset(newst->name,0,FNAMELENMAX);  //把名称数组清零一下，以免拷贝的文件名没带最后的结束符
		
		newst->fid = (struct fileIdentDesc*) calloc (fidlen,1);
		
		memcpy(newst->fid, fid, fidlen);
		newst->fidlen = fidlen;
		if( fid->fileCharacteristics & FID_FILE_CHAR_PARENT )
		{	
		//是上级文件夹 
			strcpy(newst->name, "..");
			//newst->isDir == 1;
			newst->fidlen = 40;
			logUdfInfo("[addDir2RootDirTree] newst->name %s \n", newst->name);
			continue;
		}
		//多一步操作，因为readTaggedBlock用的空间是readTaggedBlock共用的，而且这个数据实际长度可能比2048短，所以先拷贝到指定位置再申请一次
		tmpblock = readTaggedBlock( fid->icb.extLocation.logicalBlockNum, fid->icb.extLocation.partitionReferenceNum);
		if (discBurnFSVer == 201)
		{//udf 2.01
			newst->efe = calloc (2048,1);
			memcpy(newst->efe, tmpblock,2048);
			uniqueID = (newst->efe->uniqueID > uniqueID)? newst->efe->uniqueID : uniqueID;  //记录最大uniqueID
		}
		else
		{
			newst->fe = calloc (2048,1);
			memcpy(newst->fe, tmpblock,2048);
			uniqueID = (newst->fe->uniqueID > uniqueID)? newst->fe->uniqueID : uniqueID;  //记录最大uniqueID
		}

		decode_locale((dchars *)(fid->impUseAndFileIdent + fid->lengthOfImpUse), newst->name, fid->lengthFileIdent, FNAMELENMAX - 1);
		logUdfInfo("[addDir2RootDirTree] newst->name %s ,newst->fidlen = %d \n", newst->name,newst->fidlen);
		
		if( fid->fileCharacteristics & FID_FILE_CHAR_DIRECTORY ) 
		{	
		//是文件夹 转换文件名 递归处理文件夹内容			
			newst->isDir = 1;
			contrlfilenum(0,1);
			//拷贝文件夹fe存的每个文件（夹）的fid
			if (discBurnFSVer == 201)
				copyDirData(newst->efe, newst);
			else
				copyDirData(newst->fe, newst);
			
			addDir2RootDirTree(newst->data, newst->datalen, newst);
		}
		else
		{	//是文件
			contrlfilenum(1,0);
			if (discBurnFSVer == 201)
				newst->datalen = newst->efe->informationLength;
			else
				newst->datalen = newst->fe->informationLength;
			
		}
		//logUdfInfo("[addDir2RootDirTree] newst->name %s ,newst->datalen = %u \n", newst->name,newst->datalen);
	}
	

	
	return 0;
}

int copyDirData(struct fileEntry  *fe, struct stfiledir *stDir)
{
	int ret = 0;
	struct  extendedFileEntry      *efe;
	if (discBurnFSVer == 201)
	{//udf2.01
		efe = fe;
		if( (efe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_IN_ICB ) 
		{
			logUdfInfo("[copyDirData] ICBTAG_FLAG_AD_IN_ICB \n");  //TODO
			stDir->data = malloc (efe->lengthAllocDescs);  //是stDIR元素的data ,最后统一释放
			stDir->datalen = efe->lengthAllocDescs;
			memcpy(stDir->data, efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr, efe->lengthAllocDescs);
			memset(efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr, 0, efe->lengthAllocDescs);
			
		} 
		else
		{
			stDir->data = malloc(2048);  //是stDIR元素的data ,最后统一释放
			stDir->datalen = efe->informationLength;
			logUdfInfo("[copyDirData] efe->informationLength = %d \n",efe->informationLength);  //TODO
			if( efe->informationLength > 2048 ) 
			{
				uint64_t len = (efe->informationLength + 2047) & ~2047;
				stDir->data = realloc(stDir->data, len);
				if( !(stDir->data) ) 
				{
					printf("[copyDirData] Realloc directory data failed\n");
					return -1;
				}			
			}

			ret = readExtents(stDir->data, (efe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_SHORT,
			efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr);
			if (ret == -1)
				stDir->datalen = 0;
		}
	}
	else
	{
		if( (fe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_IN_ICB ) 
		{
			logUdfInfo("[copyDirData] ICBTAG_FLAG_AD_IN_ICB \n");  //TODO
			stDir->data = malloc (fe->lengthAllocDescs);  //是stDIR元素的data ,最后统一释放
			stDir->datalen = fe->lengthAllocDescs;
			memcpy(stDir->data, fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr, fe->lengthAllocDescs);
			memset(fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr, 0, fe->lengthAllocDescs);
			
		} 
		else
		{
			stDir->data = malloc(2048);  //是stDIR元素的data ,最后统一释放
			stDir->datalen = fe->informationLength;
			logUdfInfo("[copyDirData] fe->informationLength = %d \n",fe->informationLength);  //TODO
			if( fe->informationLength > 2048 ) 
			{
				uint64_t len = (fe->informationLength + 2047) & ~2047;
				stDir->data = realloc(stDir->data, len);
				if( !(stDir->data) ) 
				{
					printf("[copyDirData] Realloc directory data failed\n");
					return -1;
				}			
			}

			ret = readExtents(stDir->data, (fe->icbTag.flags & ICBTAG_FLAG_AD_MASK) == ICBTAG_FLAG_AD_SHORT,
			fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr);
			if (ret == -1)
				stDir->datalen = 0;
		}
	}
	return 0;
}

int reDirTreePre(struct stfiledir* stDir, fpstFD cbFun)
{
	struct stfiledir* currst;
	struct stfiledir* nextst;
	if(stDir == NULL || cbFun == NULL)
	{
		logUdfError("[reDirTreePre] stDir == NULL || cbFun == NULL \n");
		return 0;
	}
	
	nextst = stDir;
	for (uint32_t i = 1; i < 4294967295; i++)
	{
		currst = nextst;
//		logUdfInfo("[reDirTreePre] currst->name %s \n", currst->name);  //TODO
		(*cbFun)(currst);		
		if ( currst->isDir == 1 )
		{
			if ( currst->stfd != NULL )
			{
				reDirTreePre(currst->stfd, cbFun);
			}
		}
		if (currst->rfd == NULL)
		{
			logUdfInfo("[reDirTreePre] currst->rfd = NULL \n");  //TODO
			break;
		}
		else
			nextst = currst->rfd;
		
	}
//	logUdfInfo("[reDirTreePre]leave reDirTreePre \n");  //TODO
	return 0;
}

int reDirTree(struct stfiledir* stDir, fpstFD cbFun)
{
	struct stfiledir* currst;
	struct stfiledir* nextst;
	if(stDir == NULL || cbFun == NULL)
	{
		logUdfError("[reDirTree] stDir == NULL || cbFun == NULL \n");
		return 0;
	}
//	logUdfInfo("[reDirTree] stDir->name %s \n", stDir->name);  //TODO
	nextst = stDir;
	for (uint32_t i = 1; i < 4294967295; i++)
	{
		currst = nextst;

		if ( currst->isDir == 1 )
		{
			if ( currst->stfd != NULL )  //实际上没有空文件夹，里面最少有个".."文件
			{

				reDirTree(currst->stfd, cbFun);
			}
		}
		if (currst->rfd == NULL)
		{
			logUdfInfo("[reDirTree] passed 852 ,currst->rfd = NULL \n");  //TODO
			(*cbFun)(currst);
			break;
		}
		else
			nextst = currst->rfd;
		(*cbFun)(currst);
	}
//	logUdfInfo("[reDirTree]leave reDirTree \n");  //TODO
	return 0;
}

int delStNode(struct stfiledir *stDir)
{
//	logUdfInfo("[delStNode] stDir->name %s ", stDir->name);
	
	if (stDir == NULL)
		return 0;
	if (stDir->fid != NULL)
		free(stDir->fid);
	stDir->fid = NULL;
	if (stDir->fe != NULL)
		free(stDir->fe);
	stDir->fe = NULL;
	if (stDir->efe != NULL)
		free(stDir->efe);
	stDir->efe = NULL;
	if (stDir->data != NULL)
		free(stDir->data);
	stDir->data = NULL;
	if (stDir->path != NULL)
		free(stDir->path);
	stDir->path = NULL;
	free(stDir);
	stDir = NULL;
//	logUdfInfo("deleted\n ");
	return 0;
}
int clearCountFileNum()
{
	countfilenum.filenum = 0;  //统计文件链表里多少个文件
	countfilenum.dirnum = 0;  //统计文件链表里多少个文件夹
	countfilenum.writeblkno = 0; //计算fe写入的位置blocks
	countfilenum.contentstartblkno = 0;  //计算文件内容写入的位置blocks
	countfilenum.offset = 0;  //有的文件夹内容过多，需要后移写入位置
	return 0;
}
int delStRootDirDescTree()
{
	//删除文件树里的任何申请的内存
	logUdfInfo("[delStRootDirDescTree] start \n");
	if (stRootDir != NULL)
		reDirTree(stRootDir,&delStNode);
	if (pfile != NULL)
	{
		fflush(pfile);
		fclose(pfile);
	}
	pfile = NULL;
	stRootDir = NULL; //delStNode的删除操作可能不能及时刷新stRootDir的值，需要在这里再次设置NULL

	clearCountFileNum();

	return 0;
}

int writeFDTree2Image(FILE *inpath,struct stfiledir *stDir)
{
	uint32_t rootFeStart; //追加镜像的根目录FE在305 block，所以要跳过304个block。
	if (discBurnFSVer == 201)
		rootFeStart = 320; 
	else
		rootFeStart = 304; 
	pfile = inpath;
	countfilenum.writeblkno = rootFeStart;
	//计算文件内容开始写入的位置blocks
	countfilenum.contentstartblkno = countfilenum.writeblkno + countfilenum.filenum + countfilenum.dirnum * 2 + countfilenum.offset;
	logUdfInfo("[writeFDTree2Image] countfilenum.filenum = %d , countfilenum.dirnum = %d \n",countfilenum.filenum,countfilenum.dirnum);
	countfilenum.writeblkno --; //因为每次写入之前才+1 所以提前减好
	logUdfInfo("[writeFDTree2Image] reDirTreePre(stDir, &writeFDNode2ISO) start,countfilenum.contentstartblkno =%d \n",countfilenum.contentstartblkno);
	reDirTreePre(stDir, &writeFDNode2ISO);
	pfile = NULL;
	return 0;
}

int writeFDTree2ISO()
{
	uint32_t rootFeStart; //追加镜像的根目录FE在305 block，所以要跳过304个block。
	if (discBurnFSVer == 201)
		rootFeStart = 320; 
	else
		rootFeStart = 304; 
	countfilenum.writeblkno = rootFeStart;
	//计算文件内容开始写入的位置blocks
	countfilenum.contentstartblkno = countfilenum.writeblkno + countfilenum.filenum + countfilenum.dirnum * 2 + countfilenum.offset;
	logUdfInfo("[writeFDTree2ISO] countfilenum.filenum = %d , countfilenum.dirnum = %d \n",countfilenum.filenum,countfilenum.dirnum);
	countfilenum.writeblkno --; //因为每次写入之前才+1 所以提前减好
	logUdfInfo("[writeFDTree2ISO] reDirTreePre(stRootDir, &writeFDNode2ISO) start,countfilenum.contentstartblkno =%d \n",countfilenum.contentstartblkno);
	reDirTreePre(stRootDir, &writeFDNode2ISO);
	return 0;
}

int writeFDNode2ISO(struct stfiledir *stDir)
{
	//先序
	struct fileEntry	*fe;
	struct extendedFileEntry *efe;
    struct fileIdentDesc *fid;
    struct fileEntry	*parentDirFe;
    uint32_t tmppos = 0;
    uint32_t recordBlocks;
//	logUdfInfo("[writeFDNode2ISO] stDir->name = %s \n",stDir->name);
	fe = stDir->fe;
	efe = stDir->efe;
	fid = stDir->fid;
	if((strcmp(stDir->name,"..") == 0) && (fid->fileCharacteristics & FID_FILE_CHAR_PARENT) )
	{
		//".."文件夹没有文件内容 处理结束
		return 0;
	}
	//先写入fe
	countfilenum.writeblkno ++;
	if (discBurnFSVer == 201)
		writeFileBlock(pfile, countfilenum.writeblkno, efe, 2048);
	else
		writeFileBlock(pfile, countfilenum.writeblkno, fe, 2048);	
	if ( stDir->isDir == 1 )
	{
		//写入文件夹内容
		
	//	logUdfInfo("[writeFDNode2ISO] isDIR = 1, name = %s ,writeblkno-1 = %d ,stDir->datalen = %d \n",stDir->name,countfilenum.writeblkno,stDir->datalen);
		if (stDir->datalen > DVDBLOCKS)
		{
			for(tmppos = 0;tmppos < stDir->datalen;tmppos += 2048)
			{
				countfilenum.writeblkno ++;
				writeFileBlock(pfile, countfilenum.writeblkno, stDir->data + tmppos, 2048);
			}
			//writeFileBlock(pfile, countfilenum.writeblkno, tmppos - 2048, stDir->data + 2048 - tmppos);
		}
		else if ((stDir->datalen > 0) && (stDir->datalen <= DVDBLOCKS))
		{
			countfilenum.writeblkno ++;
			writeFileBlock(pfile, countfilenum.writeblkno, stDir->data, stDir->datalen);
		}
		else
		{}
		
	}
	else
	{
		
		if (stDir->isDataRecorded == 0)
		{//需要把文件拷贝过来
			FILE* tmpfile;
			char* tmpcontent;
			uint32_t tmpsize;
			tmppos = 0;
			
			tmpfile = fopen(stDir->path, "rb");
			//文件夹的"文件内容"的位置 其实可以改成用fe里面的short_ad - 之前一段 的方式
			if (tmpfile == NULL)
			{
				logUdfError("[writeFDNode2ISO] tmpfile = %s open failed,str=%s\n",stDir->path,strerror(errno));
				if (discBurnFSVer == 201)
					countfilenum.contentstartblkno += efe->logicalBlocksRecorded; //这边是先用再加 
				else
					countfilenum.contentstartblkno += fe->logicalBlocksRecorded; //这边是先用再加 
				return 0;
			}

			tmpcontent = calloc(DVDBLOCKS,1);
			tmppos = countfilenum.contentstartblkno;
		//	logUdfInfo("[writeFDNode2ISO] file = %s , pos = %d ,stDir->datalen = %d \n",stDir->name,tmppos,stDir->datalen);
			
			if (stDir->datalen > DVDBLOCKS)
			{
				do{
					tmpsize = fread(tmpcontent, 1, DVDBLOCKS, tmpfile);
					writeFileBlock(pfile, tmppos, tmpcontent, tmpsize);
					tmppos ++;
				}while(tmpsize > 0);
			}
			else if ((stDir->datalen > 0) && (stDir->datalen <= DVDBLOCKS))
			{
				tmpsize = fread(tmpcontent, 1, stDir->datalen, tmpfile);
				writeFileBlock(pfile, tmppos, tmpcontent, tmpsize);
			}
			else
			{}
			
			free (tmpcontent);
			fclose(tmpfile);
			tmpfile = NULL;
			fflush(pfile);
			if (discBurnFSVer == 201)
				countfilenum.contentstartblkno += efe->logicalBlocksRecorded; //这边是先用再加 
			else
				countfilenum.contentstartblkno += fe->logicalBlocksRecorded; //这边是先用再加 
		}
		
	}
	
	return 0;
}
int updateCurrStTree(struct stfiledir *stDir)
{
	uint32_t rootFeStart,partStart; //追加镜像的根目录FE在305 block，所以要跳过304个block。
	//已知mkudffs生成的追加镜像的rootdir的fe开始位置
	if (discBurnFSVer == 201)
		rootFeStart = 320; 
	else
		rootFeStart = 304;
	
	partStart = 272; //新udf镜像的逻辑分区从272开始
	//计算fe写入的位置blocks
	countfilenum.writeblkno = rootFeStart - partStart;
	//计算文件内容开始写入的位置blocks 
	countfilenum.offset = 0;
	reDirTreePre(stDir, &updateStConStart);
	
	countfilenum.contentstartblkno = countfilenum.writeblkno + countfilenum.filenum + countfilenum.dirnum * 2 + countfilenum.offset;
	
	//遍历从根文件夹开始
	logUdfInfo("[updateCurrStTree] reDirTreePre(stRootDir, &updateStNode) start \n");
	if (discBurnFSVer == 201)
		reDirTreePre(stRootDir, &updateStNodeEx);
	else
		reDirTreePre(stRootDir, &updateStNode);
	
	//运行一遍历无法全都改完 crc留到第二次遍历
	logUdfInfo("[updateCurrStTree] reDirTree(stRootDir, &updateStNodeDir) start \n");
	if (discBurnFSVer == 201)
		reDirTree(stRootDir, &updateStNodeDirEx);
	else
		reDirTree(stRootDir, &updateStNodeDir);
	//还要计算具体需要多大的镜像文件
	addIsoBlocks = countfilenum.contentstartblkno + rootFeStart + 1000;
	return 0;
}
int updateStTree()
{
//	struct stfiledir *stRootDir; 把这个文件树填好fid和fe ，等待转换后写入镜像文件
	logUdfInfo("[updateStTree] start \n");

	short_ad		*tmpSd;
	uint32_t rootFeStart; //追加镜像的根目录FE在305 block，所以要跳过304个block。
	if (discBurnFSVer == 201)
		rootFeStart = 320; 
	else
		rootFeStart = 304; //已知mkudffs生成的追加镜像的rootdir的fe开始位置

	//计算fe写入的位置blocks
	
	countfilenum.writeblkno = multiStart[getdiscinfo()->trk1_lastsession-1] + rootFeStart - wpd.partitionStartingLocation;
	logUdfInfo("[updateStTree] countfilenum.writeblkno=%d\n",countfilenum.writeblkno);
	//计算文件内容开始写入的位置blocks 
	countfilenum.offset = 0;
	reDirTreePre(stRootDir, &updateStConStart);
	
	countfilenum.contentstartblkno = countfilenum.writeblkno + countfilenum.filenum + countfilenum.dirnum * 2 + countfilenum.offset;
	logUdfInfo("[updateStTree] countfilenum.contentstartblkno=%d\n",countfilenum.contentstartblkno);
	//遍历从根文件夹开始
	logUdfInfo("[updateStTree] reDirTreePre(stRootDir, &updateStNode) start \n");
	if (discBurnFSVer == 201)
		reDirTreePre(stRootDir, &updateStNodeEx);
	else
		reDirTreePre(stRootDir, &updateStNode);
	
	//运行一遍历无法全都改完 crc留到第二次遍历
	logUdfInfo("[updateStTree] reDirTree(stRootDir, &updateStNodeDir) start \n");
	if (discBurnFSVer == 201)
		reDirTree(stRootDir, &updateStNodeDirEx);
	else
		reDirTree(stRootDir, &updateStNodeDir);
	
	//还要计算具体需要多大的镜像文件
	addIsoBlocks = countfilenum.contentstartblkno - multiStart[getdiscinfo()->trk1_lastsession-1] + wpd.partitionStartingLocation + 1000 - rootFeStart;
	logUdfInfo("[updateStTree] addIsoBlocks=%d\n",addIsoBlocks);
	return 0;
}



int updateStConStart(struct stfiledir *stDir)
{
	uint32_t recordBlocks = 0;
	countStNodeAddTagLocation(stDir); //把每个fid位置算准确
	if ((stDir->isDir) && (strcmp(stDir->name,"..") != 0))  //只计算文件夹的内容长度 因为这部分在真的文件内容之前与fe混合储存的
	{
		recordBlocks = ((stDir->datalen + 2047) & ~2047) >> 11; //提前计算的数据可能有误差
		countfilenum.offset = countfilenum.offset + recordBlocks - 1;
	}
	
	return 0;
}

int updateStNodeDir(struct stfiledir *stDir)
{
	//文件夹需要处理data和长度 所以在这里再处理一次 后序
	struct fileEntry	*fe;
    struct fileIdentDesc *fid;
    struct fileEntry	*parentDirFe;
    short_ad		*tmpSd;
    
	fid = stDir->fid; 
	fe = stDir->fe; 
	if ( strcmp(stDir->name,".") != 0) //如果不是根目录
	{
		parentDirFe = (stDir->pdirfd)->fe;
		// if  short_ad
		tmpSd = (short_ad*) (parentDirFe->extendedAttrAndAllocDescs + parentDirFe->lengthExtendedAttr);
//		logUdfInfo("[updateStNodeDir] stDir->name = %s, fid->descTag.tagIdent == %d \n",stDir->name,fid->descTag.tagIdent);
		tmpSd->extLength += stDir->fidlen;
		//logPrintX(fid, stDir->fidlen);
		//保存到文件夹的data中
//		logUdfInfo("[updateStNodeDir] (stDir->pdirfd)->datalen = %d,stDir->fidlen = %d \n",
//		(stDir->pdirfd)->datalen,stDir->fidlen);
		memcpy((stDir->pdirfd)->data + (stDir->pdirfd)->datalen, fid, stDir->fidlen);
		(stDir->pdirfd)->datalen += stDir->fidlen;
		//if ((stDir->isDir == 1) && (strcmp(stDir->name,"..") != 0))
		//{
		//	logUdfInfo("[updateStNodeDir] isDir,name = %s  ,->datalen = %d \n",stDir->name,stDir->datalen);
		//	setChecksum(fe);
		//}
	}
	else
	{
//		logUdfInfo("[updateStNodeDir] isDir . ,->datalen = %d \n",stDir->datalen);
//		logPrintX(stDir->data, stDir->datalen);
		setChecksum(fe);
	}

	if (stDir->isDir) //是目录 处理一下informationLength
	{
//		logUdfInfo("[updateStNodeDir] isDir=1 ,name = %s ,->datalen = %d,fe->logicalBlocksRecorded = %d \n",stDir->name,stDir->datalen,fe->logicalBlocksRecorded);
		fe->informationLength = stDir->datalen;
		setChecksum(fe);
	}
	return 0;
}

int updateStNode(struct stfiledir *stDir)
{
//	从根目录开始。把这个文件树填好fid和fe ，等待转换后写入镜像文件
//	先序
	struct fileEntry	*fe;
	struct fileEntry	*parentDirFe;
    struct fileIdentDesc *fid;
    short_ad		*tmpSd;
	long_ad         *tmpAd;
    struct allocDescImpUse *tmpADIU;
    uint32_t recordBlocks;
    

	if (stDir->isDataRecorded)  //是记录过的文件 已经有fe和fid
	{
		fid = stDir->fid; //是记录过的文件 所以有这项
		fe = stDir->fe; //是记录过的文件 所以有这项
		//目前只能处理short_ad
		
		if((strcmp(stDir->name,"..") == 0) && (fid->fileCharacteristics & FID_FILE_CHAR_PARENT) )
		{
			//是".."上级文件夹 当做普通文件处理不设置isDir位置
			fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno ;//因为刚处理完的文件夹的FE就是这个位置
			fid->descTag.tagLocation = stDir->pdirfd->feblock + 1;
			fid->descTag.tagSerialNum = 1;
			setChecksum(fid);
			//".."文件夹没有文件内容 FE指向上一个 处理结束
			return 0;
		}
		  //接下来要处理文件内容
		 //stDir->fe已经占用下一个block了
		if ( stDir->isDir == 1 ) //作为文件夹应该用掉两个连续的block ，1个是fe另一个是fe存的连续fid
		{
			if ( strcmp(stDir->name,".") != 0) //如果不是根目录 根文件夹没有fid所以没有这些处理内容
			{
				//改fid指向fe的位置
				countfilenum.writeblkno ++;
				fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno;
				fid->descTag.tagLocation = stDir->pdirfd->feblock + 1 + stDir->fidoffset / 2048;  //利用提前算出来的位置
				fid->descTag.tagSerialNum = 1;
				setChecksum(fid);
			}
		//	logUdfInfo("[updateStNode] recorded stDir->name = %s, stDir->fidlen = %d \n",stDir->name,stDir->fidlen);
			fe->descTag.tagLocation = countfilenum.writeblkno;  //每个FE的tag的tagLocation位置必须与之对应
			fe->descTag.tagSerialNum = 1;
			stDir->feblock = countfilenum.writeblkno;
			//改fe中指向文件内容的logical blocks num
			tmpSd = (short_ad*) (fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr);
			countfilenum.writeblkno ++; //TODO 根据文件数量也许是用掉多个block
			tmpSd->extPosition = countfilenum.writeblkno;  //文件夹的"文件内容"在下一个block
			//分配文件夹data大小从这datalen算出
			recordBlocks = ((stDir->datalen + 2047) & ~2047) >> 11; //提前计算的数据可能有误差
			fe->logicalBlocksRecorded = recordBlocks;
			countfilenum.writeblkno = countfilenum.writeblkno + recordBlocks - 1; //writeblkno跳过文件夹内容占用的空间 刚才++了所以这边-1
			tmpSd->extLength = 0; //等本层文件夹遍历完才知道真实长度
			stDir->datalen = 0;
			//
			//每个文件夹的data空间被重新分配了
			if (stDir->data)
			{	
				free(stDir->data);
				stDir->data =(char*) calloc (recordBlocks * 2048 , 1);
			}
			else
				stDir->data =(char*) calloc (recordBlocks * 2048 , 1);
		
			
		}
		else  //处理文件
		{
			//改fid指向的fe的位置  fid不需要专门设置位置 ， 占用文件夹的文件内容位置 ！！！
			fid->descTag.tagLocation = stDir->pdirfd->feblock + stDir->fidoffset / 2048 + 1;
			fid->descTag.tagSerialNum = 1;
			countfilenum.writeblkno ++;
			fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno;
			
			stDir->feblock = countfilenum.writeblkno;
			fe->descTag.tagLocation = countfilenum.writeblkno;  //每个FE的tag的tagLocation位置必须与之对应
			fe->descTag.tagSerialNum = 1;
		//	logUdfInfo("[updateStNode] fe->logicalBlocksRecorded = %d \n",fe->logicalBlocksRecorded);
		//	logUdfInfo("[updateStNode] fe->icbTag.flags = %d \n",fe->icbTag.flags);
		//	logUdfInfo("[updateStNode] fe->icbTag.fileType = %d \n",fe->icbTag.fileType);
		//	logUdfInfo("[updateStNode] fid->descTag.descCRCLength = %d ,fid->fidlen = %d \n",fid->descTag.descCRCLength,stDir->fidlen);
		//	logUdfInfo("[updateStNode] fe->uniqueID = %d \n",fe->uniqueID);
			updateTimestamp(0,0);
			fe->accessTime = timeStamp;
			fe->modificationTime = timeStamp;
			fe->attrTime = timeStamp;
			setChecksum(fid);
			setChecksum(fe);
		}

	}
	else
	{ 	//需要生成新的fe和fid 确保写入的时候用的遍历方法和现在使用的方法完全一致 保证logicalblocks，物理blocks正确
		//填在哪个blocks ，可以用fe的extLength和extPosition来确定
		
		if(strcmp(stDir->name,"..") == 0) 
		{
		//".."文件夹没有文件内容 
			stDir->fid = makeFileIdentDesc("");
			fid = stDir->fid;
			stDir->fidlen = (sizeof(struct fileIdentDesc) + fid->lengthOfImpUse + fid->lengthFileIdent + 3) & ~3 ;
   			fid->fileCharacteristics = FID_FILE_CHAR_DIRECTORY | FID_FILE_CHAR_PARENT;
   			fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno ;//fe指向上一个位置的
			fid->descTag.tagLocation = stDir->pdirfd->feblock + 1;
			fid->descTag.tagSerialNum = 1;
			fid->descTag.descCRCLength = stDir->fidlen - sizeof(tag);
			setChecksum(fid);
			return 0;
		}
		
		if  ( stDir->isDir == 1 ) //处理新建的文件夹
		{
			stDir->fe = makeFileEntry();
			stDir->fid = makeFileIdentDesc(stDir->name);

   			fid = stDir->fid;
			fe = stDir->fe;
			if ( strcmp(stDir->name,".") != 0) //如果不是根目录 根文件夹没有fid所以没有这些处理内容
			{
				//改fid指向fe的位置
				++uniqueID;
				stDir->fidlen = (sizeof(struct fileIdentDesc) + fid->lengthOfImpUse + fid->lengthFileIdent + 3) & ~3 ;
				fid->fileCharacteristics = FID_FILE_CHAR_DIRECTORY;
				countfilenum.writeblkno ++;
				fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno ; //连贯存放fe的计算，之前文件夹的fe内容过长已经计算过了
				fid->descTag.tagLocation = stDir->pdirfd->feblock + stDir->fidoffset / 2048 + 1;  //对于fid来说是这样的虽然实际记录位置可能+2 +3
				fid->descTag.tagSerialNum = 1;
				fid->descTag.descCRCLength = stDir->fidlen - sizeof(tag);
				//处理 tmpADIU
				tmpADIU = fid->icb.impUse;
				tmpADIU->impUse[0] = uniqueID;
				setChecksum(fid);
			}
		//	logUdfInfo("[updateStNode] no recorded stDir->name = %s, stDir->fidlen = %d \n",stDir->name,stDir->fidlen);
			fe->descTag.tagLocation = countfilenum.writeblkno;  //每个FE的tag的tagLocation位置必须与之对应
			fe->descTag.tagSerialNum = 1;
			stDir->feblock = countfilenum.writeblkno;
			fe->uniqueID = 1;		
			fe->uid = 0xFFFFFFFF;
    		fe->gid = 0xFFFFFFFF;
    		fe->permissions = 0x35AD;
    		fe->fileLinkCount = 1;
    		fe->checkpoint = 1;
    		fe->lengthAllocDescs = sizeof(short_ad); //对应short_ad的大小
			fe->icbTag.fileType = ICBTAG_FILE_TYPE_DIRECTORY;
			//fe->icbTag.flags = fe->icbTag.flags | ICBTAG_FLAG_SORTED;
			tmpSd = (short_ad*) (fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr);
			countfilenum.writeblkno ++; //TODO 根据文件数量也许是用掉2个block
			tmpSd->extPosition = countfilenum.writeblkno;  //文件夹的"文件内容"在下一个block
			recordBlocks = ((stDir->datalen + 2047) & ~2047) >> 11; //提前计算的数据可能有误差
			fe->logicalBlocksRecorded = recordBlocks;
			countfilenum.writeblkno = countfilenum.writeblkno + recordBlocks - 1; //如果文件夹内容过长 需要
			tmpSd->extLength = 0; //等本层文件夹遍历完才知道真实长度
			stDir->datalen = 0;
			fe->descTag.descCRCLength = sizeof(struct fileEntry) + fe->lengthExtendedAttr + fe->lengthAllocDescs - sizeof(tag);
			if (stDir->data)
			{	
				free(stDir->data);
				stDir->data =(char*) calloc (recordBlocks * 2048 , 1);
			}
			else
				stDir->data =(char*) calloc (recordBlocks * 2048 , 1);
		}
		else //处理新建的文件
		{
			
			stDir->fe = makeFileEntry();
			stDir->fid = makeFileIdentDesc(stDir->name);
	
   			fid = stDir->fid;
			fe = stDir->fe;
			++uniqueID;
			//处理fid
			fid->descTag.tagLocation = stDir->pdirfd->feblock + stDir->fidoffset / 2048 + 1;
			fid->descTag.tagSerialNum = 1;
			countfilenum.writeblkno ++;
			fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno;
			
			stDir->fidlen = (sizeof(struct fileIdentDesc) + fid->lengthOfImpUse + fid->lengthFileIdent + 3) & ~3 ;
			fid->descTag.descCRCLength = stDir->fidlen - sizeof(tag);
		//	logUdfInfo("[updateStNode] fid->descTag.descCRCLength = %d ,fid->fidlen = %d \n",fid->descTag.descCRCLength,stDir->fidlen);
			//处理 tmpADIU
			tmpADIU = fid->icb.impUse;
			tmpADIU->impUse[0] = uniqueID;
			setChecksum(fid);
			//处理fe
			fe->descTag.tagLocation = countfilenum.writeblkno;  //每个FE的tag的tagLocation位置必须与之对应
			stDir->feblock = countfilenum.writeblkno;
			
			fe->uniqueID = uniqueID;
		//	logUdfInfo("[updateStNode] fe->uniqueID = %d \n",fe->uniqueID);
			fe->informationLength = stDir->datalen;
			updateFePermissions(fe,stDir->path);
			// 注意 大于 1073739776 的文件需要多个Sd来储存
			// 注意 大于 4294959104 的文件需要多个Ad来储存
			if (stDir->datalen > 4294959104)
			{
				int tmpTimes;
				fe->icbTag.flags = fe->icbTag.flags | ICBTAG_FLAG_AD_LONG;  //shortad的flag是0所以直接处理就行
				tmpTimes = stDir->datalen / 1073739776 + 1;
				tmpAd = (long_ad*) (fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr) ;
				for (int i = 0;i < tmpTimes; i++)
				{
					if (i+1 < tmpTimes) //说明不是最后一次
						tmpAd->extLength = 1073739776;
					else
						tmpAd->extLength = stDir->datalen % 1073739776;
					tmpAd->extLocation.logicalBlockNum = countfilenum.contentstartblkno + i*(524287); // 1073739776/DVDBLOCKS=524287
					fe->lengthAllocDescs = fe->lengthAllocDescs + sizeof(long_ad);
					tmpAd = tmpAd + 1; //指针加1会自动按照指针实际大小加长度
				}
				
			}
			else if (stDir->datalen > 1073739776)
			{
				int tmpTimes;
				tmpTimes = stDir->datalen / 1073739776 + 1;
				tmpSd = (short_ad*) (fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr) ;
				for (int i = 0;i < tmpTimes; i++)
				{
					if (i+1 < tmpTimes) //说明不是最后一次
						tmpSd->extLength = 1073739776;
					else
						tmpSd->extLength = stDir->datalen % 1073739776;
					tmpSd->extPosition = countfilenum.contentstartblkno + i*(524287); // 1073739776/DVDBLOCKS=524287
					fe->lengthAllocDescs = fe->lengthAllocDescs + sizeof(short_ad);
					tmpSd = tmpSd + 1; //指针加1会自动按照指针实际大小加长度
				}
			}
			else
			{
				tmpSd = (short_ad*) (fe->extendedAttrAndAllocDescs + fe->lengthExtendedAttr);
				tmpSd->extLength = stDir->datalen;
				tmpSd->extPosition = countfilenum.contentstartblkno;  //文件夹的"文件内容"
				fe->lengthAllocDescs = sizeof(short_ad); //对应1个short_ad的大小
			}

			countfilenum.contentstartblkno += fe->logicalBlocksRecorded; //这边是先用再加

			fe->descTag.descCRCLength = sizeof(struct fileEntry) + fe->lengthExtendedAttr + fe->lengthAllocDescs - sizeof(tag);
			fe->checkpoint = 1;
			
		//	logUdfInfo("[updateStNode] fe->descTag.descCRCLength = %d \n",fe->descTag.descCRCLength);
		//	logUdfInfo("[updateStNode] fe->logicalBlocksRecorded = %d \n",fe->logicalBlocksRecorded);
		//	logUdfInfo("[updateStNode] fe->icbTag.flags = %d \n",fe->icbTag.flags);
		//	logUdfInfo("[updateStNode] fe->icbTag.fileType = %d \n",fe->icbTag.fileType);
			setChecksum(fe);
		}

	}

	return 0;
}

int updateStNodeDirEx(struct stfiledir *stDir)
{
	//文件夹需要处理data和长度 所以在这里再处理一次 后序
//	struct fileEntry	*fe;
	struct extendedFileEntry *efe;
    struct fileIdentDesc *fid;
//    struct fileEntry	*parentDirFe;
	struct extendedFileEntry	*parentDireFe;
    short_ad		*tmpSd;
    
	fid = stDir->fid; 
	efe = stDir->efe; 
	if ( strcmp(stDir->name,".") != 0) //如果不是根目录
	{
		parentDireFe = (stDir->pdirfd)->efe;
		// if  short_ad
		tmpSd = (short_ad*) (parentDireFe->extendedAttrAndAllocDescs + parentDireFe->lengthExtendedAttr);
//		logUdfInfo("[updateStNodeDir] stDir->name = %s, fid->descTag.tagIdent == %d \n",stDir->name,fid->descTag.tagIdent);
		tmpSd->extLength += stDir->fidlen;
		//logPrintX(fid, stDir->fidlen);
		//保存到文件夹的data中
//		logUdfInfo("[updateStNodeDir] (stDir->pdirfd)->datalen = %d,stDir->fidlen = %d \n",
//		(stDir->pdirfd)->datalen,stDir->fidlen);
		memcpy((stDir->pdirfd)->data + (stDir->pdirfd)->datalen, fid, stDir->fidlen);
		(stDir->pdirfd)->datalen += stDir->fidlen;
		//if ((stDir->isDir == 1) && (strcmp(stDir->name,"..") != 0))
		//{
		//	logUdfInfo("[updateStNodeDir] isDir,name = %s  ,->datalen = %d \n",stDir->name,stDir->datalen);
		//	setChecksum(fe);
		//}
	}
	else
	{
//		logUdfInfo("[updateStNodeDir] isDir . ,->datalen = %d \n",stDir->datalen);
//		logPrintX(stDir->data, stDir->datalen);
		setChecksum(efe);
	}

	if (stDir->isDir) //是目录 处理一下informationLength
	{
//		logUdfInfo("[updateStNodeDir] isDir=1 ,name = %s ,->datalen = %d,fe->logicalBlocksRecorded = %d \n",stDir->name,stDir->datalen,fe->logicalBlocksRecorded);
		efe->informationLength = stDir->datalen;
		setChecksum(efe);
	}
	return 0;
}

int updateStNodeEx(struct stfiledir *stDir)
{
//	从根目录开始。把这个文件树填好fid和efe ，等待转换后写入镜像文件
//	先序
//	struct fileEntry	*fe;
	struct extendedFileEntry *efe;
	struct fileEntry	*parentDirFe;
    struct fileIdentDesc *fid;
    short_ad		*tmpSd;
	long_ad         *tmpAd;
    struct allocDescImpUse *tmpADIU;
    uint32_t recordBlocks;
    

	if (stDir->isDataRecorded)  //是记录过的文件 已经有efe和fid
	{
		fid = stDir->fid; //是记录过的文件 所以有这项
		efe = stDir->efe; //是记录过的文件 所以有这项
		
		if((strcmp(stDir->name,"..") == 0) && (fid->fileCharacteristics & FID_FILE_CHAR_PARENT) )
		{
			//是".."上级文件夹 当做普通文件处理不设置isDir位置
			fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno ;//因为刚处理完的文件夹的FE就是这个位置
			fid->icb.extLocation.partitionReferenceNum = 0;
			fid->descTag.tagLocation = stDir->pdirfd->feblock + 1;
			fid->descTag.tagSerialNum = 1;
			setChecksum(fid);
			//".."文件夹没有文件内容 FE指向上一个 处理结束
			return 0;
		}
		//接下来要处理文件内容
		//stDir->efe已经占用下一个block了
		if ( stDir->isDir == 1 ) //作为文件夹应该用掉两个连续的block ，1个是fe另一个是fe存的连续fid
		{
			if ( strcmp(stDir->name,".") != 0) //如果不是根目录 根文件夹没有fid所以没有这些处理内容
			{
				//改fid指向fe的位置
				countfilenum.writeblkno ++;
				fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno;
				fid->icb.extLocation.partitionReferenceNum = 0;
				fid->descTag.tagLocation = stDir->pdirfd->feblock + 1 + stDir->fidoffset / 2048;  //利用提前算出来的位置
				fid->descTag.tagSerialNum = 1;
				setChecksum(fid);
			}
		//	logUdfInfo("[updateStNode] recorded stDir->name = %s, stDir->fidlen = %d \n",stDir->name,stDir->fidlen);
			efe->descTag.tagLocation = countfilenum.writeblkno;  //每个FE的tag的tagLocation位置必须与之对应
			efe->descTag.tagSerialNum = 1;
			stDir->feblock = countfilenum.writeblkno;
			//目前只能处理short_ad
			efe->icbTag.flags = (efe->icbTag.flags & ~ICBTAG_FLAG_AD_MASK) | ICBTAG_FLAG_AD_SHORT;
			//改fe中指向文件内容的logical blocks num
			tmpSd = (short_ad*) (efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr);
			countfilenum.writeblkno ++; //TODO 根据文件数量也许是用掉多个block
			tmpSd->extPosition = countfilenum.writeblkno;  //文件夹的"文件内容"在下一个block
			//分配文件夹data大小从这datalen算出
			recordBlocks = ((stDir->datalen + 2047) & ~2047) >> 11; //提前计算的数据可能有误差
			efe->logicalBlocksRecorded = recordBlocks;
			countfilenum.writeblkno = countfilenum.writeblkno + recordBlocks - 1; //writeblkno跳过文件夹内容占用的空间 刚才++了所以这边-1
			tmpSd->extLength = 0; //等本层文件夹遍历完才知道真实长度
			stDir->datalen = 0;
			
			//每个文件夹的data空间被重新分配了
			if (stDir->data)
			{	
				free(stDir->data);
				stDir->data =(char*) calloc (recordBlocks * 2048 , 1);
			}
			else
				stDir->data =(char*) calloc (recordBlocks * 2048 , 1);
		
		}
		else  //处理文件
		{
			//改fid指向的fe的位置  fid不需要专门设置位置 ， 占用文件夹的文件内容位置 ！！！
			fid->descTag.tagLocation = stDir->pdirfd->feblock + stDir->fidoffset / 2048 + 1;
			fid->descTag.tagSerialNum = 1;
			countfilenum.writeblkno ++;
			fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno;
			fid->icb.extLocation.partitionReferenceNum = 0;
			stDir->feblock = countfilenum.writeblkno;
			efe->descTag.tagLocation = countfilenum.writeblkno;  //每个FE的tag的tagLocation位置必须与之对应
			efe->descTag.tagSerialNum = 1;
		//	logUdfInfo("[updateStNode] fe->logicalBlocksRecorded = %d \n",fe->logicalBlocksRecorded);
		//	logUdfInfo("[updateStNode] fe->icbTag.flags = %d \n",fe->icbTag.flags);
		//	logUdfInfo("[updateStNode] fe->icbTag.fileType = %d \n",fe->icbTag.fileType);
		//	logUdfInfo("[updateStNode] fid->descTag.descCRCLength = %d ,fid->fidlen = %d \n",fid->descTag.descCRCLength,stDir->fidlen);
		//	logUdfInfo("[updateStNode] fe->uniqueID = %d \n",fe->uniqueID);
			updateTimestamp(0,0);
			efe->accessTime = timeStamp;
			efe->modificationTime = timeStamp;
			efe->attrTime = timeStamp;
			efe->createTime = timeStamp;
			//已经存在的文件  文件内容短就在efe内 或者是在外部 均无需处理 

			setChecksum(fid);
			setChecksum(efe);
		}

	}
	else
	{ 	//需要生成新的fe和fid 确保写入的时候用的遍历方法和现在使用的方法完全一致 保证logicalblocks，物理blocks正确
		//填在哪个blocks ，可以用fe的extLength和extPosition来确定
		
		if(strcmp(stDir->name,"..") == 0) 
		{
		//".."文件夹没有文件内容 
			stDir->fid = makeFileIdentDesc("");
			fid = stDir->fid;
			stDir->fidlen = (sizeof(struct fileIdentDesc) + fid->lengthOfImpUse + fid->lengthFileIdent + 3) & ~3 ;
   			fid->fileCharacteristics = FID_FILE_CHAR_DIRECTORY | FID_FILE_CHAR_PARENT;
   			fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno ;//fe指向上一个位置的
			fid->descTag.tagLocation = stDir->pdirfd->feblock + 1;
			fid->descTag.tagSerialNum = 1;
			fid->descTag.descCRCLength = stDir->fidlen - sizeof(tag);
			setChecksum(fid);
			return 0;
		}
		
		if  ( stDir->isDir == 1 ) //处理新建的文件夹
		{
			stDir->efe = makeFileEntryEx();
			stDir->fid = makeFileIdentDesc(stDir->name);

   			fid = stDir->fid;
			efe = stDir->efe;
			if ( strcmp(stDir->name,".") != 0) //如果不是根目录 根文件夹没有fid所以没有这些处理内容
			{
				//改fid指向fe的位置
				++uniqueID;
				stDir->fidlen = (sizeof(struct fileIdentDesc) + fid->lengthOfImpUse + fid->lengthFileIdent + 3) & ~3 ;
				fid->fileCharacteristics = FID_FILE_CHAR_DIRECTORY;
				countfilenum.writeblkno ++;
				fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno ; //连贯存放fe的计算，之前文件夹的fe内容过长已经计算过了
				fid->descTag.tagLocation = stDir->pdirfd->feblock + stDir->fidoffset / 2048 + 1;  //对于fid来说是这样的虽然实际记录位置可能+2 +3
				fid->descTag.tagSerialNum = 1;
				fid->descTag.descCRCLength = stDir->fidlen - sizeof(tag);
				//处理 tmpADIU
				tmpADIU = fid->icb.impUse;
				tmpADIU->impUse[0] = uniqueID;
				setChecksum(fid);
			}
		//	logUdfInfo("[updateStNode] no recorded stDir->name = %s, stDir->fidlen = %d \n",stDir->name,stDir->fidlen);
			efe->descTag.tagLocation = countfilenum.writeblkno;  //每个FE的tag的tagLocation位置必须与之对应
			efe->descTag.tagSerialNum = 1;
			stDir->feblock = countfilenum.writeblkno;
			efe->uniqueID = 1;		
			efe->uid = 0xFFFFFFFF;
    		efe->gid = 0xFFFFFFFF;
    		efe->permissions = 0x35AD;
    		efe->fileLinkCount = 1;
    		efe->checkpoint = 1;
    		efe->lengthAllocDescs = sizeof(short_ad); //对应short_ad的大小
			efe->icbTag.fileType = ICBTAG_FILE_TYPE_DIRECTORY;
			//fe->icbTag.flags = fe->icbTag.flags | ICBTAG_FLAG_SORTED;
			tmpSd = (short_ad*) (efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr);
			countfilenum.writeblkno ++; //TODO 根据文件数量也许是用掉2个block
			tmpSd->extPosition = countfilenum.writeblkno;  //文件夹的"文件内容"在下一个block
			recordBlocks = ((stDir->datalen + 2047) & ~2047) >> 11; //提前计算的数据可能有误差
			efe->logicalBlocksRecorded = recordBlocks;
			countfilenum.writeblkno = countfilenum.writeblkno + recordBlocks - 1; //如果文件夹内容过长 需要
			tmpSd->extLength = 0; //等本层文件夹遍历完才知道真实长度
			stDir->datalen = 0;
			efe->descTag.descCRCLength = sizeof(struct fileEntry) + efe->lengthExtendedAttr + efe->lengthAllocDescs - sizeof(tag);
			if (stDir->data)
			{	
				free(stDir->data);
				stDir->data =(char*) calloc (recordBlocks * 2048 , 1);
			}
			else
				stDir->data =(char*) calloc (recordBlocks * 2048 , 1);
		}
		else //处理新建的文件
		{
			
			stDir->efe = makeFileEntryEx();
			stDir->fid = makeFileIdentDesc(stDir->name);
	
   			fid = stDir->fid;
			efe = stDir->efe;
			++uniqueID;
			//处理fid
			fid->descTag.tagLocation = stDir->pdirfd->feblock + stDir->fidoffset / 2048 + 1;
			fid->descTag.tagSerialNum = 1;
			countfilenum.writeblkno ++;
			fid->icb.extLocation.logicalBlockNum = countfilenum.writeblkno;
			
			stDir->fidlen = (sizeof(struct fileIdentDesc) + fid->lengthOfImpUse + fid->lengthFileIdent + 3) & ~3 ;
			fid->descTag.descCRCLength = stDir->fidlen - sizeof(tag);
		//	logUdfInfo("[updateStNode] fid->descTag.descCRCLength = %d ,fid->fidlen = %d \n",fid->descTag.descCRCLength,stDir->fidlen);
			//处理 tmpADIU
			tmpADIU = fid->icb.impUse;
			tmpADIU->impUse[0] = uniqueID;
			setChecksum(fid);
			//处理fe
			efe->descTag.tagLocation = countfilenum.writeblkno;  //每个FE的tag的tagLocation位置必须与之对应
			stDir->feblock = countfilenum.writeblkno;
			
			efe->uniqueID = uniqueID;
		//	logUdfInfo("[updateStNode] fe->uniqueID = %d \n",fe->uniqueID);
			efe->informationLength = stDir->datalen;
			efe->objectSize = stDir->datalen;
			updateFePermissionsEx(efe,stDir->path);
			// 注意 大于 1073739776 的文件需要多个Sd来储存
			// 注意 大于 4294959104 的文件需要多个Ad来储存
			if (stDir->datalen > 4294959104)
			{
				int tmpTimes;
				efe->icbTag.flags = efe->icbTag.flags | ICBTAG_FLAG_AD_LONG;  //shortad的flag是0所以直接处理就行
				tmpTimes = stDir->datalen / 1073739776 + 1;
				tmpAd = (long_ad*) (efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr) ;
				for (int i = 0;i < tmpTimes; i++)
				{
					if (i+1 < tmpTimes) //说明不是最后一次
						tmpAd->extLength = 1073739776;
					else
						tmpAd->extLength = stDir->datalen % 1073739776;
					tmpAd->extLocation.logicalBlockNum = countfilenum.contentstartblkno + i*(524287); // 1073739776/DVDBLOCKS=524287
					efe->lengthAllocDescs = efe->lengthAllocDescs + sizeof(long_ad);
					tmpAd = tmpAd + 1; //指针加1会自动按照指针实际大小加长度
				}
				
			}
			else if (stDir->datalen > 1073739776)
			{
				int tmpTimes;
				tmpTimes = stDir->datalen / 1073739776 + 1;
				tmpSd = (short_ad*) (efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr) ;
				for (int i = 0;i < tmpTimes; i++)
				{
					if (i+1 < tmpTimes) //说明不是最后一次
						tmpSd->extLength = 1073739776;
					else
						tmpSd->extLength = stDir->datalen % 1073739776;
					tmpSd->extPosition = countfilenum.contentstartblkno + i*(524287); // 1073739776/DVDBLOCKS=524287
					efe->lengthAllocDescs = efe->lengthAllocDescs + sizeof(short_ad);
					tmpSd = tmpSd + 1; //指针加1会自动按照指针实际大小加长度
				}
			}
			else
			{
				tmpSd = (short_ad*) (efe->extendedAttrAndAllocDescs + efe->lengthExtendedAttr);
				tmpSd->extLength = stDir->datalen;
				tmpSd->extPosition = countfilenum.contentstartblkno;  //文件夹的"文件内容"
				efe->lengthAllocDescs = sizeof(short_ad); //对应1个short_ad的大小
			}

			countfilenum.contentstartblkno += efe->logicalBlocksRecorded; //这边是先用再加

			efe->descTag.descCRCLength = sizeof(struct fileEntry) + efe->lengthExtendedAttr + efe->lengthAllocDescs - sizeof(tag);
			efe->checkpoint = 1;
			
		//	logUdfInfo("[updateStNode] fe->descTag.descCRCLength = %d \n",fe->descTag.descCRCLength);
		//	logUdfInfo("[updateStNode] fe->logicalBlocksRecorded = %d \n",fe->logicalBlocksRecorded);
		//	logUdfInfo("[updateStNode] fe->icbTag.flags = %d \n",fe->icbTag.flags);
		//	logUdfInfo("[updateStNode] fe->icbTag.fileType = %d \n",fe->icbTag.fileType);
			setChecksum(efe);
		}

	}

	return 0;
}

uint32_t countStNodeAddTagLocation(struct stfiledir *stDir)
{
	uint32_t addTagLocation;
	uint32_t offsetLocation = 0;
	if (stDir->rfd != NULL && stDir->rfd->fidoffset == 0)
	{
		stDir->rfd->fidoffset = stDir->fidlen + stDir->fidoffset;
	}
	addTagLocation = stDir->fidoffset / 2048;
	//if (addTagLocation > 0)
//	logUdfInfo("[countStNodeAddTagLocation]name = %s,fidlen = %d ,fidoffset = %d , addTagLocation = %d \n",stDir->name,stDir->fidlen,stDir->fidoffset,addTagLocation);
	return addTagLocation;
}
int countStNode(struct stfiledir *stDir)
{
	//先序
	if(strcmp(stDir->name,"..") == 0)
	{
		//".."文件夹没有文件内容 处理结束
		return 0;
	}
	usedBlockNum ++;
	if ( stDir->isDir == 1 )
	{
		usedBlockNum = usedBlockNum + ((stDir->datalen + 2047) & ~2047) >> 11;
	}
	else
	{
		if (stDir->isDataRecorded == 0)
		{
			usedBlockNum = usedBlockNum + ((stDir->datalen + 2047) & ~2047) >> 11;
		}
		
	}
	
	return 0;
}

int countUsedBlock()
{
	usedBlockNum = 0;
	reDirTreePre(stRootDir, &countStNode);
	return usedBlockNum;
}


